/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    ap.c

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/

#include "precomp.h"

UCHAR	ChalText[130] ={
	16,128,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf,
	0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xa,0xb,0xc,0xd,0xe,0xf
};

//-----------------------------------------------------------------------------
// Procedure:   AP_Initialize
//
// Description: 
//
// Arguments:

// Returns:    (none)
//-----------------------------------------------------------------------------

VOID
AP_Initialize(
                    IN PZD1205_ADAPTER Adapter,
                    IN BOOLEAN DebugPrint
                    )

{
	UCHAR		i;

    DEBUGFUNC(_T("AP_Initialize"));
    INITSTR((_T("\n")));

    // init the lists
	QueueInitList(&Adapter->MgtFreeList);
	QueueInitList(&Adapter->STAFreeList);
	QueueInitList(&Adapter->STAContextList);
    // Initialize the Multicast queueing pointers to NULL
    Adapter->FirstMulPendingQueue = (PNDIS_PACKET) NULL;
    Adapter->LastMulPendingQueue = (PNDIS_PACKET) NULL;
    Adapter->NumMulPendingQueued = 0;

	// Setup MgtFreeList
	for (i=0;i<TX_MGT_NUM;i++){
        QueuePutTail(&Adapter->MgtFreeList, &Adapter->TxMgtEntity[i].Link);
	}

	// Initialize STAContext
	for (i=0;i<MAX_AID;i++){
		Adapter->STA_Context[i].Adapter = Adapter;
		// Initialize the Multicast queueing pointers to NULL
		Adapter->STA_Context[i].FirstPendingQueue = (PNDIS_PACKET) NULL;
		Adapter->STA_Context[i].LastPendingQueue = (PNDIS_PACKET) NULL;
		Adapter->STA_Context[i].NumPendingQueued = 0;

		NdisMInitializeTimer(&Adapter->STA_Context[i].AgeTimer,
			Adapter->ZD1205AdapterHandle,
			(PNDIS_TIMER_FUNCTION) AP_AgeTimerFunction,
			(PVOID) &Adapter->STA_Context[i]);

		// Setup STAFreeList
        QueuePutTail(&Adapter->STAFreeList, &Adapter->STA_Context[i].Link);
	}
}

void
AP_CheckERP( IN PZD1205_ADAPTER	Adapter )
{	
    PSTA_CONTEXT    STAContextPtr;
    UCHAR           MixedMode = 0;
	UCHAR           BarkerMode = 0;

	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);

    if ( !STAContextPtr ){
	    Adapter->CardSetting.ERP[2] &= ~BIT_0;
		Adapter->CardSetting.ERP[2] &= ~BIT_2;
		Adapter->CardSetting.Capability |= 0x400;
		APMgt_SendNotification(Adapter, BIT_1);
		return;
	}

	while(STAContextPtr){

		if ( STAContextPtr->MixedMode )
            MixedMode = 1;

		if ( !(STAContextPtr->Capability & BIT_5) )
			BarkerMode = 1;

		// Get next
		STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList, &STAContextPtr->Link);
	}

	if ( !MixedMode )
	{
        Adapter->CardSetting.ERP[2] &= ~BIT_0;
		Adapter->CardSetting.Capability |= 0x400;
		APMgt_SendNotification(Adapter, BIT_1);
	}

	if ( !BarkerMode )
        Adapter->CardSetting.ERP[2] &= ~BIT_2;

}


void
AP_CompleteAllPendingPktsAndTimers(
                    IN PZD1205_ADAPTER Adapter,
                    ZD1211_IRQL        *pOldIrql
					)
{
	PNDIS_PACKET	QueuePacket;
	PSTA_CONTEXT	STAContextPtr;
    BOOLEAN			Cancelled;

	// Complete MulticastPending Queue
	while (Adapter->FirstMulPendingQueue){
		QueuePacket = Adapter->FirstMulPendingQueue;
        Adapter->NumMulPendingQueued--;
        DequeuePacket( Adapter->FirstMulPendingQueue, 
			           Adapter->LastMulPendingQueue
					   );
	    
		ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, *pOldIrql);
		NdisMSendComplete(
			Adapter->ZD1205AdapterHandle,
			QueuePacket,
			NDIS_STATUS_SUCCESS);
		ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, pOldIrql);
  	}
	// Complete STAContext.Pending Queue
	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		while (STAContextPtr->FirstPendingQueue){
			QueuePacket = STAContextPtr->FirstPendingQueue;
			STAContextPtr->NumPendingQueued--;
			DequeuePacket( STAContextPtr->FirstPendingQueue, 
						   STAContextPtr->LastPendingQueue
						   );
			
			//KeReleaseSpinLock(&Adapter->Lock, *pOldIrql);
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, *pOldIrql);
			NdisMSendComplete(
				Adapter->ZD1205AdapterHandle,
				QueuePacket,
				NDIS_STATUS_SUCCESS);
			//KeAcquireSpinLock(&Adapter->Lock, pOldIrql);
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, pOldIrql);
		}
		// Stop AgeTime
		NdisMCancelTimer(&STAContextPtr->AgeTimer,
			&Cancelled);		
		// Get next
		STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList, &STAContextPtr->Link);
	}
}

void
AP_CheckSTAsAlive(
		IN PZD1205_ADAPTER Adapter
		)
{
	PSTA_CONTEXT	STAContextPtr;
	PSTA_CONTEXT	NextSTAContextPtr;

	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		NextSTAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList,
													&STAContextPtr->Link);
		STAContextPtr->IdleTime++;
		if (STAContextPtr->IdleTime >= 2){
			AP_SnedNullDataCheckTxComplete(Adapter, STAContextPtr);
			if (STAContextPtr->IdleTime >= 4){
				AP_DisAssociateOneSTA(Adapter, STAContextPtr, REASON_NO_ACTIVITY);
			}
		}
		STAContextPtr = NextSTAContextPtr;
	}
}

/*++

Routine Description:
    
    Timer function for AP AgeTimer
    
Arguments:

    SystemSpecific1     Not used
    FunctionContext     Pointer to our adapter
    SystemSpecific2     Not used
    SystemSpecific3     Not used

Return Value:

    None
    
--*/
VOID 
AP_AgeTimerFunction(
    IN  PVOID	SystemSpecific1,
    IN  PVOID	FunctionContext,
    IN  PVOID	SystemSpecific2, 
    IN  PVOID	    SystemSpecific3
    )
{
	PSTA_CONTEXT	STAContextPtr = (PSTA_CONTEXT)FunctionContext;
	PZD1205_ADAPTER	Adapter= (PZD1205_ADAPTER)STAContextPtr->Adapter;
    NDIS_STATUS     Status;
	ZD1211_IRQL     OldIrql;
	PNDIS_PACKET    QueuePacket;

    DEBUGFUNC(_T("AP_AgeTimerFunction"));

	//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
	ZDDbg((_T("Get SpinLock\n")));
	ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
	if (STAContextPtr->LinkStatus == CONNECTED){
		if (STAContextPtr->PolledBySTA){
			STAContextPtr->PolledBySTA = FALSE;
			if (STAContextPtr->FirstPendingQueue){
				// Set Aging Timer 5 sec.
				NdisMSetTimer(&STAContextPtr->AgeTimer, 5000);
			}
		}
		else{
			while(STAContextPtr->FirstPendingQueue){
				QueuePacket = STAContextPtr->FirstPendingQueue;
				STAContextPtr->NumPendingQueued--;
				DequeuePacket( STAContextPtr->FirstPendingQueue, 
					           STAContextPtr->LastPendingQueue
							   );	
				if (Adapter->FirstTxQueue){
					Adapter->NumPacketsQueued++;
					EnqueuePacket( Adapter->FirstTxQueue, 
						           Adapter->LastTxQueue, 
						           QueuePacket
								   );
				}
				else{
					Status = SetupNextSend( Adapter, 
						                    QueuePacket, 
											DATA, 
						                    Adapter->CardSetting.EncryMode, 
											UPPER_NDIS, 
											NULL
											);
					
					if (Status == NDIS_STATUS_RESOURCES)
					{
						Adapter->NumPacketsQueued++;
						EnqueuePacket( Adapter->FirstTxQueue, 
							           Adapter->LastTxQueue, 
							           QueuePacket
									   );
					}
				}
			}
		}
	}
	else{
		FREEaSTAContext(Adapter, STAContextPtr);
	}
	//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
}

void
AP_UpdateATIMBitMap(
			IN PZD1205_ADAPTER Adapter
			)
{
	PSTA_CONTEXT	STAContextPtr;
	USHORT			quotient;
	USHORT			remainder;

	NdisZeroMemory(Adapter->atimBitMap, sizeof(Adapter->atimBitMap));
	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		if (STAContextPtr->FirstPendingQueue){
			quotient = (STAContextPtr->AID >> 3);
			remainder = (STAContextPtr->AID & 0x7);
			Adapter->atimBitMap[quotient] |= (0x1<<remainder);
		}
		STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList,
			&STAContextPtr->Link);
	}
}

void
AP_UpdateBeacon(IN PZD1205_ADAPTER Adapter)
{
	USHORT		index=0;
	UCHAR		Beacon[128];
	USHORT		i;
	USHORT		j;
	UCHAR		buf[256];
    DEBUGFUNC(_T("AP_UpdateBeacon"));

	Adapter->CardSetting.Capability &= ~BIT_1;
	Adapter->CardSetting.Capability |= BIT_0;

	/****************************************************/
	/* We generate a AP								*/
	/****************************************************/
	Adapter->ChosenBSS = 0xff;
	//Frame control
	Beacon[index++] = 0x80;	
	Beacon[index++] = 0x00;
	
	//Duration
	Beacon[index++] = 0x00;	
	Beacon[index++] = 0x00;
	
	//Address1
	for (j=0;j<6;j++){		
		Beacon[index++] = 0xff;	
	}
	//Address2
	for (j=0;j<6;j++){		
		Beacon[index++] = Adapter->AiNodeAddress[j];	
	}
	//Address3
	for (j=0;j<6;j++){		
		Beacon[index++] = Adapter->AiNodeAddress[j];	
	}
	UpdateBSSID(Adapter, &Beacon[index-6]);
	
	//Sequence control
	Beacon[index++] = 0x00;	
	Beacon[index++] = 0x00;
	
	//Timestamp
	for (j=0;j<8;j++){		
		Beacon[index++] = 0x00;
	}
	
	//BeaconInterval
	//Beacon[index++] = (UCHAR)Adapter->CardSetting.BeaconInterval;
	//Beacon[index++] = (UCHAR)(Adapter->CardSetting.BeaconInterval >> 8);
	Beacon[index++] = 0x64;
	Beacon[index++] = 0x00;
	UpdateBeaconInterval(Adapter, &Beacon[index-2]);
	
	//Capability
	if ( Adapter->CardSetting.EncryMode == NO_WEP )   // set the privacy bit
		Adapter->CardSetting.Capability &= 0xffef;
	else
		Adapter->CardSetting.Capability |= 0x0010;
	
	// Auto ( preambleMode ==3 ) -> default as long preamble
	if ( Adapter->preambleMode == 2 )                 // set the preamble bit
		Adapter->CardSetting.Capability |= 0x0020;    // short preamble
	else
		Adapter->CardSetting.Capability &= 0xffdf;    // long preamble;
	
	Beacon[index++] = (UCHAR)(Adapter->CardSetting.Capability);
	Beacon[index++] = (UCHAR)(Adapter->CardSetting.Capability>>8);
	
	//if (Adapter->CardSetting.Capability & BIT_5){ // Short Preamble
		//Adapter->CardSetting.PreambleType = 0x20;//jhlee
		//Adapter->CardSetting.Capability |= BIT_5;
	//}
	//else{
		//Adapter->CardSetting.PreambleType = 0x00;
		//Adapter->CardSetting.Capability &= ~BIT_5;
	//}

	//SSID
	if (Adapter->EnableHiddenSSID){
		Beacon[index++] = 0;	// SSID element ID
		Beacon[index++] = 0;	// SSID length
	}
	else{
		for (j=0;j<(Adapter->CardSetting.Info_SSID[1]+2);j++){
			Beacon[index++] = Adapter->CardSetting.Info_SSID[j];
		}
	}
	
	//Supported rates
	for (i=0;i<(Adapter->CardSetting.Info_SupportedRates[1]+2);i++){
		Beacon[index++] = Adapter->CardSetting.Info_SupportedRates[i];
	}
	UpdateSupportedRates(Adapter, &Beacon[index-i]);
		
	//DS parameter
	Beacon[index++] = 0x3;
	Beacon[index++] = 0x1;
	Beacon[index++] = (UCHAR)Adapter->CardSetting.Channel;
	
	//TIM parameter
	Adapter->bcstAnnounce = FALSE;
	if ((Adapter->mDtimCount == 0) && Adapter->FirstMulPendingQueue){
		Adapter->bcstAnnounce = TRUE;
	}	
		
	AP_UpdateATIMBitMap(Adapter);
	mkTim((Element*)buf, (TrafficMap_t *)Adapter->atimBitMap, Adapter->mDtimCount, 
			(UCHAR)Adapter->CardSetting.DTIMPeriod, 1, MAX_AID, Adapter->bcstAnnounce);
	for (j=0; j<buf[1]+2; j++)
		Beacon[index++] = buf[j];
	
#if	(defined(GCCK) && defined(OFDM))

	if ( (Adapter->IsUSB2_0) || (Adapter->busbswitch == 1))
	{
		//ERP info
		Beacon[index++] = Adapter->CardSetting.ERP[0];	//42
		Beacon[index++] = Adapter->CardSetting.ERP[1];
		Beacon[index++] = Adapter->CardSetting.ERP[2];
			
		// WIFI say OFDM can't support in Ad-hoc
		//OFDM support rate
		for (i=0;i<(Adapter->CardSetting.Info_ExtSupportedRates[1]+2);i++){
			Beacon[index++] = Adapter->CardSetting.Info_ExtSupportedRates[i];
		}
		UpdateSupportedRates(Adapter, &Beacon[index-i]);
	}
#endif		

	//CRC32
	for (j=0;j<4;j++){
		Beacon[index++] = 0x00;
	}

	//Beacon send AP
	UpdateBeaconInterval_Send(Adapter, index, 1, Beacon);
}

//make tim for beacon frame
void mkTim(Element *tim, TrafficMap_t *trf, UCHAR dtc, UCHAR dtp, USHORT aidLo, USHORT aidHi, BOOLEAN bc)
{
	int		i;
	UCHAR *map = (UCHAR*)trf->t;
	USHORT	N1=0;
	USHORT	N2=0;
	UCHAR	index = 0;
	
	tim->buf[0] = 5;
	tim->buf[2] = dtc;	
	tim->buf[3] = dtp;	
	
	// Calculate N1
	for (i=0;i<=(aidHi/8);i++){
		if (map[i] != 0){
			break;
		}
	}
	if (i>0){
		// N1 is the largest even number
		N1 = (USHORT)(i & ~BIT_0);
	}
	// Calculate N2
	for (i=(aidHi/8);i>=0;i--){
		if (map[i] != 0){
			break;
		}
	}
	if (i>0){
		N2 = (USHORT)i;
	}
	// Fill the content
	if (N2==0){
		tim->buf[4] = 0;
		tim->buf[5] = map[0];
		tim->buf[1] = 4;
	}
	else{
		tim->buf[4] = (UCHAR)N1;
		for (i=N1;i<=N2;i++){
			tim->buf[5+index++] = map[i];
		}
		tim->buf[1] = N2-N1+4;
	}

	if (bc){
		tim->buf[4] |= BIT_0;
	}
}

PSTA_CONTEXT
FindSTAContext(
		IN PZD1205_ADAPTER Adapter,
		PCHAR	pAddr
		)
{
	PSTA_CONTEXT	STAContextPtr;

	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		if (!memcmp(STAContextPtr->MacAddr, pAddr, 6)){
			// We find this Addr in STAContextList
			break;
		}
		STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList,
													&STAContextPtr->Link);
	}
	return STAContextPtr;
}

BOOLEAN
GETaAID(
		IN PZD1205_ADAPTER Adapter,
		PCHAR	paid
		)
{
	UCHAR	i;

	for (i=1;i<32;i++){
		if (!((Adapter->AID_RollTable >> i) & BIT_0)){
			break;
		}
	}
	if (i==32){
		return FALSE;
	}
	else{
		*(paid) = i;
		Adapter->AID_RollTable |= (0x1 << i);
		return TRUE;
	}
}

void
FREEaAID(
		IN PZD1205_ADAPTER Adapter,
		UCHAR	aid
		)
{
	Adapter->AID_RollTable &= ~(0x1<<aid);
}

PSTA_CONTEXT
GETaSTAContext(
		IN PZD1205_ADAPTER Adapter
		)
{
	UCHAR	aid;
	PSTA_CONTEXT	STAContextPtr;

	if (!GETaAID(Adapter, &aid)){
		return NULL;
	}
	STAContextPtr = (PSTA_CONTEXT)QueuePopHead(&Adapter->STAFreeList);
	if (!STAContextPtr){
		FREEaAID(Adapter, aid);
	}
	else{
		STAContextPtr->AID = aid;
	}
	return(STAContextPtr);
}

void
FREEaSTAContext(
		IN PZD1205_ADAPTER Adapter,
		PSTA_CONTEXT		STAContextPtr
		)
{
    BOOLEAN			Cancelled;
	PNDIS_PACKET	QueuePacket;

	// Stop AgeTimer
    NdisMCancelTimer(&STAContextPtr->AgeTimer,
        &Cancelled);
	// Free AID
	FREEaAID(Adapter, STAContextPtr->AID);
	// Complete the pending packets
	while (STAContextPtr->FirstPendingQueue){
		QueuePacket = STAContextPtr->FirstPendingQueue;
		STAContextPtr->NumPendingQueued--;
		DequeuePacket( STAContextPtr->FirstPendingQueue, 
			           STAContextPtr->LastPendingQueue
					   );
		
		//KeReleaseSpinLock(&Adapter->Lock, Adapter->OldIrql);
		NdisMSendComplete(
			Adapter->ZD1205AdapterHandle,
			QueuePacket,
			NDIS_STATUS_SUCCESS);
		//KeAcquireSpinLock(&Adapter->Lock, &Adapter->OldIrql);
	}
	// Remove STAContext
	QueueRemoveEntity(&Adapter->STAContextList, &STAContextPtr->Link);
	// Initialize STAContext Variables
	STAContextPtr->AID = 0;
	STAContextPtr->AuthStatus = UN_AUTHENTICATED;
	//STAContextPtr->ConsecutiveSuccessFrames = 0;
	//STAContextPtr->CurrentRate = 0;
	STAContextPtr->IdleTime = 0;
	STAContextPtr->LinkStatus = DIS_CONNECTED;
	// Put STAContext into STAFreeList
	QueuePutTail(&Adapter->STAFreeList, &STAContextPtr->Link);

	AP_CheckERP(Adapter); // update the ERP information in card settting
}

void
AP_SnedNullDataCheckTxComplete(
		IN PZD1205_ADAPTER	Adapter,
		PSTA_CONTEXT		STAContextPtr
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETH_HEADER_STRUC	pEthHdr;
    NDIS_STATUS			AllocationStatus;
	NDIS_STATUS			Status;
	USHORT				TypeLength;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;

	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	pEthHdr = (PETH_HEADER_STRUC)TxMgtEntityPtr->Content;

	// Set DestAddr
	memcpy(pEthHdr->Destination, STAContextPtr->MacAddr, 6);
	// Set Source Address
	memcpy(pEthHdr->Source, Adapter->AiNodeAddress, 6);

	TypeLength = 0;
	// Set TypeLen
	pEthHdr->TypeLength[0] = (UCHAR)(TypeLength>>8);
	pEthHdr->TypeLength[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEthHdr), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	if ( (Status = SetupNextSend(Adapter, Packet, DATA, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
	}

}

void
AP_SendAuthentication(
		IN PZD1205_ADAPTER	Adapter,
		PSTA_CONTEXT		STAContextPtr,
		USHORT		AuthType,
		USHORT		AuthSeq,
		USHORT		AuthSts,
		UCHAR		AuthChal
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETHER_AUTH_FRM		pEtherAuth;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;
    NDIS_STATUS			AllocationStatus;
	USHORT				TypeLength;
	NDIS_STATUS			Status;

    DEBUGFUNC(_T("AP_SendAuthentication"));

	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	INITSTR((_T("start sending auth\n")));
	pEtherAuth = (PETHER_AUTH_FRM)TxMgtEntityPtr->Content;

	// Set DestAddr
	memcpy(pEtherAuth->DestAddr, STAContextPtr->MacAddr, 6);
	// Set Source Address
	memcpy(pEtherAuth->SrcAddr, Adapter->AiNodeAddress, 6);
	// Set Algorithm
	pEtherAuth->Al_Num[0] = (UCHAR)AuthType;
	pEtherAuth->Al_Num[1] = (UCHAR)(AuthType>>8);
	// Set Sequence
	pEtherAuth->Trans_SeqNo[0] = (UCHAR)AuthSeq;
	pEtherAuth->Trans_SeqNo[1] = (UCHAR)(AuthSeq>>8);
	// Set Status
	pEtherAuth->Status[0] = (UCHAR)AuthSts;
	pEtherAuth->Status[1] = (UCHAR)(AuthSts>>8);

	if (AuthChal != CHALLENGE){
		TypeLength = 6;
	}
	else{
		memcpy(pEtherAuth->Challenge, ChalText, 130);
		TypeLength = 136;
	}
	// Set TypeLen
	pEtherAuth->TypeLen[0] = (UCHAR)(TypeLength>>8);
	pEtherAuth->TypeLen[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEtherAuth), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	INITSTR((_T("call SetupNextSend\n")));
	if ( (Status = SetupNextSend(Adapter, Packet, AUTHENTICATE, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
		INITSTR((_T("Out of NDIS_STATUS_RESOURCES\n")));
	}

}

void
AP_SendAssociationRsp(
		IN PZD1205_ADAPTER	Adapter,
		PSTA_CONTEXT		STAContextPtr,
		USHORT		AssoSts
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETHER_ASSORSP_FRM	pEtherAssoRsp;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;
    NDIS_STATUS			AllocationStatus;
	USHORT				TypeLength;
	NDIS_STATUS			Status;
   	PUCHAR              pExtendedSupportedRates;
	

	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	pEtherAssoRsp = (PETHER_ASSORSP_FRM)TxMgtEntityPtr->Content;

	// Set DestAddr
	memcpy(pEtherAssoRsp->DestAddr, STAContextPtr->MacAddr, 6);
	// Set Source Address
	memcpy(pEtherAssoRsp->SrcAddr, Adapter->AiNodeAddress, 6);
	// Set Capability
	pEtherAssoRsp->Capability[0] = (UCHAR)Adapter->CardSetting.Capability;
	pEtherAssoRsp->Capability[1] = (UCHAR)(Adapter->CardSetting.Capability>>8);
	// Set Status
	pEtherAssoRsp->Status[0] = (UCHAR)AssoSts;
	pEtherAssoRsp->Status[1] = (UCHAR)(AssoSts>>8);
	// Set AID
	pEtherAssoRsp->AID[0] = STAContextPtr->AID;
	pEtherAssoRsp->AID[1] = 0;
	// Set SupportedRates
	memcpy(pEtherAssoRsp->SupportedRates, Adapter->CardSetting.Info_SupportedRates,
				Adapter->CardSetting.Info_SupportedRates[1]+2);
	// Set Extended supported rates
	pExtendedSupportedRates = pEtherAssoRsp->SupportedRates + 
		                      Adapter->CardSetting.Info_SupportedRates[1] + 2;

	memcpy( pExtendedSupportedRates,
		    Adapter->CardSetting.Info_ExtSupportedRates,
			Adapter->CardSetting.Info_ExtSupportedRates[1] + 2
			);

	// Set TypeLength
	TypeLength = 6 + Adapter->CardSetting.Info_SupportedRates[1] + 2
		         + Adapter->CardSetting.Info_ExtSupportedRates[1] + 2;
		          
	pEtherAssoRsp->TypeLen[0] = (UCHAR)(TypeLength>>8);
	pEtherAssoRsp->TypeLen[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEtherAssoRsp), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	if ( (Status = SetupNextSend(Adapter, Packet, ASSOCIATE_RSP, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
	}

}

void
AP_SendReAssociationRsp(
		IN PZD1205_ADAPTER	Adapter,
		PSTA_CONTEXT		STAContextPtr,
		USHORT		AssoSts
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETHER_ASSORSP_FRM	pEtherAssoRsp;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;
    NDIS_STATUS			AllocationStatus;
	USHORT				TypeLength;
	NDIS_STATUS			Status;
   	PUCHAR              pExtendedSupportedRates;


	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	pEtherAssoRsp = (PETHER_ASSORSP_FRM)TxMgtEntityPtr->Content;

	// Set DestAddr
	memcpy(pEtherAssoRsp->DestAddr, STAContextPtr->MacAddr, 6);
	// Set Source Address
	memcpy(pEtherAssoRsp->SrcAddr, Adapter->AiNodeAddress, 6);
	// Set Capability
	pEtherAssoRsp->Capability[0] = (UCHAR)Adapter->CardSetting.Capability;
	pEtherAssoRsp->Capability[1] = (UCHAR)(Adapter->CardSetting.Capability>>8);
	// Set Status
	pEtherAssoRsp->Status[0] = (UCHAR)AssoSts;
	pEtherAssoRsp->Status[1] = (UCHAR)(AssoSts>>8);
	// Set AID
	pEtherAssoRsp->AID[0] = STAContextPtr->AID;
	pEtherAssoRsp->AID[1] = 0;
	// Set SupportedRates
	memcpy( pEtherAssoRsp->SupportedRates, 
		    Adapter->CardSetting.Info_SupportedRates,
			Adapter->CardSetting.Info_SupportedRates[1] + 2
			);
	// Set Extended supported rates
	pExtendedSupportedRates = pEtherAssoRsp->SupportedRates + 
		                      Adapter->CardSetting.Info_SupportedRates[1] + 2;

	memcpy( pExtendedSupportedRates,
		    Adapter->CardSetting.Info_ExtSupportedRates,
			Adapter->CardSetting.Info_ExtSupportedRates[1] + 2
			);

	// Set TypeLength
	TypeLength = 6 + Adapter->CardSetting.Info_SupportedRates[1] + 2
		         + Adapter->CardSetting.Info_ExtSupportedRates[1] + 2;

	pEtherAssoRsp->TypeLen[0] = (UCHAR)(TypeLength>>8);
	pEtherAssoRsp->TypeLen[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEtherAssoRsp), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	if ( (Status = SetupNextSend(Adapter, Packet, REASSOCIATE_RSP, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
	}

}

void
AP_SendDisAssociation(
		IN PZD1205_ADAPTER	Adapter,
		PUCHAR		pAddr1,
		USHORT		Reason
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETHER_DISASSO_FRM	pEtherDisAsso;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;
    NDIS_STATUS			AllocationStatus;
	USHORT				TypeLength;
	NDIS_STATUS			Status;

	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	pEtherDisAsso = (PETHER_DISASSO_FRM)TxMgtEntityPtr->Content;

	// Set DestAddr
	memcpy(pEtherDisAsso->DestAddr, pAddr1, 6);
	// Set Source Address
	memcpy(pEtherDisAsso->SrcAddr, Adapter->AiNodeAddress, 6);
	// Set Reason
	pEtherDisAsso->Reason[0] = (UCHAR)Reason;
	pEtherDisAsso->Reason[1] = (UCHAR)(Reason>>8);
	// Set TypeLength
	TypeLength = 2;
	pEtherDisAsso->TypeLen[0] = (UCHAR)(TypeLength>>8);
	pEtherDisAsso->TypeLen[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEtherDisAsso), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	if ( (Status = SetupNextSend(Adapter, Packet, DISASSOCIATION, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
	}
}

void
AP_SendProbeResponse(
		IN PZD1205_ADAPTER	Adapter,
		PWLAN_MANAGEMENT_FRM_HEADER_STRUC	pMgtFrm,
		IN ZD1211_IRQL *pOldIrql
		)
{
	PTX_MGT_ENTITY		TxMgtEntityPtr;
	PETH_HEADER_STRUC	pEtherHdr;
	PNDIS_PACKET		Packet;
	PNDIS_BUFFER		Buffer;
    NDIS_STATUS			AllocationStatus;
	USHORT				TypeLength;
	NDIS_STATUS			Status;
	USHORT				index=0;
	PUCHAR				FrmBody;
	ULONG				tmpvalue;
	USHORT				i;


	TxMgtEntityPtr = (PTX_MGT_ENTITY)QueuePopHead(&Adapter->MgtFreeList);
	if (!TxMgtEntityPtr){
		return;
	}

	pEtherHdr = (PETH_HEADER_STRUC)TxMgtEntityPtr->Content;
	FrmBody = (PUCHAR)pEtherHdr+14;

	// Set DestAddr
	memcpy(pEtherHdr->Destination, pMgtFrm->SA, 6);
	// Set Source Address
	memcpy(pEtherHdr->Source, Adapter->AiNodeAddress, 6);
	// Set Timestamp

	// Timestamp
#ifdef HOST_IF_USB
    //KeReleaseSpinLock(&Adapter->Lock, *pOldIrql);
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, *pOldIrql);
#endif

	ZD1205_READ_REGISTER(Adapter,TSF_LowPart, &tmpvalue);

#ifdef HOST_IF_USB
    //KeAcquireSpinLock(&Adapter->Lock, pOldIrql);
	ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, pOldIrql);
#endif

	FrmBody[index++] = (UCHAR)(tmpvalue);
	FrmBody[index++] = (UCHAR)(tmpvalue>>8);
	FrmBody[index++] = (UCHAR)(tmpvalue>>16);
	FrmBody[index++] = (UCHAR)(tmpvalue>>24);

#ifdef HOST_IF_USB
    //KeReleaseSpinLock(&Adapter->Lock, *pOldIrql);
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, *pOldIrql);
#endif

	ZD1205_READ_REGISTER(Adapter,TSF_HighPart, &tmpvalue);

#ifdef HOST_IF_USB
    //KeAcquireSpinLock(&Adapter->Lock, pOldIrql);
	ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, pOldIrql);
#endif

	FrmBody[index++] = (UCHAR)(tmpvalue);
	FrmBody[index++] = (UCHAR)(tmpvalue>>8);
	FrmBody[index++] = (UCHAR)(tmpvalue>>16);
	FrmBody[index++] = (UCHAR)(tmpvalue>>24);

	// Beacon Interval
	FrmBody[index++] = (UCHAR)(Adapter->CardSetting.BeaconInterval);
	FrmBody[index++] = (UCHAR)(Adapter->CardSetting.BeaconInterval>>8);

	// Capability
	FrmBody[index++] = (UCHAR)(Adapter->CardSetting.Capability);
	FrmBody[index++] = (UCHAR)(Adapter->CardSetting.Capability>>8);

	// SSID
	for (i=0;i<(Adapter->CardSetting.Info_SSID[1]+2);i++){
		FrmBody[index++] = Adapter->CardSetting.Info_SSID[i];
	}

	// Supported rates
	for (i=0;i<(Adapter->CardSetting.Info_SupportedRates[1]+2);i++){
		FrmBody[index++] = Adapter->CardSetting.Info_SupportedRates[i];
	}

	// DS Parameter Set
	FrmBody[index++] = 0x3;
	FrmBody[index++] = 0x1;
	FrmBody[index++] = (UCHAR)Adapter->CardSetting.Channel;

#if	(defined(GCCK) && defined(OFDM))

	if ( (Adapter->IsUSB2_0) || (Adapter->busbswitch == 1))
	{
		//ERP info
		FrmBody[index++] = Adapter->CardSetting.ERP[0];	//42
		FrmBody[index++] = Adapter->CardSetting.ERP[1];
		FrmBody[index++] = Adapter->CardSetting.ERP[2];
			
		// WIFI say OFDM can't support in Ad-hoc
		//OFDM support rate
		for (i=0;i<(Adapter->CardSetting.Info_ExtSupportedRates[1]+2);i++){
			FrmBody[index++] = Adapter->CardSetting.Info_ExtSupportedRates[i];
		}
	}
#endif		


	// Set TypeLength
	TypeLength = index;
	pEtherHdr->TypeLength[0] = (UCHAR)(TypeLength>>8);
	pEtherHdr->TypeLength[1] = (UCHAR)TypeLength;

	// Form a packet for authentication frame
	NdisAllocatePacket(&AllocationStatus,
			&Packet,
			Adapter->ReceivePacketPool);
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NDIS_SET_PACKET_HEADER_SIZE(Packet,	ETHERNET_HEADER_SIZE);

	NdisAllocateBuffer(&AllocationStatus,
				&Buffer,
				Adapter->ReceiveBufferPool,
				(PVOID)(pEtherHdr), 
				(UINT)(TypeLength+14));

	// probably should do some error handling here
	ASSERT(AllocationStatus == NDIS_STATUS_SUCCESS);
	NdisChainBufferAtBack(Packet, Buffer);

	// Call SetupNextSend procedure.
	if ( (Status = SetupNextSend(Adapter, Packet, PROBERESPONSE, 
						NO_CIPHER, AP_MGT, (PVOID)TxMgtEntityPtr)) ==
										NDIS_STATUS_RESOURCES ){

	    NdisFreeBuffer(Buffer);
	    NdisFreePacket(Packet);
		QueuePutTail(&Adapter->MgtFreeList, &TxMgtEntityPtr->Link);
	}

}

void
AP_DisAssociateOneSTA(
		IN PZD1205_ADAPTER Adapter,
		PSTA_CONTEXT		STAContextPtr,
		USHORT		Reason
		)
{
	AP_SendDisAssociation(Adapter, STAContextPtr->MacAddr, Reason);
	FREEaSTAContext(Adapter, STAContextPtr);
}

void
AP_DisAssociateAllSTAs(
		IN PZD1205_ADAPTER Adapter
		)
{
	PSTA_CONTEXT	STAContextPtr;

	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		AP_DisAssociateOneSTA(Adapter, STAContextPtr, REASON_AP_ABORT);
		// AP_DisAssociateOneSTA will remove STAContext from the STAContextList.
		STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	}

}

BOOLEAN
AP_ReportSTAsMacList(
		IN PZD1205_ADAPTER Adapter,
		PMAC_LIST_DATA		pMacListData,
		ULONG				BufLen
		)
{
	PSTA_CONTEXT	STAContextPtr;

	//ASSERT(BufLen >= (MAX_AID*sizeof(MAC_LIST_DATA)));
	//if (BufLen >= (MAX_AID*sizeof(MAC_LIST_DATA))){
	ASSERT(BufLen >= (16*sizeof(MAC_LIST_DATA)));
	if (BufLen >= (16*sizeof(MAC_LIST_DATA))){
		STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
		while(STAContextPtr){
			pMacListData->Valid = TRUE;
			memcpy(pMacListData->MAC_Addr, STAContextPtr->MacAddr, 6);
			pMacListData++;
			STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList,
				&STAContextPtr->Link);
		}
		return TRUE;
	}
	else{
		return FALSE;
	}
}

BOOLEAN
AP_AnySTAInPSMode(
		IN PZD1205_ADAPTER Adapter
		)
{
	PSTA_CONTEXT	STAContextPtr;

	STAContextPtr = (PSTA_CONTEXT)QueueGetHead(&Adapter->STAContextList);
	while(STAContextPtr){
		if (STAContextPtr->PSMode){
			return TRUE;
		}
		STAContextPtr = (PSTA_CONTEXT)QueueGetNext(&Adapter->STAContextList,
			&STAContextPtr->Link);
	}
	return FALSE;
}

BOOLEAN
AP_FilterMacAddr(
		IN PZD1205_ADAPTER Adapter,
		PUCHAR		pAddr
		)
{
	UCHAR	i;

	switch(Adapter->AP_MacAddrFilterMode){
	case DISABLE:
		return TRUE;
		break;
	case ACCEPT:
		//for(i=0;i<sizeof(Adapter->MACFilterListData);i++){
		for(i=0;i<16;i++){
			if (!Adapter->MACFilterListData[i].Valid){
				continue;
			}
			if (!memcmp(pAddr, Adapter->MACFilterListData[i].MAC_Addr, 6)){
				return TRUE;
			}
		}
		return FALSE;
		break;
	case REJECT:
		//for(i=0;i<sizeof(Adapter->MACFilterListData);i++){
		for(i=0;i<16;i++){
			if (!Adapter->MACFilterListData[i].Valid){
				continue;
			}
			if (!memcmp(pAddr, Adapter->MACFilterListData[i].MAC_Addr, 6)){
				return FALSE;
			}
		}
		return TRUE;
		break;
	default:
		ASSERT(0);
		return FALSE;
		break;
	}
}

void
AP_ProcessDisAssociation(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		)
{
	PWLAN_MANAGEMENT_FRM_HEADER_STRUC	pMgtFrm;
	PZD1205SwRfd				SwRfd;
	PSTA_CONTEXT	STAContextPtr;

	DEBUGFUNC(_T("AP_ProcessDisAssociation"));
    INITSTR((_T("\n")));

	SwRfd = (PZD1205SwRfd)QueueGetHead(
		&DefragEntityPtr->ElementList);
	pMgtFrm = (PWLAN_MANAGEMENT_FRM_HEADER_STRUC)&SwRfd->Rfd->RxBuffer;

	STAContextPtr = FindSTAContext(Adapter, pMgtFrm->SA);

	if (STAContextPtr){
		FREEaSTAContext(Adapter, STAContextPtr);
	}
}

void 
AP_ProcessProbeRequest(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr,
		IN ZD1211_IRQL *pOldIrql
		)
{
	PWLAN_MANAGEMENT_FRM_HEADER_STRUC	pMgtFrm;
	PZD1205SwRfd				SwRfd;
	PUCHAR						pSSID;

	DEBUGFUNC(_T("AP_ProcessProbeRequest"));
    INITSTR((_T("\n")));

	SwRfd = (PZD1205SwRfd)QueueGetHead(
		&DefragEntityPtr->ElementList);
	pMgtFrm = (PWLAN_MANAGEMENT_FRM_HEADER_STRUC)&SwRfd->Rfd->RxBuffer;
	pSSID = (PUCHAR)pMgtFrm+PLCP_HEADER_SIZE+MGT_FRM_HEADER_SIZE;

	if (!Adapter->EnableHiddenSSID){
		AP_SendProbeResponse(Adapter, pMgtFrm, pOldIrql);
	}
	else{
		if (!memcmp(pSSID, &Adapter->CardSetting.Info_SSID[0],
			Adapter->CardSetting.Info_SSID[1])){
			AP_SendProbeResponse(Adapter, pMgtFrm, pOldIrql);
		}
	}
}

void
AP_ProcessAuthen(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		)
{
	USHORT		authSeq;
	USHORT		authAlg;
	PWLAN_MANAGEMENT_FRM_HEADER_STRUC	pMgtFrm;
	PZD1205SwRfd				SwRfd;
	PSTA_CONTEXT	STAContextPtr;
	PUCHAR		pauthSeq;
	PUCHAR		pauthAlg;
	PUCHAR		pStatus;
	PUCHAR		pChallenge;

	DEBUGFUNC(_T("AP_ProcessAuthen"));
    //INITSTR((_T("\n")));

	SwRfd = (PZD1205SwRfd)QueueGetHead(
		&DefragEntityPtr->ElementList);
	pMgtFrm = (PWLAN_MANAGEMENT_FRM_HEADER_STRUC)&SwRfd->Rfd->RxBuffer;

    
	if (!AP_FilterMacAddr(Adapter, pMgtFrm->SA)){
		return;
	}

	if (pMgtFrm->FrameCtrl[1] & 0x40){	// WEP
		pauthAlg = (PUCHAR)pMgtFrm+PLCP_HEADER_SIZE+MGT_FRM_HEADER_SIZE+IV_SIZE;
	}
	else{
		pauthAlg = (PUCHAR)pMgtFrm+PLCP_HEADER_SIZE+MGT_FRM_HEADER_SIZE;
	}
	pauthSeq = pauthAlg+2;
	pStatus = pauthSeq+2;
	pChallenge = pStatus+2;

	authAlg = *(pauthAlg) + (*(pauthAlg+1)<<8);
	authSeq = *(pauthSeq) + (*(pauthSeq+1)<<8);
	STAContextPtr = FindSTAContext(Adapter, pMgtFrm->SA);
	switch (authSeq){
	case 1:
		if (!STAContextPtr){
			STAContextPtr = GETaSTAContext(Adapter);
			if (STAContextPtr){
				//INITSTR((_T("get a STAContextPtr\n")));
				QueuePutTail(&Adapter->STAContextList, &STAContextPtr->Link);
				memcpy(STAContextPtr->MacAddr, pMgtFrm->SA, 6);
				// Set Timeout 5 sec.
				NdisMSetTimer(&STAContextPtr->AgeTimer, 5000);
			}
			else{
				// No reaource
				break;
			}
		}
		if (authAlg == OPEN_SYSTEM){
			//INITSTR((_T("open system\n")));
			AP_SendAuthentication(Adapter, STAContextPtr, OPEN_SYSTEM, SEQ_2, AUTH_SUCCESS, !CHALLENGE);
			STAContextPtr->AuthStatus = AUTHENTICATED;
		}
		else if (authAlg == SHARED_KEY){
			AP_SendAuthentication(Adapter, STAContextPtr, SHARED_KEY, SEQ_2, AUTH_SUCCESS, CHALLENGE);
			STAContextPtr->AuthStatus = WAIT_CHAL_RSP;
		}
		break;
	case 3:
		if (!STAContextPtr){
			break;
		}
		if (STAContextPtr->AuthStatus != WAIT_CHAL_RSP){
			break;
		}

		if (!memcmp(ChalText, pChallenge, 130)){
			AP_SendAuthentication(Adapter, STAContextPtr, SHARED_KEY, SEQ_4, AUTH_SUCCESS, !CHALLENGE);
			STAContextPtr->AuthStatus = AUTHENTICATED;
		}
		else{
			AP_SendAuthentication(Adapter, STAContextPtr, SHARED_KEY, SEQ_4, AUTH_CHAL_FAIL, !CHALLENGE);
		}
		break;
	default:
		break;
	}

}

void
AP_ProcessAssociationReq(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		)
{
	PZD1205SwRfd	SwRfd;
	PSTA_CONTEXT	STAContextPtr;
	PUCHAR			pCapability;
	PUCHAR			pListenInterval;
	PUCHAR			pSSID;
	PUCHAR			pSupportedRates;
	PUCHAR          pExtendedSupportedRates;
	PWLAN_MANAGEMENT_FRM_HEADER_STRUC pMgtFrm;
	UCHAR			i, j, aid, tmpRate, a, b;
	UCHAR           max_rate = 0x02;
    BOOLEAN			Cancelled;
	UCHAR           SupportedRates[RATEARRAY_NUM];
	UCHAR           SupportedRatesCount = 0;
	USHORT          ReasonCode = ASSO_SUCCESS;
	USHORT          ExtRateLen;

	DEBUGFUNC(_T("AP_ProcessAssociationReq"));
    INITSTR((_T("\n")));

	SwRfd = (PZD1205SwRfd)QueueGetHead(
		&DefragEntityPtr->ElementList);

	pMgtFrm = (PWLAN_MANAGEMENT_FRM_HEADER_STRUC)SwRfd->Rfd->RxBuffer;
	pCapability = ((PUCHAR)pMgtFrm+PLCP_HEADER_SIZE+MGT_FRM_HEADER_SIZE);
	pListenInterval = pCapability+2;
	pSSID = pListenInterval+2;
	pSupportedRates = pSSID+(*(pSSID+1)+2);
	pExtendedSupportedRates = pSupportedRates+(*(pSupportedRates+1)+2);
	STAContextPtr = FindSTAContext(Adapter, pMgtFrm->SA);

    ExtRateLen = SwRfd->Rfd->RxBuffer + SwRfd->FrameLength - pExtendedSupportedRates 
		         - CRC32_SIZE - EXT_INFO_SIZE;

	if (!STAContextPtr){
		goto ASSO_Exit;
	}

	aid = STAContextPtr->AID;
    STAContextPtr->MixedMode = 1;

	if (STAContextPtr->AuthStatus != AUTHENTICATED){
		goto ASSO_Exit;
	}
	//++ Check Capability
	if (!(*(pCapability) & BIT_0)){ //Assure in ESS mode
		goto ASSO_Exit;
	}
	//--
	//++ Check SSID
    if ( *(pSSID+1) != Adapter->CardSetting.Info_SSID[1] )
		goto ASSO_Exit;

	if (memcmp(pSSID, Adapter->CardSetting.Info_SSID, Adapter->CardSetting.Info_SSID[1]+2)){
		goto ASSO_Exit;
	}
	//--
	//++ Update Info in  STAContext
	STAContextPtr->LinkStatus = CONNECTED;
    NdisMCancelTimer(&STAContextPtr->AgeTimer,
        &Cancelled);

	STAContextPtr->Capability = *pCapability + (*(pCapability+1) << 8);

    //++ check privacy bit
//	if ( ((STAContextPtr->Capability & BIT_4)&&(!(Adapter->CardSetting.Capability & BIT_4)))||
//		 ((!(STAContextPtr->Capability & BIT_4))&&(Adapter->CardSetting.Capability & BIT_4)))
	if ( (STAContextPtr->Capability & BIT_4)&&(!(Adapter->CardSetting.Capability & BIT_4)) )
        goto ASSO_Exit;

	for( i=0; i<*(pSupportedRates+1);i++){
		tmpRate = (*(pSupportedRates+2+i) & 0x7f);

		if(Adapter->busbswitch==0)//Use_G_Mode_in_Usb1.1 == disable  (Normal status)
			if ( (!Adapter->IsUSB2_0)&&(Rate_Convert(tmpRate, STAContextPtr->Capability) > 0x03) )
				break;

        SupportedRates[SupportedRatesCount++] = tmpRate;
		if ( tmpRate > max_rate )
			max_rate = tmpRate;
		
		Adapter->OppositeRateInfo[aid].RateArray[i] = Rate_Convert(tmpRate, STAContextPtr->Capability);
		//if ( *(pSupportedRates+2+i) & 0x80 )
		//	  BasicRates[BasicRatesCount++] = Adapter->OppositeRateInfo[aid].RateArray[i];
	}
   
	if ( (*pExtendedSupportedRates == 50)&&
		 ((Adapter->IsUSB2_0)||(Adapter->busbswitch==1))&&
		 (ExtRateLen)&&
		 (ExtRateLen > *(pExtendedSupportedRates+1)) )
	{ 
	    for( j=0; j<*(pExtendedSupportedRates+1);j++){

            tmpRate = (*(pExtendedSupportedRates+2+j) & 0x7f);
			SupportedRates[SupportedRatesCount++] = tmpRate;

			if ( (Rate_Convert(tmpRate, STAContextPtr->Capability) <= 6) &&
				 (Rate_Convert(tmpRate, STAContextPtr->Capability) >= 4))
			{
				// has rate about 12M, 9M ,6M
				// not to use these rate
				continue;
			}

		    if ( tmpRate > max_rate )
			    max_rate = tmpRate;

		    Adapter->OppositeRateInfo[aid].RateArray[i++] = Rate_Convert(tmpRate, STAContextPtr->Capability);			
		}
	}

	for ( j=0; j<i; j++ )
        if ( Adapter->OppositeRateInfo[aid].RateArray[j] > 3 ){
		    STAContextPtr->MixedMode = 0;
			break;
		}
		
    if ( Adapter->GOnlyMode )
	{
        for( a=0; a<Adapter->BasicRates[0]; a++ )
		{
		    for( b=0; b<SupportedRatesCount; b++ )
			    if ( Adapter->BasicRates[a+1] == SupportedRates[b] )
				    break;

		    if ( b == i )
			{
			    ReasonCode = ASSO_FAIL_RATE;
		        break;
			}
		}
	}

	if ( STAContextPtr->MixedMode == 1 ){
        Adapter->CardSetting.ERP[2] |= BIT_0;
	 	Adapter->CardSetting.ERP[2] |= BIT_1;		
		Adapter->CardSetting.Capability &= ~(0x400);
		APMgt_SendNotification(Adapter, BIT_0);
	}

	if ( !(STAContextPtr->Capability & BIT_5) ) // long preamble only
        Adapter->CardSetting.ERP[2] |= BIT_2;

    Adapter->OppositeRateInfo[aid].bJustRiseRate = FALSE;
	Adapter->OppositeRateInfo[aid].RateArrayCount = i;
	Adapter->OppositeRateInfo[aid].RiseCondition = 0;
	Adapter->OppositeRateInfo[aid].DownCondition = 0;
	SortRateArray(Adapter->OppositeRateInfo[aid].RateArray, Adapter->OppositeRateInfo[aid].RateArrayCount);
	Adapter->OppositeRateInfo[aid].MaxRate = i-1;
    Adapter->OppositeRateInfo[aid].CurrentRate = Adapter->OppositeRateInfo[aid].MaxRate;
    Adapter->OppositeRateInfo[aid].ConsecutiveSuccessFrames = 0;
	Adapter->OppositeRateInfo[aid].FailFrames = 0;
	//--

	AP_SendAssociationRsp(Adapter, STAContextPtr, ReasonCode);

    if ( ReasonCode != ASSO_SUCCESS )
        FREEaSTAContext(Adapter, STAContextPtr);
	else
		Mgt_SendNotification(Adapter, RQ_AP_INDICATE_BRIDGE);

ASSO_Exit:
	return;
}

void
AP_ProcessReAssociationReq(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		)
{
	PZD1205SwRfd	SwRfd;
	PSTA_CONTEXT	STAContextPtr;
	PUCHAR			pCapability;
	PUCHAR			pListenInterval;
	PUCHAR			pSSID;
	PUCHAR			pSupportedRates;
	PUCHAR          pExtendedSupportedRates;
	PWLAN_MANAGEMENT_FRM_HEADER_STRUC pMgtFrm;
	UCHAR			i, j, aid, tmpRate, a, b;
	UCHAR           max_rate = 0x02;
    BOOLEAN			Cancelled;
	UCHAR           SupportedRates[RATEARRAY_NUM];
	UCHAR           SupportedRatesCount = 0;
	USHORT          ReasonCode = ASSO_SUCCESS;
	USHORT          ExtRateLen;


	DEBUGFUNC(_T("AP_ProcessReAssociationReq"));
    INITSTR((_T("\n")));

	SwRfd = (PZD1205SwRfd)QueueGetHead(
		&DefragEntityPtr->ElementList);

	pMgtFrm = (PWLAN_MANAGEMENT_FRM_HEADER_STRUC)SwRfd->Rfd->RxBuffer;
	pCapability = ((PUCHAR)pMgtFrm+PLCP_HEADER_SIZE+MGT_FRM_HEADER_SIZE);
	pListenInterval = pCapability+2;
	pSSID = pListenInterval+2+6;  // The ReAssociation contains the current AP address
	pSupportedRates = pSSID+(*(pSSID+1)+2);
	pExtendedSupportedRates = pSupportedRates+(*(pSupportedRates+1)+2);
	STAContextPtr = FindSTAContext(Adapter, pMgtFrm->SA);

    ExtRateLen = SwRfd->Rfd->RxBuffer + SwRfd->FrameLength - pExtendedSupportedRates 
		         - CRC32_SIZE - EXT_INFO_SIZE;
	
	if (!STAContextPtr){
		goto ASSO_Exit;
	}

    aid = STAContextPtr->AID;
    STAContextPtr->MixedMode = 1;

	if (STAContextPtr->AuthStatus != AUTHENTICATED){
		goto ASSO_Exit;
	}
	//++ Check Capability
	if (!(*(pCapability) & BIT_0)){ //Assure in ESS mode
		goto ASSO_Exit;
	}
	//--
	//++ Check SSID
    if ( *(pSSID+1) != Adapter->CardSetting.Info_SSID[1] )
		goto ASSO_Exit;

	if (memcmp(pSSID, Adapter->CardSetting.Info_SSID, Adapter->CardSetting.Info_SSID[1]+2)){
		goto ASSO_Exit;
	}
	//--
	//++ Update Info in  STAContext
	STAContextPtr->LinkStatus = CONNECTED;
    NdisMCancelTimer(&STAContextPtr->AgeTimer,
        &Cancelled);

	STAContextPtr->Capability = *pCapability + (*(pCapability+1) << 8);

    //++ check privacy bit
//	if ( ((STAContextPtr->Capability & BIT_4)&&(!(Adapter->CardSetting.Capability & BIT_4)))||
//		 ((!(STAContextPtr->Capability & BIT_4))&&(Adapter->CardSetting.Capability & BIT_4)))
	if ( (STAContextPtr->Capability & BIT_4)&&(!(Adapter->CardSetting.Capability & BIT_4)) )
        goto ASSO_Exit;
	
	for( i=0; i<*(pSupportedRates+1);i++){
		tmpRate = (*(pSupportedRates+2+i) & 0x7f);

		if(Adapter->busbswitch==0)//Use_G_Mode_in_Usb1.1 == disable  (Normal status)
			if ( (!Adapter->IsUSB2_0)&&(Rate_Convert(tmpRate, STAContextPtr->Capability) > 0x03) )
				break;

        SupportedRates[SupportedRatesCount++] = tmpRate;

		if ( tmpRate > max_rate )
			max_rate = tmpRate;
		
		Adapter->OppositeRateInfo[aid].RateArray[i] = Rate_Convert(tmpRate, STAContextPtr->Capability);
	}
   
	if ( (*pExtendedSupportedRates == 50)&&
		 ((Adapter->IsUSB2_0)||(Adapter->busbswitch==1))&&
		 (ExtRateLen)&&
		 (ExtRateLen > *(pExtendedSupportedRates+1)) )
	{ 
	    for( j=0; j<*(pExtendedSupportedRates+1);j++){

            tmpRate = (*(pExtendedSupportedRates+2+j) & 0x7f);
			SupportedRates[SupportedRatesCount++] = tmpRate;

			if ( (Rate_Convert(tmpRate, STAContextPtr->Capability) <= 6) &&
				 (Rate_Convert(tmpRate, STAContextPtr->Capability) >= 4))
			{
				// has rate about 12M, 9M ,6M
				// not to use these rate
				continue;
			}

		    if ( tmpRate > max_rate )
			    max_rate = tmpRate;
            
		    Adapter->OppositeRateInfo[aid].RateArray[i++] = Rate_Convert(tmpRate, STAContextPtr->Capability);			
		}
	}

 	for ( j=0; j<i; j++ )
        if ( Adapter->OppositeRateInfo[aid].RateArray[j] > 3 ){
		    STAContextPtr->MixedMode = 0;
			break;
		}   
	
	if ( Adapter->GOnlyMode )
	{
        for( a=0; a<Adapter->BasicRates[0]; a++ )
		{
		    for( b=0; b<SupportedRatesCount; b++ )
		        if ( Adapter->BasicRates[a+1] == SupportedRates[b] )
				    break;
		    if ( b == i )
			{
			    ReasonCode = ASSO_FAIL_RATE;
		        break;
			}
		}
	}

	if ( STAContextPtr->MixedMode == 1 ){
        Adapter->CardSetting.ERP[2] |= BIT_0;
	 	Adapter->CardSetting.ERP[2] |= BIT_1;		
		Adapter->CardSetting.Capability &= ~(0x400);
		APMgt_SendNotification(Adapter, BIT_0);
	}

	if ( !(STAContextPtr->Capability & BIT_5) ) // long preamble only
        Adapter->CardSetting.ERP[2] |= BIT_2;

    Adapter->OppositeRateInfo[aid].bJustRiseRate = FALSE;
	Adapter->OppositeRateInfo[aid].RateArrayCount = i;
	Adapter->OppositeRateInfo[aid].RiseCondition = 0;
	Adapter->OppositeRateInfo[aid].DownCondition = 0;
	SortRateArray(Adapter->OppositeRateInfo[aid].RateArray, Adapter->OppositeRateInfo[aid].RateArrayCount);
	Adapter->OppositeRateInfo[aid].MaxRate = i-1;
    Adapter->OppositeRateInfo[aid].CurrentRate = Adapter->OppositeRateInfo[aid].MaxRate;
    Adapter->OppositeRateInfo[aid].ConsecutiveSuccessFrames = 0;
	Adapter->OppositeRateInfo[aid].FailFrames = 0;
	//--

	AP_SendReAssociationRsp(Adapter, STAContextPtr, ReasonCode);

    if ( ReasonCode != ASSO_SUCCESS )
        FREEaSTAContext(Adapter, STAContextPtr);        
	else
		Mgt_SendNotification(Adapter, RQ_AP_INDICATE_BRIDGE);

ASSO_Exit:
	return;
}

void
AP_ProcessEvents(
					IN PZD1205_ADAPTER Adapter
					)
{
	PZD1205_DEFRAG_ENTITY		DefragEntityPtr = NULL;
	ULONG			tmpvalue;
	ULONG			FrmType;
    ZD1211_IRQL     OldIrql;
	PSTA_CONTEXT	STAContextPtr;
	ULONG           ulStatusBuffer;

	DEBUGFUNC(_T("AP_ProcessEvents"));
    //INITSTR((_T("start\n")));

	while(1){	
 
		if ( Adapter->CardSetting.BSSType != AP_BSS )
			break;

		// Process RQ_TERMINATION
		if (Adapter->Notification & RQ_TERMINATION){
			INITSTR((_T("Terminate ZD1205 thread now..\n")));
			Adapter->h_ZD1205MgtThread = NULL;
			Adapter->Notification &= ~RQ_TERMINATION;
#ifdef HOST_IF_USB
			USB_CompleteCountDecrement(Adapter);
#endif
			//PsTerminateSystemThread(STATUS_SUCCESS);
			ExitThread(0);
		}
		// set OID_802_11_CONFIGURATION
		else if ( Adapter->Notification & RQ_SET_OID ){
			Adapter->Notification &= ~RQ_SET_OID;
			{	// update beacon
				UCHAR	BcnInterval[2];	// convert to as network 

				BcnInterval[0] = (UCHAR)(Adapter->BeaconInterval);
				BcnInterval[1] = (UCHAR)(Adapter->BeaconInterval >> 8);

				UpdateBeaconInterval(Adapter, BcnInterval);
			}
			{	// update ATIMWindow
				UCHAR	ATIMWindow[2];	// convert to as network 

				ATIMWindow[0] = (UCHAR)(Adapter->ATIMWindow);
				ATIMWindow[1] = (UCHAR)(Adapter->ATIMWindow >> 8);
			
				UpdateATIMWindow(Adapter, ATIMWindow);
			}
			// update channel
		    Set_RF_Channel(Adapter, Adapter->SaveChannel, (UCHAR)Adapter->RF_Mode, 1);  			    
		}
		// Process RQ_CONNECTNETWORK
		else if (Adapter->Notification & RQ_CONNECTNETWORK){
			INITSTR((_T("RQ_CONNECTNETWORK\n")));
			Adapter->Notification &= ~RQ_CONNECTNETWORK;
		    tmpvalue = Adapter->CardSetting.BeaconInterval;
		    
			if (Adapter->CardSetting.DTIMPeriod == 0)
			    Adapter->CardSetting.DTIMPeriod = 3;
		
		    tmpvalue |= (Adapter->CardSetting.DTIMPeriod << 16);
		    tmpvalue |= BIT_24;	// Set AP mode
		    tmpvalue &= ~BIT_27; // Do not Enable DTIM Notify.
		    ZD1205_WRITE_REGISTER(Adapter, BCNInterval, tmpvalue);
		    // Prepare beacon now, so that CfgNextBcn will not be blocked
		    // due to BCNFIFO not ready.
#ifdef HOST_IF_USB
            Mgt_SendNotification(Adapter, RQ_AP_UPDATEBEACON);
	        //KeReleaseSpinLock(&Adapter->Lock, OldIrql);
#else
		    AP_UpdateBeacon(Adapter);
	        //KeSetEvent(&Adapter->BeaconUpdateLockEvent, IO_NO_INCREMENT, FALSE);
#endif
        //JWEI 2004/02/09
        //    ZD1205_WRITE_REGISTER(Adapter, LED1, 0x1);
            iLED_ON(Adapter, Adapter->LinkLEDn);
            ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, CAM_AP);  // AP mode

			if ( (Adapter->IsUSB2_0) || (Adapter->busbswitch == 1))
			{
			    Adapter->CardSetting.LastSentTxRate = 0xb; // the default is 54M
			    Adapter->CardSetting.LastSentRxRate = 0xb; // the default is 54M
			}
			else
			{
			    Adapter->CardSetting.LastSentTxRate = 0x3; // the default is 11M
			    Adapter->CardSetting.LastSentRxRate = 0x3; // the default is 11M
			}

			Adapter->adapterReady = TRUE;
			ClearOppositeRateInfo(Adapter);
			Adapter->CheckBeacon = 1;
			//Adapter->BSS_Members = 0;
			NdisMIndicateStatus(Adapter->ZD1205AdapterHandle,
				NDIS_STATUS_MEDIA_CONNECT,
				NULL,     // Not used.
				0);                 // Not used.
			NdisMIndicateStatusComplete(Adapter->ZD1205AdapterHandle);
		}
		// Process RQ_AP_DISASSOCIATE_ALL
		else if (Adapter->Notification & RQ_AP_DISASSOCIATE_ALL){
			Adapter->Notification &= ~RQ_AP_DISASSOCIATE_ALL;
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
			AP_DisAssociateAllSTAs(Adapter);
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
		}
		// remove a STA
		else if (Adapter->Notification & RQ_AP_FREE_A_STA){
			Adapter->Notification &= ~RQ_AP_FREE_A_STA;
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
			STAContextPtr = FindSTAContext(Adapter, Adapter->DelMac);
			FREEaSTAContext(Adapter, STAContextPtr);
            //KeReleaseSpinLock(&Adapter->Lock, OldIrql);
            ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);

			NdisMIndicateStatus(Adapter->ZD1205AdapterHandle,
				NDIS_STATUS_MEDIA_SPECIFIC_INDICATION,
				&ulStatusBuffer,     
				sizeof(ulStatusBuffer));                 
			NdisMIndicateStatusComplete(Adapter->ZD1205AdapterHandle);
		}
		// indicate a status to the bridge when any STA is 
		// associated or removed
		else if (Adapter->Notification & RQ_AP_INDICATE_BRIDGE){
			Adapter->Notification &= ~RQ_AP_INDICATE_BRIDGE;
			NdisMIndicateStatus(Adapter->ZD1205AdapterHandle,
				NDIS_STATUS_MEDIA_SPECIFIC_INDICATION,
				&ulStatusBuffer,     
				sizeof(ulStatusBuffer));                 
			NdisMIndicateStatusComplete(Adapter->ZD1205AdapterHandle);
		}
		// Process received management frame
		else if ( Mgt_RetrieveQueue(Adapter, &DefragEntityPtr) ){
			//INITSTR((_T("Mgt_RetrieveQueue\n")));
			if (QueueGetCount(&DefragEntityPtr->ElementList) == 1){					
				FrmType = ParseRxMgtFrame(Adapter, DefragEntityPtr);

				// Atomic operation
				//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
				ZDDbg((_T("Get SpinLock\n")));
				ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
				switch(FrmType){
				case DEAUTHENTICATION:
				case DISASSOCIATION:
					AP_ProcessDisAssociation(Adapter, DefragEntityPtr);
					break;
				case PROBEREQUEST:
					AP_ProcessProbeRequest(Adapter, DefragEntityPtr, &OldIrql);
					break;
				//case AUTHENTICATE:
					//AP_ProcessAuthen(Adapter, DefragEntityPtr);
					//break;
				//case ASSOCIATE:
					//AP_ProcessAssociationReq(Adapter, DefragEntityPtr);
					//break;
				//case REASSOCIATE_REQ:
				//	AP_ProcessReAssociationReq(Adapter, DefragEntityPtr);
				//	break;
				default:
					break;
				}				
			    //KeReleaseSpinLock(&Adapter->Lock, OldIrql);				
				ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
			}
			GetReturnedMgtFrame(Adapter, DefragEntityPtr);

		}
		// Process RQ_AP_UPDATEBEACON
		else if (Adapter->Notification & RQ_AP_UPDATEBEACON){
			Adapter->Notification &= ~RQ_AP_UPDATEBEACON;
			AP_UpdateBeacon(Adapter);
		}
		// We have processed all possible events, go to wait event now.
		else{
			// Clear undesired events.
			Adapter->Notification = 0;
			break;
		}
	}
}

void
AP_ForwardMulticastPkt(
			IN PZD1205_ADAPTER Adapter,
			PNDIS_PACKET	Packet,
			PETH_HEADER_STRUC	pEthHdr
			)
{
    NDIS_STATUS         Status;

	DEBUGFUNC(_T("AP_ForwardMulticastPkt"));
	// SetupNextSend (with provider = AP_FORWARD_MUL) copies the content of
	// this packet to Coalesce buffer.
	/*if (Adapter->aSTAInPSMode){
		Adapter->NumMulPendingQueued ++;
	    EnqueuePacket( Adapter->FirstMulPendingQueue, 
					   Adapter->LastMulPendingQueue, 
					   Packet);
		NDIS_SET_PACKET_STATUS(Packet, NDIS_STATUS_SUCCESS);
	}else*/ if ( (Status = SetupNextSend(Adapter, Packet, DATA, 
				Adapter->CardSetting.EncryMode, AP_FORWARD_MUL, NULL)) ==
			    NDIS_STATUS_RESOURCES ){
		Adapter->ForwardingLoss_Mul++;
		// Do not free this packet, we need to report it to upper NDIS
		// later.
	}
	return;
}

BOOLEAN
AP_ForwardUnicastPkt(
			IN PZD1205_ADAPTER Adapter,
			PNDIS_PACKET	Packet,
			PETH_HEADER_STRUC	pEthHdr
			)
{
    NDIS_STATUS         Status;
	PSTA_CONTEXT		STAContextPtr;

	DEBUGFUNC(_T("AP_ForwardUnicastPkt"));
    //INITSTR((_T("\n")));

    //INITSTR((_T("PZD1205_RESERVED_FROM_PACKET = %x\n"), PZD1205_RESERVED_FROM_PACKET(Packet)));
    //INITSTR((_T("PZD1205_RESERVED_2_FROM_PACKET = %x\n"), PZD1205_RESERVED_2_FROM_PACKET(Packet)));

	STAContextPtr = FindSTAContext(Adapter, pEthHdr->Destination);
	if (!STAContextPtr){
		return FALSE;
	}

	if (STAContextPtr->LinkStatus != CONNECTED){
		return FALSE;
	}

	if (STAContextPtr->PSMode){
		//STAContextPtr->UniQCount++;
		if (!STAContextPtr->FirstPendingQueue){
			// Set Aging Timer 5 sec.
			NdisMSetTimer(&STAContextPtr->AgeTimer, 5000);
		}
		
		STAContextPtr->NumPendingQueued++;
		EnqueuePacket( STAContextPtr->FirstPendingQueue, 
		               STAContextPtr->LastPendingQueue, 
	                   Packet);
		NDIS_SET_PACKET_STATUS(Packet, NDIS_STATUS_SUCCESS);
	}else if ( (Status = SetupNextSend(Adapter, Packet, DATA, 
				               Adapter->CardSetting.EncryMode, AP_FORWARD_UNI, NULL)) ==
			                   NDIS_STATUS_RESOURCES ){

		Adapter->ForwardingLoss_Uni ++;

		return FALSE;
	}

	return TRUE;
}

BOOLEAN
AP_CheckForward(
			IN PZD1205_ADAPTER Adapter,
			PETH_HEADER_STRUC	pEthHdr
			)
{
	PSTA_CONTEXT	STAContextPtr;

	STAContextPtr = FindSTAContext(Adapter, pEthHdr->Destination);
	if (STAContextPtr){
		return TRUE;
	}
	else{
		return FALSE;
	}
}
/*
//-----------------------------------------------------------------------------
// Procedure:   ZD1205APMgtThread
//
// Description: 
//				Adapter - Ptr to the Adapter structure
//
// Arguments:
//
// Returns:     (none)
//-----------------------------------------------------------------------------
ULONG    
ZD1211APMgtThread(IN PZD1205_ADAPTER Adapter)
{

    PZD1205_DEFRAG_ENTITY		DefragEntityPtr = NULL;
	ULONG		    tmpvalue;
	ZD1211_IRQL		OldIrql;
	
	DEBUGFUNC(_T("ZD1211APMgtThread"));
    INITSTR((_T("\n")));


    while(1)
	{
#ifndef CE_ALL
		KeWaitForSingleObject(&Adapter->AP_MgtEvent, Executive, KernelMode,
								FALSE, NULL);
		KeClearEvent(&Adapter->AP_MgtEvent);
#else
		WaitForSingleObject(Adapter->AP_MgtEvent, INFINITE);
		ResetEvent(Adapter->AP_MgtEvent);
#endif

		if (Adapter->FlagAccessRegister & BIT_31)
		{
			INITSTR((_T("Terminate ZD1211 APMgt thread now..\n")));
			Adapter->h_ZD1211APMgtThread = NULL;
#ifdef HOST_IF_USB
			USB_CompleteCountDecrement(Adapter);
#endif
			//PsTerminateSystemThread(STATUS_SUCCESS);
			ExitThread(0);
		}


	    if ( Adapter->FlagAccessRegister & BIT_0 )
		{
            Adapter->FlagAccessRegister &= ~BIT_0;
			if (Adapter->RF_Mode == AL2230_RF ||
				Adapter->RF_Mode == AL2210_RF)
			{
				ZD1205_WRITE_REGISTER(Adapter,IFS_Value, 0xA47c032);
			}
			else
			{
				ZD1205_WRITE_REGISTER(Adapter,IFS_Value, 0x547c032);
			}
		}

		if ( Adapter->FlagAccessRegister & BIT_1 )
		{
		    Adapter->FlagAccessRegister &= ~BIT_1;
			if (Adapter->RF_Mode == AL2230_RF ||
				Adapter->RF_Mode == AL2210_RF)
			{
				ZD1205_WRITE_REGISTER(Adapter,IFS_Value, 0xA47c00a);
			}
			else
			{
				ZD1205_WRITE_REGISTER(Adapter,IFS_Value, 0x547c00a);
			}
		}

		if ( Adapter->FlagAccessRegister & BIT_2 )
		{
		    Adapter->FlagAccessRegister &= ~BIT_2;
#ifndef HOST_IF_USB
	        //KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
#else
#ifndef CE_ALL
	        //protect BeaconUpdate
	        KeWaitForSingleObject(  &Adapter->BeaconUpdateLockEvent, 
							Executive, 
							KernelMode, 
							FALSE, 
							NULL
							);      
#else  // CE_ALL
			WaitForSingleObject(Adapter->BeaconUpdateLockEvent, INFINITE);
#endif // CE_ALL

#endif
			tmpvalue = 0;
		    ZD1205_READ_REGISTER(Adapter,BCNInterval, &tmpvalue);
		    tmpvalue &= 0xFFFF0000;
		    tmpvalue |= Adapter->CardSetting.BeaconInterval;
		    tmpvalue |= (Adapter->CardSetting.DTIMPeriod << 16);
		    ZD1205_WRITE_REGISTER(Adapter, BCNInterval, tmpvalue);

#ifndef HOST_IF_USB
	        //KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
#else
#ifndef CE_ALL
	        KeSetEvent(&Adapter->BeaconUpdateLockEvent, IO_NO_INCREMENT, FALSE);
#else  // CE_ALL
            SetEvent(Adapter->BeaconUpdateLockEvent);
#endif  // CE_ALL
#endif
		}

		if ( Adapter->FlagAccessRegister & BIT_3 )
		{
		    Adapter->FlagAccessRegister &= ~BIT_3;
	        ZD1205_WRITE_REGISTER(Adapter,CWmin_CWmax, Adapter->CWmin_CWmax_NormalSlot);
 
		}

		if ( Adapter->FlagAccessRegister & BIT_4 )
		{
		    Adapter->FlagAccessRegister &= ~BIT_4;
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
			AP_CompleteAllPendingPktsAndTimers(Adapter, &OldIrql);
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
		}

		if ( Adapter->FlagAccessRegister & BIT_5 )
		{
		    Adapter->FlagAccessRegister &= ~BIT_5;
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
			AP_DisAssociateAllSTAs(Adapter); 
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
		}

	}

	return 0;

}
*/