/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    michael.h

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/

#ifndef _MICHAEL_HEADER_
#define _MICHAEL_HEADER_
// Rotation functions on 32 bit values
#define ROL32( A, n ) \
 ( ((A) << (n)) | ( ((A)>>(32-(n)))  & ( (1UL << (n)) - 1 ) ) )
#define ROR32( A, n ) ROL32( (A), 32-(n) )

typedef unsigned long UInt32;
typedef unsigned char Byte;

//variable.
typedef struct
        {
         UInt32  K0, K1;        // Key
         UInt32  L, R;          // Current state
         UInt32  M;             // Message accumulator (single word)
         int     nBytesInM;     // # bytes in M
        }   MICvar;             // variable for MIC

// Clear the internal message, 
// resets the object to the state just after construction.
void MICclear(MICvar *MIC);

// Set the key to a new value
void MICsetKey( Byte * key,MICvar *MIC );

// Get the MIC result. Destination should accept 8 bytes of result.
// This also resets the message to empty.
void MICgetMIC( Byte * dst,MICvar *MIC );

// Add a single byte to the internal message
void MICappendByte( Byte b,MICvar *MIC );

// Get UInt32 from 4 bytes LSByte first
UInt32 getUInt32( Byte * p );

// Put UInt32 into 4 bytes LSByte first
void putUInt32( Byte * p, UInt32 val );

#endif