/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    tkipseed.h

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/
#ifndef _TKIPSEED_HEADER_
#define _TKIPSEED_HEADER_

#define BYTE    unsigned char
#define Mk16(A,B) ((A<<8)+B)

typedef unsigned short u16b;   /* 16-bit word */
typedef unsigned long UInt32;
typedef unsigned char Byte;
#define Lo8(v16)  ((BYTE)( (v16) & 0xFF))
#define Hi8(v16)  ((BYTE)(((v16)>>8)&0xFF))

//variable.
typedef struct _Seedvar
    {
        BYTE    TK[32];          // Key
        BYTE    TA[6];
        u16b    TTAK[5];        // TTAK
        u16b    ppk[6];
        u16b    IV16,iv16tmp;
        UInt32  IV32,iv32tmp;
    }   Seedvar, *PSeedvar;

#define Tx  0
#define Rx  1

void Tkip_Init( BYTE * key, BYTE *ta,Seedvar *Seed,BYTE *initiv);

void Tkip_clear(Seedvar *Seed);

// set key and TA
void Tkip_setkey(BYTE * key,BYTE *ta,Seedvar *Seed);

// phase1 key mixing function
char Tkip_phase1_key_mix(UInt32  IV32,Seedvar *Seed);
    
// phase2 key mixing function
char Tkip_phase2_key_mix(u16b IV16,Seedvar *Seed);

// get generated seeds
void Tkip_getseeds(u16b IV16,BYTE *RC4Key,Seedvar *Seed);

// update stored IV.
void Tkip_updateiv(Seedvar *Seed);


/************************************************************/
/* tkip_sbox()                                              */
/* Returns a 16 bit value from a 64K entry table. The Table */
/* is synthesized from two 256 entry byte wide tables.      */
/************************************************************/
unsigned int tkip_sbox(unsigned int index);

// rotate right by 1 bit.
static unsigned int rotr1(unsigned int a);
#endif