/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    registers.h

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/



#ifndef _REGISTERS_H
#define _REGISTERS_H


//-------------------------------------------------------------------------
// Registers definition
//-------------------------------------------------------------------------
#define		CR0						0x0000
#define		CR1						0x0004
#define		CR2						0x0008
#define		CR3						0x000C

#define		CR5						0x0010
#define		CR6						0x0014
#define		CR7						0x0018
#define		CR8						0x001C

#define		CR4						0x0020

#define		CR9						0x0024
#define		CR10					0x0028
#define		CR11					0x002C
#define		CR12					0x0030
#define		CR13					0x0034
#define		CR14					0x0038
#define		CR15					0x003C
#define		CR16					0x0040
#define		CR17					0x0044
#define		CR18					0x0048
#define		CR19					0x004C
#define		CR20					0x0050
#define		CR21					0x0054
#define		CR22					0x0058
#define		CR23					0x005C
#define		CR24					0x0060
#define		CR25					0x0064
#define		CR26					0x0068
#define		CR27					0x006C
#define		CR28					0x0070
#define		CR29					0x0074
#define		CR30					0x0078
#define		CR31					0x007C
#define		CR32					0x0080
#define		CR33					0x0084
#define		CR34					0x0088
#define		CR35					0x008C
#define		CR36					0x0090
#define		CR37					0x0094
#define		CR38					0x0098
#define		CR39					0x009C
#define		CR40					0x00A0
#define		CR41					0x00A4
#define		CR42					0x00A8
#define		CR43					0x00AC
#define		CR44					0x00B0
#define		CR45					0x00B4
#define		CR46					0x00B8
#define		CR47					0x00BC
#define		CR48					0x00C0
#define		CR49					0x00C4
#define		CR50					0x00C8
#define		CR51					0x00CC
#define		CR52					0x00D0
#define		CR53					0x00D4
#define		CR54					0x00D8
#define		CR55					0x00DC
#define		CR56					0x00E0
#define		CR57					0x00E4
#define		CR58					0x00E8
#define		CR59					0x00EC
#define		CR60					0x00F0
#define		CR61					0x00F4
#define		CR62					0x00F8
#define		CR63					0x00FC
#define		CR64					0x0100
#define		CR65					0x0104
#define		CR66					0x0108
#define		CR67					0x010C
#define		CR68					0x0110
#define		CR69					0x0114
#define		CR70					0x0118
#define		CR71					0x011C
#define		CR72					0x0120
#define		CR73					0x0124
#define		CR74					0x0128
#define		CR75					0x012C
#define		CR76					0x0130
#define		CR77					0x0134
#define		CR78					0x0138
#define		CR79					0x013C
#define		CR80					0x0140
#define		CR81					0x0144
#define		CR82					0x0148
#define		CR83					0x014C
#define		CR84					0x0150
#define		CR85					0x0154
#define		CR86					0x0158
#define		CR87					0x015C
#define		CR88					0x0160
#define		CR89					0x0164
#define		CR90					0x0168
#define		CR91					0x016C
#define		CR92					0x0170
#define		CR93					0x0174
#define		CR94					0x0178
#define		CR95					0x017C
#define		CR96					0x0180
#define		CR97					0x0184
#define		CR98					0x0188
#define		CR99					0x018C
#define		CR100					0x0190
#define		CR101					0x0194
#define		CR102					0x0198
#define		CR103					0x019C
#define		CR104					0x01A0
#define		CR105					0x01A4
#define		CR106					0x01A8
#define		CR107					0x01AC
#define		CR108					0x01B0
#define		CR109					0x01B4
#define		CR110					0x01B8
#define		CR111					0x01BC
#define		CR112					0x01C0
#define		CR113					0x01C4
#define		CR114					0x01C8
#define		CR115					0x01CC
#define		CR116					0x01D0
#define		CR117					0x01D4
#define		CR118					0x01D8
#define		CR119					0x01DC
#define		CR120					0x01E0
#define		CR121					0x01E4
#define		CR122					0x01E8
#define		CR123					0x01EC

#define		CR125					0x01F4
#define		CR126					0x01F8
#define		CR127					0x01FC
#define		CR128					0x0200
#define		CR129					0x0204
#define		CR130					0x0208
#define		CR131					0x020C
#define		CR132					0x0210
#define		CR133					0x0214
#define		CR134					0x0218
#define		CR135					0x021C
#define		CR136					0x0220
#define		CR137					0x0224
#define		CR138					0x0228
#define		CR139					0x022C
#define		CR140					0x0230
#define		CR141					0x0234
#define		CR142					0x0238
#define		CR143					0x023C
#define		CR144					0x0240
#define		CR145					0x0244
#define		CR146					0x0248
#define		CR147					0x024C
#define		CR148					0x0250
#define		CR149					0x0254
#define		CR150					0x0258
#define		CR151					0x025C
#define		CR152					0x0260
#define		CR153					0x0264
#define		CR154					0x0268
#define		CR155					0x026C
#define		CR156					0x0270
#define		CR157					0x0274
#define		CR158					0x0278
#define		CR159					0x027C
#define		CR160					0x0280
#define		CR161					0x0284
#define		CR162					0x0288
#define		CR163					0x028C
#define		CR164					0x0290
#define		CR165					0x0294
#define		CR166					0x0298
#define		CR167					0x029C
#define		CR168					0x02A0
#define		CR169					0x02A4
#define		CR170					0x02A8
#define		CR171					0x02AC
#define		CR172					0x02B0
#define		CR173					0x02B4
#define		CR174					0x02B8
#define		CR175					0x02BC
#define		CR176					0x02C0
#define		CR177					0x02C4
#define		CR178					0x02C8
#define		CR179					0x02CC
#define		CR180					0x02D0
#define		CR181					0x02D4
#define		CR182					0x02D8
#define		CR183					0x02DC
#define		CR184					0x02E0
#define		CR185					0x02E4
#define		CR186					0x02E8
#define		CR187					0x02EC
#define		CR188					0x02F0
#define		CR189					0x02F4
#define		CR190					0x02F8
#define		CR191					0x02FC
#define		CR192					0x0300
#define		CR193					0x0304
#define		CR194					0x0308
#define		CR195					0x030C
#define		CR196					0x0310
#define		CR197					0x0314
#define		CR198					0x0318
#define		CR199					0x031C
#define		CR200					0x0320
#define		CR201					0x0324
#define		CR202					0x0328
#define		CR203					0x032C
#define		CR204					0x0330
#define		CR205					0x0334
#define		CR206					0x0338
#define		CR207					0x033C
#define		CR208					0x0340
#define		CR209					0x0344
#define		CR210					0x0348
#define		CR211					0x034C
#define		CR212					0x0350
#define		CR213					0x0354
#define		CR214					0x0358
#define		CR215					0x035C
#define		CR216					0x0360
#define		CR217					0x0364
#define		CR218					0x0368
#define		CR219					0x036C
#define		CR220					0x0370
#define		CR221					0x0374
#define		CR222					0x0378
#define		CR223					0x037C
#define		CR224					0x0380
#define		CR225					0x0384
#define		CR226					0x0388
#define		CR227					0x038C
#define		CR228					0x0390
#define		CR229					0x0394
#define		CR230					0x0398
#define		CR231					0x039C
#define		CR232					0x03A0
#define		CR233					0x03A4
/*
#define		CR234					0x03A8
#define		CR235					0x03AC
#define		CR236					0x03B0
#define		CR237					0x03B4
#define		CR238					0x03B8
#define		CR239					0x03BC
*/
#define		CR240					0x03C0
#define		CR241					0x03C4
#define		CR242					0x03C8
#define		CR243					0x03CC
#define		CR244					0x03D0
#define		CR245					0x03D4
#define		CR251					0x03EC
#define		CR252					0x03F0
#define		CR253					0x03F4
#define		CR254					0x03F8
#define		CR255					0x03FC
#define		PHY_END					0x03FC

#define		RF_IF_CLK				0x0400
#define		RF_IF_DATA				0x0404
#define		PE1_PE2					0x0408
#define		PE2_DLY					0x040C
#define		LE1						0x0410
#define		LE2						0x0414
#define		GPI_EN					0x0418

#define		RADIO_PD				0x042C
#define		RF2948_PD				0x042C
//JWEI 2004/02/09
#ifndef HOST_IF_USB
#define     LED1                    0x0430
#define     LED2                    0x0434
#else
#define     rLED_CTRL               0x0644
#define     LED2                    BIT_8   // Note: this is really LED1
#define     LED1                    BIT_9   // Note: this is really LED2
#endif

#define		EnablePSManualAGC		0x043C	// 1: enable
#define		CONFIGPhilips			0x0440

#define		SA2400_SER_AP			0x0444
#define		I2C_WRITE				0x0444	// Same as SA2400_SER_AP (for compatible with ZD1201)

#define		SA2400_SER_RP			0x0448

#ifndef	AMAC
#define		AfterPNP				0x0454
#endif

#define		RADIO_PE				0x0458
#define		RstBusMaster			0x045C

#define		RFCFG					0x0464
#define		RFCFG1					0x0644
#define		HSTSCHG					0x046C

#define		PHY_ON					0x0474
#define		RX_DELAY				0x0478
#define		RX_PE_DELAY				0x047C


#define		GPIO_1					0x0490
#define		GPIO_2					0x0494


#define		EncryBufMux				0x04A8


#define		PS_Ctrl					0x0500
#define		ADDA_PwrDwn_Ctrl		0x0504
#define		ADDA_MBIAS_WarmTime		0x0508
#define		MAC_PS_STATE			0x050C
#define		InterruptCtrl			0x0510
#define		TSF_LowPart				0x0514
#define		TSF_HighPart			0x0518
#define		ATIMWndPeriod			0x051C
#define		BCNInterval				0x0520
#define		Pre_TBTT				0x0524	//In unit of TU(1024us)

#define		PCI_TxAddr_p1			0x0600
#define		PCI_TxAddr_p2			0x0604
#define		PCI_RxAddr_p1			0x0608
#define		PCI_RxAddr_p2			0x060C
#define		MACAddr_P1				0x0610
#define		MACAddr_P2				0x0614
#define		BSSID_P1				0x0618
#define		BSSID_P2				0x061C
#define		BCNPLCPCfg				0x0620
#define		GroupHash_P1			0x0624
#define		GroupHash_P2			0x0628

#define		BasicRateTbl			0x0630
#define		MandatoryRateTbl		0x0634
#define		RTS_CTS_Rate			0x0638



//				Wep protect
//				_
//	if set to 0x114
//				 __
//				0x14 * slot time(if is 2us) = 40us = wep init time.
//
// So if we change slot time, change 0x14 to let wep init time close to 40us.
#define		Wep_Protect				0x063C

#ifdef	AMAC
#define		AfterPNP				0x0648
#endif

#ifdef	OFDM
#define		AckTime80211			0x0658
#endif	

#define		PHYDelay				0x066C
#define		BCNFIFO					0x0670
#define		SnifferOn				0x0674
#define		EncryType				0x0678
#define		RetryMAX				0x067C
#define		CtlReg1					0x0680	//Bit0:		IBSS mode
											//Bit1:		PwrMgt mode
											//Bit2-4 :	Highest basic rate
											//Bit5:		Lock bit
											//Bit6:		PLCP weight select
											//Bit7:		PLCP control switch (Host/Device)
#define		DeviceState				0x0684
#define		UnderrunCnt				0x0688
#define		SendToHost				0x068C
#define		Ack_Timeout_Ext			0x0690
#define		BCN_FIFO_Semaphore		0x0694
#define		IFS_Value				0x0698
#define		RxTimeoutCnt			0x069C

#define		TotalRxFrm				0x06A0
#define		CRC32Cnt				0x06A4
#define		CRC16Cnt				0x06A8
#define		DecrypErr_UNI			0x06AC
#define		RxFIFOOverrun			0x06B0
#define		DecrypErr_Mul			0x06BC

#define		NAV_CNT					0x06C4
#define		NAV_CCA					0x06C8
#define		RetryCnt				0x06CC

#define		ReadTcbAddress			0x06E8
#define		ReadRfdAddress			0x06EC

// If we change CWmin_CWmax, take care of Wep_Protect
#define		CWmin_CWmax				0x06F0
#define		TotalTxFrm				0x06F4

#define		CAM_MODE				0x0700
#define		CAM_ROLL_CALL_TBL_L		0x0704
#define		CAM_ROLL_CALL_TBL_H		0x0708
#define		CAM_ADDRESS				0x070C
#define		CAM_DATA				0x0710
#define		ROMDIR					0x0714

#define		WEPKey0					0x0720
#define		WEPKey1					0x0724
#define		WEPKey2					0x0728
#define		WEPKey3					0x072C
#define		WEPKey4					0x0730
#define		WEPKey5					0x0734
#define		WEPKey6					0x0738
#define		WEPKey7					0x073C
#define		WEPKey8					0x0740
#define		WEPKey9					0x0744
#define		WEPKey10				0x0748
#define		WEPKey11				0x074C
#define		WEPKey12				0x0750

#define		EEPROM_PROTECT0			0x0758
#define		EEPROM_PROTECT1			0x075C

//yarco
#define		TKIP_MODE				0x0760
#define		TX_CCM_MODE				0x0B80
#define		TX_CCM_MASK				0x0B84
#define		RX_CCM_MODE				0x0C88
#define		RX_CCM_MASK				0x0C8C

#define		Dbg_FIFO_Rd				0x0800
#define		Dbg_Select				0x0804
#define		FIFO_Length				0x0808


// EEPROM Memmory Map Region
#define		E2P_SUBID				0x0900
#define		E2P_POD					0x0904
#define		E2P_MACADDR_P1			0x0908
#define		E2P_MACADDR_P2			0x090C
#define     E2P_PWR_CAL_VALUE       0x0910
#define		E2P_PWR_INT_VALUE		0x0920
#define		E2P_ALLOWED_CHANNEL		0x0930
//JWEI 2003/12/31
#ifdef HOST_IF_USB
#define     E2P_DEVICE_VER          0x0940
#define     E2P_PHY_REG             0x094A
#define     E2P_36M_CAL_VALUE       0x0950
#define     E2P_36M_INT_VALUE       0x0960
#define     E2P_48M_CAL_VALUE       0x0970
#define     E2P_48M_INT_VALUE       0x0980
#define     E2P_54M_CAL_VALUE       0x0990
#define     E2P_54M_INT_VALUE       0x09A0
    #ifndef fNEW_CODE_MAP
#define     E2P_END                 0x09F0
    #else
#define     E2P_END                 0x09FC
    #endif
#else
#define     E2P_PHY_REG             0x0934
#define     E2P_REGION_CODE         0x0960
#define     E2P_FEATURE_BITMAP      0x0964
#define     E2P_END                 0x0968
#endif

//JWEI 2004/02/11
#ifdef HOST_IF_USB
#define     FW_FIRMWARE_VER         0x0B00
#define     FW_USB_SPEED            0x0B01
#define     FW_FIX_TX_RATE          0x0B02
#define     FW_LINK_STATUS          0x0B03
#define     FW_SOFT_RESET           0x0B04
#define     FW_FLASH_CHKSUM         0x0B06
#define     FW_FLASH_CHKSUMH        0x0B07

#define     ZD1211_CLOCK_CTRL       0x8540
#define     SOCGPIO                 0x85C0 //chi-define for signal strength LED control
#define     bZD1211_CLOCK_EEPROM    0
#define     bmZD1211_CLOCK_EEPROM   mBIT(bZD1211_CLOCK_EEPROM)

#define     UMAC_EPROM_ROM_ADDR     0x862A
#define     UMAC_EPROM_RAM_ADDR     0x862B
#define     UMAC_EPROM_DMA_LEN_DIR  0x862C
#define     bmEPROM_XFER_DIR        BIT_15

#define     UMAC_WAIT_STATE         0x8801
#endif

//-------------------------------------------------------------------------
// Registers bitmap definition
//-------------------------------------------------------------------------

// EVSTATUS
#define		TX_COMPLETE				0x00000001
#define		RX_COMPLETE				0x00000002
#define		RETRY_FAIL				0x00000004
#define		PS_WAKE_UP				0x00000008
#define		ATIMWND_END				0x00000010
#define		CFG_NEXT_BCN			0x00000040

#define		BUS_ABORT				0x00000080



#endif      // REGISTERS_H

