/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    request.c

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/

#include "precomp.h"
#include "ver.h"

//WPA support
BOOLEAN
CheckAuthentication(PZD1205_ADAPTER Adapter, UCHAR* pSSID)
{

	ULONG    i, j, length, pc, ac, start, IEstart;
    UCHAR    WPAMode,WepWpaMode;

    if ( (Adapter->CardSetting.AuthMode == Ndis802_11AuthModeWPA)&&
		 (Adapter->encryMode >= Ndis802_11Encryption2Enabled) )
	{
		WepWpaMode=1;//WPA
		WPAMode = 1;
	}
	else if ( Adapter->CardSetting.AuthMode == Ndis802_11AuthModeWPAPSK )
	{
		WepWpaMode=1;//WPA
		WPAMode = 2;
	}
	else if ( Adapter->encryMode == Ndis802_11Encryption1Enabled)
	{
		WepWpaMode=2;//WEP
	}
	else
	{
		return TRUE;
	}


    if (WepWpaMode==1)
	{
		for ( i=0; i<Adapter->BSSCnt; i++ )
		{
			length = Adapter->BSSInfo[i].SSID[1];
			if ( strncmp((char*)&pSSID[1], (char*)&Adapter->BSSInfo[i].SSID[2], length) == 0 )
			{ //Found desired SSID
						
				if ( Adapter->BSSInfo[i].WPASupport )
				{
					IEstart = Adapter->BSSInfo[i].IEstart;
					pc = Adapter->BSSInfo[i].wpaIEs[12+IEstart] + (Adapter->BSSInfo[i].wpaIEs[13+IEstart] << 8);
					start = 14 + pc * 4 + IEstart;
					ac = Adapter->BSSInfo[i].wpaIEs[start] + (Adapter->BSSInfo[i].wpaIEs[start+1] << 8);
					start += 5;
					for ( j=0; j<ac; j++ )
					{
						if ( Adapter->BSSInfo[i].wpaIEs[start] == WPAMode )
							return TRUE;
						start += 4;
					}
				}
			}
		}
		return FALSE;
	}


	if (WepWpaMode==2)
	{
		for ( i=0; i<Adapter->BSSCnt; i++ )
		{
			if (( ( strcmp((char*)&Adapter->CardSetting.Info_SSID[2],
				(char*)&Adapter->BSSInfo[i].SSID[2]) == 0 ))
				||( pSSID[0] == 0 ))//any SSID
			{
				if ( Adapter->BSSInfo[i].WPASupport )
					return FALSE;
				else
				    return TRUE;
			}
		}
	}
 return FALSE;
}
//-----------------------------------------------------------------------------
// Procedure:   ZD1205SetInformation
//
// Description: ZD1205SetInformation handles a set operation for a single OID.
//              The only operations that really change the configuration of
//              the adapter are set PACKET_FILTER, and SET_MULTICAST.
//
// Arguments:
//      MiniportAdapterContext - The context value returned by the Miniport
//                               when the adapter was initialized (see the call
//                               NdisMSetAttributes. In reality, it is a
//                               pointer to ZD1205_ADAPTER.
//      Oid - The Oid that is to be set.
//      InformationBuffer -  Holds the data to be set.
//      InformationBufferLength - The length of InformationBuffer.
//
// Result:
//      BytesRead - If the call is successful, returns the number of bytes
//                  read from InformationBuffer.
//      BytesNeeded - If there is not enough data in OvbBuffer to satisfy the
//                    OID, returns the amount of storage needed.
//
// Returns:
//      NDIS_STATUS_SUCCESS
//      NDIS_STATUS_INVALID_LENGTH
//      NDIS_STATUS_INVALID_OID
//      NDIS_STATUS_NOT_SUPPORTED
//      NDIS_STATUS_NOT_ACCEPTED
//-----------------------------------------------------------------------------

NDIS_STATUS
ZD1205SetInformation(
                   IN NDIS_HANDLE MiniportAdapterContext,
                   IN NDIS_OID Oid,
                   IN PVOID InformationBuffer,
                   IN ULONG InformationBufferLength,
                   OUT PULONG BytesRead,
                   OUT PULONG BytesNeeded
                   )

{
    PZD1205_ADAPTER       Adapter;
    NDIS_STATUS         Status;
    ULONG               PacketFilter;
	ULONG       IoValue;
	USHORT		i,j;
	ULONG		tmpvalue;
	PUCHAR		pKey;
	USHORT		loop;
	ULONG		DebugPrint;
//#ifdef NDIS51_MINIPORT
    PNDIS_802_11_SSID		pSSID;
	UCHAR       tmpSSID[33];
	UCHAR       SSIDLen;
	PUINT       mode;
	UCHAR       AuthenticationModeMax;
//#endif
    PNDIS_802_11_CONFIGURATION  pConfiguration;

	ZD1211_IRQL		OldIrql;

    DEBUGFUNC(_T("ZD1205SetInformation"));
    Adapter = PZD1205_ADAPTER_FROM_CONTEXT_HANDLE(MiniportAdapterContext);

	DebugPrint = Adapter->DbgMsgFlag & DBGMSG_OID;
    *BytesRead = 0;
    *BytesNeeded = 0;


#ifndef HOST_IF_USB
	// Assure that no any Tx/Rx frame processing by aquiring Adapter->Lock/
	//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
#endif

    //DbgPrint("set oid = %x\r\n", Oid);

	switch (Oid) {

		case OID_ZD_IO32:
		case OID_ZD_IO_WRITE:
		case OID_ZD_SET_TALLIES:
        case OID_ZD_TEST:
		case OID_ZD_DOWNLOAD_ROM:
		case OID_ZD_CMD:
        case OID_ZD_SETRID:
	    case OID_ZD_RESET_TALLIES:

			Status = ZD1211Old_SetInformation(	MiniportAdapterContext,
												Oid,
												InformationBuffer,
												InformationBufferLength,
												BytesRead,
												BytesNeeded
												);

		break;

		case OID_ZD_CUSTOM:
		case OID_ZD_RD:

		Status = ZD1211_Custom_SetInformation(
						MiniportAdapterContext,
						Oid,
						InformationBuffer,
						InformationBufferLength,
						BytesRead,
						BytesNeeded
						);

		break;

		case OID_802_3_MULTICAST_LIST:
			INITSTRTX(DebugPrint, (_T("OID_802_3_MULTICAST_LIST\n")));

			// The data must be a multiple of the Ethernet address size.
			if (InformationBufferLength % ETH_LENGTH_OF_ADDRESS != 0){
				Status = (NDIS_STATUS_INVALID_LENGTH);
				break;
			}else{
				pKey = (PUCHAR)InformationBuffer;
				ZD1205_WRITE_REGISTER(Adapter,GroupHash_P1, 0);
				ZD1205_WRITE_REGISTER(Adapter,GroupHash_P2, 0x80000000);
                Adapter->MulticastAddr[0] = (UCHAR) InformationBufferLength / ETH_LENGTH_OF_ADDRESS;
				memcpy(Adapter->MulticastAddr+1, InformationBuffer, InformationBufferLength);
				Adapter->MulticastAddr[InformationBufferLength+1] = 0;
				for (i=0;i<InformationBufferLength;i++){
					if ((i % 6) == 5){
						*(pKey+i) = (*(pKey+i)) >> 2;
						if (*(pKey+i) >= 32){
							ZD1205_READ_REGISTER(Adapter,GroupHash_P2, &tmpvalue);
							tmpvalue |= (0x1 << (*(pKey+i)-32));
							ZD1205_WRITE_REGISTER(Adapter,GroupHash_P2, tmpvalue);
						}
						else{
							ZD1205_READ_REGISTER(Adapter,GroupHash_P1, &tmpvalue);
							tmpvalue |= (0x1 << (*(pKey+i)));
							ZD1205_WRITE_REGISTER(Adapter,GroupHash_P1, tmpvalue);
						}
					}
				}
				ZD1205_READ_REGISTER(Adapter,GroupHash_P1, &Adapter->ulGroupHash_P1);
				ZD1205_READ_REGISTER(Adapter,GroupHash_P1, &Adapter->ulGroupHash_P2);
				*BytesRead = InformationBufferLength;
				Status = NDIS_STATUS_SUCCESS;
				break;
			}


		case OID_GEN_CURRENT_PACKET_FILTER:
			INITSTRTX(DebugPrint, (_T("OID_GEN_CURRENT_PACKET_FILTER\n")));

			// Verify the Length
			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}

			// Now call the filter package to set the packet filter.
			NdisMoveMemory((PVOID)&PacketFilter, InformationBuffer, sizeof(ULONG));

			// Verify bits, if any bits are set that we don't support, leave
			// Should be this, for AEGIS-Client compatibility
			if ( !Adapter->WPAOn ){
			    if ( PacketFilter &
				     ~(NDIS_PACKET_TYPE_DIRECTED |
				     NDIS_PACKET_TYPE_MULTICAST |
				     NDIS_PACKET_TYPE_BROADCAST
				     ))
				{
				    REQUEST(Adapter, ("Filter Type %08x not supported\n", PacketFilter));
				    Status = NDIS_STATUS_NOT_SUPPORTED;
				    *BytesRead = 4;
				    break;
				}			
			}else{
			    if ( PacketFilter &
				     ~(NDIS_PACKET_TYPE_DIRECTED |
				     NDIS_PACKET_TYPE_MULTICAST |
				     NDIS_PACKET_TYPE_BROADCAST |
				     NDIS_PACKET_TYPE_PROMISCUOUS |
				     NDIS_PACKET_TYPE_ALL_MULTICAST
				     ))
				{
				    REQUEST(Adapter, ("Filter Type %08x not supported\n", PacketFilter));
				    Status = NDIS_STATUS_NOT_SUPPORTED;
				    *BytesRead = 4;
				    break;
				}
			}

			// If this is a miniport driver, the submit the packet filter change
			*BytesRead = InformationBufferLength;
			Status = NDIS_STATUS_SUCCESS;
			break;


		case OID_GEN_CURRENT_LOOKAHEAD:
			INITSTRTX(DebugPrint, (_T("OID_GEN_CURRENT_LOOKAHEAD\n")));

			// Verify the Length
			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			*BytesRead = 4;
			Status = NDIS_STATUS_SUCCESS;
			break;


			// stub the next four cases to set up power management stuff
			// if the adapter had supported power management, the commented lines
			// should replace the stub lines. See the power management spec

		case OID_PNP_SET_POWER:
			INITSTRTX(DebugPrint, (_T("OID_PNP_SET_POWER\n")));

			if (InformationBufferLength == 0){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			*BytesRead = InformationBufferLength;
			Status = NDIS_STATUS_SUCCESS;
			//*BytesRead = 0;                     //stub
			//Status = NDIS_STATUS_SUCCESS; //stub
			break;

		case OID_PNP_ADD_WAKE_UP_PATTERN:
			INITSTRTX(DebugPrint, (_T("OID_PNP_ADD_WAKE_UP_PATTERN\n")));

			// call a function that would program the adapter's wake
			// up pattern, return success
			//*BytesRead = InformationBufferLength;
			*BytesRead = 0;                     //stub
			Status = NDIS_STATUS_NOT_SUPPORTED; //stub
			break;

		case OID_PNP_REMOVE_WAKE_UP_PATTERN:
			INITSTRTX(DebugPrint, (_T("OID_PNP_REMOVE_WAKE_UP_PATTERN\n")));
			// call a function that would remove the adapter's wake
			// up pattern, return success
			//*BytesRead = InformationBufferLength;
			*BytesRead = 0;                     //stub
			Status = NDIS_STATUS_NOT_SUPPORTED; //stub
			break;

		case OID_PNP_ENABLE_WAKE_UP:
			INITSTRTX(DebugPrint, (_T("OID_PNP_ENABLE_WAKE_UP\n")));
			// call a function that would enable wake up on the adapter
			// return success
			//*BytesRead = InformationBufferLength;
			*BytesRead = 0;                     //stub
			Status = NDIS_STATUS_NOT_SUPPORTED; //stub
			break;

			/* this OID is for showing how to work with driver specific (custom)
			OIDs and the NDIS 5 WMI interface using GUIDs
			*/
		case OID_CUSTOM_DRIVER_SET:
			INITSTRTX(DebugPrint, (_T("OID_CUSTOM_DRIVER_SET\n")));
			*BytesRead = 4;
			Status = NDIS_STATUS_SUCCESS;
			break;
//#ifdef NDIS51_MINIPORT
		case OID_GEN_MACHINE_NAME:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_GEN_MACHINE_NAME\n")));
			INITSTRTX(DebugPrint, (_T("No Action\n")));
			*BytesRead = InformationBufferLength;
			break;
		case OID_802_11_RSSI_TRIGGER:
			DebugPrint = TRUE;
			if (InformationBufferLength == 0){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			INITSTRTX(DebugPrint, (_T("OID_802_11_RSSI_TRIGGER\n")));
            Adapter->RssiTrigLevel=*((PULONG)InformationBuffer);
			INITSTRTX(DebugPrint,(_T("Value = %x\n"), Adapter->RssiTrigLevel));
			*BytesRead = 4;
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_BSSID:
			if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_BSSID:
			DebugPrint = TRUE;
			if (InformationBufferLength != 6){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID\n")));
			memcpy(Adapter->BSSID_to_be_Connect_tmp, InformationBuffer, InformationBufferLength);
			*BytesRead = 6;
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_SSID:
			if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_SSID\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_SSID:
		case OID_ZDX_802_11_SSID:
			DebugPrint = TRUE;
			// Verify the Length
			if (InformationBufferLength < sizeof(NDIS_802_11_SSID)){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
				INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_SSID\n")));

				{
					char tmpArray[6] = {0};

					if (memcmp(Adapter->BSSID_to_be_Connect_tmp, tmpArray, 6) == 0){
						Adapter->bNeedCmpBSSID = FALSE;
					}
					else{
						INITSTRTX(DebugPrint, (_T("Need Compare BSSID\n")));
						Adapter->bNeedCmpBSSID = TRUE;
						memcpy(Adapter->BSSID_to_be_Connect, Adapter->BSSID_to_be_Connect_tmp, 6);
						NdisZeroMemory(Adapter->BSSID_to_be_Connect_tmp, 6);
					
						ZDDbgPrint((_T("BSSID : %x-%x-%x-%x-%x-%x\n"), Adapter->BSSID_to_be_Connect[0],
						Adapter->BSSID_to_be_Connect[1],
						Adapter->BSSID_to_be_Connect[2],
						Adapter->BSSID_to_be_Connect[3],
						Adapter->BSSID_to_be_Connect[4],
						Adapter->BSSID_to_be_Connect[5]
						));
					}
				}
				pSSID = (PNDIS_802_11_SSID)InformationBuffer;
				SSIDLen = (UCHAR) pSSID->SsidLength;
				if (SSIDLen > 32){
					SSIDLen = 32;
					/*if (Adapter->Notification & RQ_CONNECTNETWORK){
						*BytesRead=sizeof(NDIS_802_11_SSID);
						Status = NDIS_STATUS_SUCCESS;
						break;
					}*/
					//ASSERT(0);
				}
				memcpy(tmpSSID, pSSID->Ssid, SSIDLen);
				if (SSIDLen != 0){
					if ( Adapter->Notification & RQ_CONNECTNETWORK )
						Adapter->MoreConnect++;
					Adapter->CardSetting.Info_SSID[2+Adapter->CardSetting.Info_SSID[1]]=0;

					//if ( strcmp((char*)&Adapter->CardSetting.Info_SSID[2], (char*)&pSSID->Ssid[0]) != 0 ){
					if ( (strncmp((char*)&Adapter->CardSetting.Info_SSID[2], (char*)&pSSID->Ssid[0], pSSID->SsidLength) != 0) ||
						(Adapter->CardSetting.Info_SSID[1] != pSSID->SsidLength) ||
						(Adapter->CardSetting.AuthMode == Ndis802_11AuthModeWPA) ||
						(Adapter->CardSetting.AuthMode == Ndis802_11AuthModeWPAPSK) ){ // Different SSID been set
							Mgt_ClearNotification(Adapter, RQ_CONNECTNETWORK);
						if (Adapter->adapterReady == TRUE){
							Mgt_SendNotification(Adapter, RQ_DISCONNECT);
							Adapter->adapterReady = FALSE;
							ZDDbgPrint((_T("Adapter DisConnect! - 3\n")));
						
						}
					}

					Adapter->CardSetting.Info_SSID[0] = 0x00;
					Adapter->CardSetting.Info_SSID[1] = SSIDLen;
					for (i=0;i<SSIDLen;i++){
						Adapter->CardSetting.Info_SSID[2+i] = tmpSSID[i];
					}
					
					Adapter->CardSetting.Info_SSID[2+i] = 0;
					ZDDbg2(("Value = %s\n", (char*)&Adapter->CardSetting.Info_SSID[2]));
					//INITSTRTX(DebugPrint,(_T("Value = %s\n"), (char*)&Adapter->CardSetting.Info_SSID[2]));
					Mgt_SendNotification(Adapter, RQ_CONNECTNETWORK);
					Mgt_SendNotification(Adapter, RQ_AP_DISASSOCIATE_ALL);
					Adapter->AnyBSSFlag = 0;
				}else{
					Adapter->NotCheckConnect = 0;
					Adapter->CardSetting.Info_SSID[0] = 0x00;
					Adapter->CardSetting.Info_SSID[1] = 0x0;
					Adapter->AnyBSSFlag = 1;
					//Adapter->CardSetting.AuthMode = Ndis802_11AuthModeOpen;	// Use open authentication.
				}
				*BytesRead=sizeof(NDIS_802_11_SSID);
				Status = NDIS_STATUS_SUCCESS;
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZDDbg((_T("---------->>> Release SpinLock\n")));
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
			break;
		case OID_802_11_NETWORK_TYPE_IN_USE:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_802_11_NETWORK_TYPE_IN_USE\n")));
			INITSTRTX(DebugPrint, (_T("Not support\n")));
            Status = NDIS_STATUS_NOT_SUPPORTED;
			break;
		case OID_802_11_BSSID_LIST_SCAN:
			DebugPrint = TRUE;
            if ( Adapter->ZDConfigRunning ){
                //INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    //INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID_LIST_SCAN\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
			//INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID_LIST_SCAN\n")));
			//Mgt_SendNotification(Adapter, RQ_BSSID_LIST_SCAN);
			//Mgt_SendNotification(Adapter, RQ_ZD_BSSID_LIST_SCAN);
			Status = NDIS_STATUS_SUCCESS;		
		case OID_ZD_802_11_BSSID_LIST_SCAN:
		case OID_ZDX_802_11_BSSID_LIST_SCAN:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_BSSID_LIST_SCAN\n")));
			Mgt_SendNotification(Adapter, RQ_ZD_BSSID_LIST_SCAN);
			Status = NDIS_STATUS_SUCCESS;
			break;			
		case OID_802_11_INFRASTRUCTURE_MODE:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_INFRASTRUCTURE_MODE\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}

		case OID_ZD_802_11_INFRASTRUCTURE_MODE:
		case OID_ZDX_802_11_INFRASTRUCTURE_MODE:
			DebugPrint = TRUE;
			if (InformationBufferLength == 0){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			//INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_INFRASTRUCTURE_MODE\n")));
			switch(*(PULONG)InformationBuffer){
			case Ndis802_11IBSS:
				INITSTR((_T("Ndis802_11IBSS\n")));
				SetBSSType(Adapter, INDEPENDENT_BSS);
				break;
			case Ndis802_11Infrastructure:
				//INITSTR((_T("Ndis802_11Infrastructure\n")));
				SetBSSType(Adapter, INFRASTRUCTURE_BSS);
				break;
			case Ndis802_11AutoUnknown:
				INITSTR((_T("Ndis802_11AutoUnknown\n")));
				SetBSSType(Adapter, INFRASTRUCTURE_BSS);
				break;
			case AP_BSS:
				INITSTR((_T("AP_BSS\n")));
				SetBSSType(Adapter, AP_BSS);
				break;
			default:
				INITSTR((_T("PSEUDO_IBSS\n")));
				SetBSSType(Adapter, PSEUDO_IBSS);
				break;
			}
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_CONFIGURATION:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_CONFIGURATION\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_CONFIGURATION:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_802_11_CONFIGURATION\n")));

			if (InformationBuffer == 0 || 
				(InformationBufferLength < 
				sizeof(NDIS_802_11_CONFIGURATION) )
				)
			{
				Status = NDIS_STATUS_INVALID_LENGTH;
				break;
			}	

			pConfiguration=(PNDIS_802_11_CONFIGURATION)InformationBuffer;			
		
            if ( (Adapter->IsUSB2_0) )
			{
				if (pConfiguration->Length != sizeof(NDIS_802_11_CONFIGURATION))
				{
					Status = NDIS_STATUS_INVALID_LENGTH;
					break;
				}	

				{	// update beacon
					UCHAR	BcnInterval[2];	// convert to as network 

					BcnInterval[0] = (UCHAR)(pConfiguration->BeaconPeriod);
					BcnInterval[1] = (UCHAR)(pConfiguration->BeaconPeriod >> 8);

					UpdateBeaconInterval(Adapter, BcnInterval);
				}
				{	// update ATIMWindow
					UCHAR	ATIMWindow[2];	// convert to as network 

					ATIMWindow[0] = (UCHAR)(pConfiguration->ATIMWindow);
					ATIMWindow[1] = (UCHAR)(pConfiguration->ATIMWindow >> 8);
			
					UpdateATIMWindow(Adapter, ATIMWindow);
				}
				{	// update channel
					ULONG ChannelNo = ((pConfiguration->DSConfig)/1000 - 2412)/5 + 1;

					if (pConfiguration->DSConfig == 2484000){
						Adapter->SaveChannel = 14;

						Set_RF_Channel(Adapter, 14, (UCHAR)Adapter->RF_Mode, 1);  
					}
					else{
						Adapter->SaveChannel = (UCHAR) ChannelNo;

						Set_RF_Channel(Adapter, ChannelNo, (UCHAR)Adapter->RF_Mode, 1);  
					}
				}
			}
			else
			{
                ULONG ChannelNo = ((pConfiguration->DSConfig)/1000 - 2412)/5 + 1;

			    Adapter->ATIMWindow = (USHORT) pConfiguration->ATIMWindow;
				Adapter->BeaconInterval = (USHORT) pConfiguration->BeaconPeriod;
			    if ( pConfiguration->DSConfig == 2484000 )
					Adapter->SaveChannel = 14;
				else
					Adapter->SaveChannel = (UCHAR) ChannelNo;

				Mgt_SendNotification(Adapter, RQ_SET_OID);
			}

			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_ADD_WEP:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_ADD_WEP\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_ADD_WEP:
		case OID_ZDX_802_11_ADD_WEP:
			DebugPrint = TRUE;
			if (InformationBufferLength < sizeof(NDIS_802_11_WEP)){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_ADD_WEP\n")));
			{
				PNDIS_802_11_WEP  WEP_p;
				ULONG KeyId;
				PUCHAR		pKey;
								
				WEP_p = (PNDIS_802_11_WEP)InformationBuffer; //Get data pointer
				
				KeyId = WEP_p->KeyIndex & 0x7fffFFFF;
				ZDDbgPrint((_T("WEP_p->KeyIndex = %x\n"),WEP_p->KeyIndex));
				if (KeyId > 3)
				{
					Status = NDIS_STATUS_FAILURE;
					break;
				}

                // jhlee 3313
				// check the default key
                if ( (WEP_p->KeyIndex & 0x80000000) ){
				    //Status = NDIS_STATUS_SUCCESS;
					Adapter->CardSetting.EncryKeyId = (UCHAR)KeyId;
					ZDDbgPrint((_T("Adapter->CardSetting.EncryKeyId = %d\n"),Adapter->CardSetting.EncryKeyId));
					//break;
				} 

				pKey = (PCHAR)WEP_p->KeyMaterial;

				if (WEP_p->KeyLength == 5){
					INITSTR((_T("WEP64\n")));
					memcpy(Adapter->AllKeyBuf+5*KeyId, pKey, 5);
					Change_EncryMode(Adapter, WEP64, WEP64);
					//ZD1205_WRITE_REGISTER(Adapter,EncryType, 0xa); // For WEP 64
					loop = 20;
					SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP64, 
										(UCHAR)KeyId, pKey);
				}
				else if (WEP_p->KeyLength == 13){
					INITSTR((_T("WEP128\n")));
					memcpy(Adapter->AllKeyBuf+13*KeyId, pKey, 13);
					Change_EncryMode(Adapter, WEP128, WEP128);
					loop = 52;
					SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP128, 
										(UCHAR)KeyId, pKey);
				}
				else if (WEP_p->KeyLength == 29){
					INITSTR((_T("WEP256\n")));
					memcpy(Adapter->AllKeyBuf+29*KeyId, pKey, 29);
					Change_EncryMode(Adapter, WEP256, WEP256);
					loop = 52;
					SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP256, 
										(UCHAR)KeyId, pKey);
				}
				else{
					Status = NDIS_STATUS_FAILURE;
					break;
				}

                // SetKeyContext has changed CAM_MODE to CAM_STA
				// We should restore it in AP mode
				if ( Adapter->CardSetting.BSSType == AP_BSS )
                    ZD1205_WRITE_REGISTER(Adapter, CAM_MODE, CAM_AP);
       

#ifndef AMAC
				for (i=0;i<loop;i+=4){
					ZD1205_READ_REGISTER(Adapter,WEPKey0+i, &tmpkey);
					switch(KeyId){
					case 0:
						tmpkey &= ~0x000000ff;
						tmpkey |= ((ULONG)*(pKey) << 0);
						break;
					case 1:
						tmpkey &= ~0x0000ff00;
						tmpkey |= ((ULONG)*(pKey) << 8);
						break;
					case 2:
						tmpkey &= ~0x00ff0000;
						tmpkey |= ((ULONG)*(pKey) << 16);
						break;
					case 3:
						tmpkey &= ~0xff000000;
						tmpkey |= ((ULONG)*(pKey) << 24);
						break;
					}
					pKey++;
					ZD1205_WRITE_REGISTER(Adapter,WEPKey0+i, tmpkey);
				}
#endif
				
			}
			Status = NDIS_STATUS_SUCCESS;
			break;
	    case OID_802_11_ADD_KEY:// Set
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_ADD_KEY\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_ADD_KEY:
			{
				//WPA support
				PNDIS_802_11_KEY	pNdis80211Key;
				ULONG				keyIndex;
				int 				i;
				ULONG				tmpkey;
				pNdis80211Key=(PNDIS_802_11_KEY)InformationBuffer;

				DebugPrint = TRUE;
				INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_ADD_KEY******\n")));

				// Don't enable the code below, cause WEP64 can't use by Zero Config
				if (pNdis80211Key->KeyIndex == 0xC0000001)					
					return NDIS_STATUS_INVALID_DATA;	
				
				//if (pNdis80211Key->BSSID[0] & BIT_0)
				//	return NDIS_STATUS_INVALID_DATA;	
				
				INITSTRWPA((_T("Associated to BSSID=")));
				DumpWPA(pNdis80211Key->BSSID,6, FALSE, 1);
				if (pNdis80211Key->KeyIndex & BIT_29){
					INITSTRWPA((_T("KeyRSC=")));
					DumpWPA((CHAR*)&pNdis80211Key->KeyRSC,8, FALSE, 1);
				}
				else{
					INITSTRWPA((_T("IV set by NIC\n")));
				}
				INITSTRWPA((_T("pNdis80211Key->KeyIndex = %x\n"),pNdis80211Key->KeyIndex));
				INITSTRWPA((_T("pNdis80211Key->KeyLength = %d\n"),pNdis80211Key->KeyLength));
				INITSTRWPA((_T("KeyMaterial=")));
				DumpWPA(pNdis80211Key->KeyMaterial,pNdis80211Key->KeyLength,FALSE,1);
				
				Adapter->wepKeyLen=(UCHAR)pNdis80211Key->KeyLength;
				keyIndex=pNdis80211Key->KeyIndex & 255;
				if ((pNdis80211Key->KeyIndex & (BIT_31+BIT_30))==(BIT_31+BIT_30)){
					// Set Pairwise key
					if (keyIndex==0){//The key index should be set to zero for a pairwise key.
						INITSTRTX(DebugPrint, (_T("*****Set Pairwise key, keyIndex = 0 *****\n")));
						Adapter->CardSetting.EncryKeyId = (UCHAR)keyIndex;
						INITSTRWPA((_T("Adapter->CardSetting.EncryKeyId = %d\n"),Adapter->CardSetting.EncryKeyId));
						INITSTRWPA((_T("*****Change_EncryMode to TKIP\n")));
						Change_EncryMode(Adapter, TKIP, TKIP);
						Tkip_Init(pNdis80211Key->KeyMaterial, 
							Adapter->AiNodeAddress,
							&Adapter->TxSeed,
							(BYTE*)&pNdis80211Key->KeyRSC);
							
						Tkip_Init(pNdis80211Key->KeyMaterial, //for Rx
							Adapter->BSSID,
							&Adapter->RxSeed[keyIndex],
							(BYTE*)&pNdis80211Key->KeyRSC);
						
						INITSTRWPA((_T("Adapter->RxSeed.IV16 = %d\n"),Adapter->RxSeed[keyIndex].IV16));
						INITSTRWPA((_T("Adapter->RxSeed.IV32 = %d\n"),Adapter->RxSeed[keyIndex].IV32));
						
#ifndef AMAC						
						//set pairwise key to HMAC
						for (i=0; i<16; i++){
							ZD1205_READ_REGISTER(Adapter,WEPKey0+4*i, &tmpkey);
							tmpkey &= ~0x000000ff; //keyIndex = 0
							tmpkey |= Adapter->TxSeed.TK[i];
							ZD1205_WRITE_REGISTER(Adapter,WEPKey0+4*i, tmpkey);
						}	
#endif
						INITSTRWPA((_T("Dump TK =")));
						DumpWPA(Adapter->TxSeed.TK, 16, FALSE, 1); 
						//yarco
						if (Adapter->wepKeyLen == 32){ //TKIP
							INITSTRWPA((_T("TKIP\n")));
							//memcpy(Adapter->AllKeyBuf+16*keyIndex, &Adapter->TxSeed.TK[0], 16);
							
							if (Adapter->encryMode == Ndis802_11Encryption2Enabled){
								INITSTR((_T("CAM_TKIP Mode\n")));
								Change_EncryMode(Adapter, TKIP, TKIP);
								SetKeyContext(Adapter, DEFAULT_KEY_SET, TKIP, 
										(UCHAR)keyIndex, Adapter->TxSeed.TK);
							}	
							
							if (pNdis80211Key->KeyIndex & BIT_28){ //AP
								MICsetKey(&pNdis80211Key->KeyMaterial[16],
									&Adapter->TxMicKey);
								MICsetKey(&pNdis80211Key->KeyMaterial[24],
									&Adapter->RxMicKey[keyIndex]);
							}
							else{ //STA
							// The key is being set by a Supplicant.
								MICsetKey(&pNdis80211Key->KeyMaterial[16],
									&Adapter->RxMicKey[keyIndex]);	
								MICsetKey(&pNdis80211Key->KeyMaterial[24],
									&Adapter->TxMicKey);
									
								INITSTRWPA((_T("RxMicKey=")));
								DumpWPA((char *)Adapter->RxMicKey,8,FALSE,1);	
								INITSTRWPA((_T("TxMicKey=")));
								DumpWPA((char *)&Adapter->TxMicKey,8,FALSE,1);
							}
						}
						else if (Adapter->wepKeyLen == 16){ //AES
							if (Adapter->encryMode == Ndis802_11Encryption3Enabled){
								INITSTRTX(DebugPrint, (_T("CAM_AEC_CCM Mode\n")));			
								Change_EncryMode(Adapter, AES, AES);
								SetKeyContext(Adapter, DEFAULT_KEY_SET, AES, 
										(UCHAR)keyIndex, Adapter->TxSeed.TK);
								//for Broadcom AES CCMP fragment compability, disable frag num mask.		
								ZD1205_WRITE_REGISTER(Adapter,TX_CCM_MASK, 0x390);	// Modified by jxiao to fix Rx Multicast packet decrypt error
								ZD1205_WRITE_REGISTER(Adapter,RX_CCM_MASK, 0x390);
									
							}	
						}	
						//Adapter->wepStatus = Ndis802_11Encryption2Enabled;
#if DBG						
						ZD1205_READ_REGISTER(Adapter,CAM_MODE, &IoValue);				
						ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, (IoValue | HOST_RW));
						INITSTRWPA((_T(" Dumping CAM memory.........\n")));
						for (i=386; i<390; i++){
							ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, i);
							// Read twice to ensure valid data
							ZD1205_READ_REGISTER(Adapter,CAM_DATA, &tmpvalue);
							ZD1205_READ_REGISTER(Adapter,CAM_DATA, &tmpvalue);
							INITSTRWPA((_T("Addr: %d    Content: %8X\n"), i, tmpvalue));
						}
						ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, IoValue);			
#endif										
						Adapter->keyMgrState=0; // Allow the reporting of Auth_KeyUpdate event.
						Adapter->WepStatus=1;
						Adapter->iv16=0;
						Adapter->iv32=0;
						Adapter->PkInstalled = 1;
					}
					else
						return NDIS_STATUS_INVALID_DATA;
				}
				
				if ((pNdis80211Key->KeyIndex & (BIT_31+BIT_30))==0){
					// Set Group key for receive only
					if (keyIndex <= 3){
						INITSTRTX(DebugPrint, (_T("*****Set Group key******\n")));
						INITSTRWPA((_T("Group key index = %d\n"), keyIndex));
						Tkip_Init(pNdis80211Key->KeyMaterial, 
							Adapter->BSSID,
							&Adapter->RxSeed[keyIndex],
							(BYTE*)&pNdis80211Key->KeyRSC);
						
#ifndef AMAC						
						//set group key to HMAC
						for (i=0; i<16; i++){
							ZD1205_READ_REGISTER(Adapter,WEPKey0+4*i, &tmpkey);
							switch(keyIndex){
								case 1:
									tmpkey &= ~0x0000ff00;
									tmpkey |= ((ULONG)Adapter->RxSeed[keyIndex].TK[i] << 8);
									break;
									
								case 2:
									tmpkey &= ~0x00ff0000;
									tmpkey |= ((ULONG)Adapter->RxSeed[keyIndex].TK[i] << 16);
									break;
									
								case 3:
									tmpkey &= ~0xff000000;
									tmpkey |= ((ULONG)Adapter->RxSeed[keyIndex].TK[i] << 24);
									break;		
	
							}	
							ZD1205_WRITE_REGISTER(Adapter,WEPKey0+4*i, tmpkey);
						}	
#endif					
						//set group key to HMAC	
						if (Adapter->encryMode == Ndis802_11Encryption2Enabled){
							SetKeyContext(Adapter, DEFAULT_KEY_SET, TKIP, 
								(UCHAR)keyIndex, Adapter->RxSeed[keyIndex].TK);
							if ((pNdis80211Key->KeyIndex & BIT_29)==0){
							// RSC set by a Supplicant
								Adapter->RxSeed[keyIndex].IV16= 0;
								Adapter->RxSeed[keyIndex].IV32 = 0;
							}
							
							if (pNdis80211Key->KeyIndex & BIT_28){
								MICsetKey(&pNdis80211Key->KeyMaterial[24],
									&Adapter->RxMicKey[keyIndex]);	
							}
							else{
							 // The key is being set by a Supplicant.
								MICsetKey(&pNdis80211Key->KeyMaterial[16],
									&Adapter->RxMicKey[keyIndex]);	
							}
						}			
						else if  (Adapter->encryMode == Ndis802_11Encryption3Enabled){			
							SetKeyContext(Adapter, DEFAULT_KEY_SET, AES, 
								(UCHAR)keyIndex, Adapter->RxSeed[keyIndex].TK);
						}
						
						Adapter->groupKeyIndex=(UCHAR)keyIndex;
						Adapter->GkInstalled = 1;
					}
				}
				
				if ((pNdis80211Key->KeyIndex & (BIT_31+BIT_30))==BIT_31){
					// Set Group key for transmit key and receive key
					// Also used to  configure the key of legacy WEP.
					if (keyIndex <= 3){
						if (pNdis80211Key->KeyLength == 32){
						 	// For TKIP
						 	INITSTRTX(DebugPrint, (_T("*****Set Group key as Transmit key******\n")));
							ZDDbgPrint((_T("key index = %d\n"), keyIndex));

							Adapter->CardSetting.EncryKeyId = (UCHAR)keyIndex;							
						 	Change_EncryMode(Adapter, TKIP, TKIP);
							Tkip_Init(pNdis80211Key->KeyMaterial,
								Adapter->AiNodeAddress,
								&Adapter->TxSeed,
								(BYTE*)&pNdis80211Key->KeyRSC);

							//set key to HMAC
							for (i=0; i<16; i++){
								ZD1205_READ_REGISTER(Adapter,WEPKey0+4*i, &tmpkey);
								switch(keyIndex){
									case 0:
										tmpkey &= ~0x000000ff;
										tmpkey |= ((ULONG)Adapter->TxSeed.TK[i]);
										break;
									case 1:
										tmpkey &= ~0x0000ff00;
										tmpkey |= ((ULONG)Adapter->TxSeed.TK[i] << 8);
										break;
									case 2:
										tmpkey &= ~0x00ff0000;
										tmpkey |= ((ULONG)Adapter->TxSeed.TK[i] << 16);
										break;
									case 3:
										tmpkey &= ~0xff000000;
										tmpkey |= ((ULONG)Adapter->TxSeed.TK[i] << 24);
										break;		
	
									ZD1205_WRITE_REGISTER(Adapter,WEPKey0+4*i, tmpkey);
								}	
							}	
							Tkip_Init(pNdis80211Key->KeyMaterial,
								Adapter->BSSID,
								&Adapter->RxSeed[keyIndex],
								(BYTE*)&pNdis80211Key->KeyRSC);

							if (pNdis80211Key->KeyIndex & BIT_28){
								MICsetKey(&pNdis80211Key->KeyMaterial[16],
									&Adapter->TxMicKey);
									
								MICsetKey(&pNdis80211Key->KeyMaterial[24],
									&Adapter->RxMicKey[keyIndex]);
							}
							else{
							// The key is being set by a Supplicant.
								MICsetKey(&pNdis80211Key->KeyMaterial[16],
									&Adapter->RxMicKey[keyIndex]);
									
								if (Adapter->CardSetting.AuthMode==Ndis802_11AuthModeWPANone &&
									(Adapter->CardSetting.BSSType==INDEPENDENT_BSS)){
									MICsetKey(&pNdis80211Key->KeyMaterial[16],
										&Adapter->TxMicKey);
									if (keyIndex ==0){
										NdisMoveMemory(Adapter->RxSeed[keyIndex].TK,
											pNdis80211Key->KeyMaterial,
											32);
									}
								}
								else{
									MICsetKey(&pNdis80211Key->KeyMaterial[24],
										&Adapter->TxMicKey);
								}
							}
							Adapter->iv16=0;
							Adapter->iv32=0;
							Adapter->WepStatus |= (1 << keyIndex);
							Adapter->PkInstalled = 1;
						}
						else{
						 	// For Legacy WEP, Key Length is either  5 or 13
							//Adapter->wepStatus = Ndis802_11Encryption1Enabled;
							Adapter->wepKeyLen=(UCHAR)pNdis80211Key->KeyLength;
							//MP_MOVE_MEM (Adapter->RxSeed[keyIndex].TK,  // Set WEP key for S/W decryption.
								//pNdis80211Key->KeyMaterial,
								//pNdis80211Key->KeyLength);
								
							Adapter->CardSetting.EncryKeyId=(UCHAR)keyIndex;
							pKey = (PCHAR)pNdis80211Key->KeyMaterial;
							if (Adapter->wepKeyLen == 5){
								INITSTR((_T("WEP64\n")));
								memcpy(Adapter->AllKeyBuf+5*keyIndex, pKey, 5);
								Change_EncryMode(Adapter, WEP64, WEP64);
								//ZD1205_WRITE_REGISTER(Adapter,EncryType, 0xa); // For WEP 64
								loop = 20;
								SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP64, 
										(UCHAR)keyIndex, pKey);
							}
							else if (Adapter->wepKeyLen == 13){
								INITSTR((_T("WEP128\n")));
								memcpy(Adapter->AllKeyBuf+13*keyIndex, pKey, 13);
								Change_EncryMode(Adapter, WEP128, WEP128);
								loop = 52;
								SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP128, 
										(UCHAR)keyIndex, pKey);
							}
							else if (Adapter->wepKeyLen == 29){
								INITSTR((_T("WEP256\n")));
								memcpy(Adapter->AllKeyBuf+29*keyIndex, pKey, 29);
								Change_EncryMode(Adapter, WEP256, WEP256);
								loop = 52;
								SetKeyContext(Adapter, DEFAULT_KEY_SET, WEP256, 
										(UCHAR)keyIndex, pKey);
							}
							else{
								Status = NDIS_STATUS_FAILURE;
								break;
							}
#ifndef AMAC
							for (i=0; i<loop; i+=4){
								ZD1205_READ_REGISTER(Adapter,WEPKey0+i, &tmpkey);
								switch(keyIndex){
									case 0:
										tmpkey &= ~0x000000ff;
										tmpkey |= ((ULONG)*(pKey) << 0);
										break;
									case 1:
										tmpkey &= ~0x0000ff00;
										tmpkey |= ((ULONG)*(pKey) << 8);
										break;
									case 2:
										tmpkey &= ~0x00ff0000;
										tmpkey |= ((ULONG)*(pKey) << 16);
										break;
									case 3:
										tmpkey &= ~0xff000000;
										tmpkey |= ((ULONG)*(pKey) << 24);
										break;
								}
								pKey++;
								ZD1205_WRITE_REGISTER(Adapter,WEPKey0+i, tmpkey);
							}
#endif
							Adapter->WepStatus |= (1 << keyIndex);
						}
						Adapter->groupKeyIndex=(UCHAR)keyIndex;
						Adapter->PkInstalled = 1;
						Adapter->GkInstalled = 1;
					}
				}
				*BytesRead=pNdis80211Key->Length;
		    	return NDIS_STATUS_SUCCESS;
	        	break;
	    	}
		case OID_802_11_WEP_STATUS:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_WEP_STATUS\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_WEP_STATUS:
		case OID_ZDX_802_11_WEP_STATUS:
			DebugPrint = TRUE;
			//INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_WEP_STATUS\n")));
			if (InformationBufferLength == 0){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			tmpvalue = *(PULONG)InformationBuffer;
			if ( tmpvalue == Ndis802_11WEPDisabled ){
				Change_EncryMode(Adapter, NO_WEP, NO_WEP);
				Adapter->encryMode = Ndis802_11WEPDisabled;
				ZDDbgPrint((_T("Set WEP Status = %d NO WEP\n"), tmpvalue));
			}else if ( tmpvalue == Ndis802_11WEPEnabled ) // WEP
            {
		        Adapter->encryMode = (UCHAR) tmpvalue;
				ZDDbgPrint((_T("Set WEP Status = %d\n"), tmpvalue));
			}
            else if ( tmpvalue == Ndis802_11Encryption2Enabled )  // TKIP) {
            {
		        Adapter->encryMode = (UCHAR) tmpvalue;
				ZDDbgPrint((_T("Set WEP Status = %d\n"), tmpvalue));				
				INITSTRTX(DebugPrint, (_T("*****Set EncryMode to TKIP\n")));
			}
			else if ( tmpvalue == Ndis802_11Encryption3Enabled )  // AES) {
            {
		        Adapter->encryMode = (UCHAR) tmpvalue;
		        ZDDbgPrint((_T("Set WEP Status = %d\n"), tmpvalue));
				INITSTRTX(DebugPrint, (_T("*****Set EncryMode to AES\n")));								
			}
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_REMOVE_WEP:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_REMOVE_WEP\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_REMOVE_WEP:
		case OID_ZDX_802_11_REMOVE_WEP:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_REMOVE_WEP\n")));
			tmpvalue = *(PULONG)InformationBuffer;
			if ( Adapter->CardSetting.EncryKeyId == tmpvalue )
			    Change_EncryMode(Adapter, NO_WEP, NO_WEP);
			Status = NDIS_STATUS_SUCCESS;
			break;
	    case OID_802_11_REMOVE_KEY://Set
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_REMOVE_KEY\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_REMOVE_KEY:
			/*{
		ULONG	keyIndex;
		PNDIS_802_11_REMOVE_KEY p80211RemoveKey=(PNDIS_802_11_REMOVE_KEY)infoBuffer_p;
		keyIndex = p80211RemoveKey->KeyIndex & 255;
		if (p80211RemoveKey->KeyIndex & 0xB0000000)
			return NDIS_STATUS_INVALID_DATA;
		Tkip_clear(&adapter_p->RxSeed[keyIndex]);
		if (keyIndex==0)
			Tkip_clear(&adapter_p->TxSeed);
		adapter_p->WepStatus &= ~(1 << keyIndex);
        	}*/
 			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_DISASSOCIATE:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_DISASSOCIATE\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_DISASSOCIATE:
		case OID_ZDX_802_11_DISASSOCIATE:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_DISASSOCIATE\n")));
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
				Adapter->NotCheckConnect = 1;
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZDDbg((_T("---------->>> Release SpinLock\n")));
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
			Mgt_SendNotification(Adapter, RQ_DISCONNECT);
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_AUTHENTICATION_MODE:
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_AUTHENTICATION_MODE\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZD_802_11_AUTHENTICATION_MODE:
		case OID_ZDX_802_11_AUTHENTICATION_MODE:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_ZD_802_11_AUTHENTICATION_MODE\n")));
			if (InformationBufferLength == 0){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			mode = (PUINT) InformationBuffer;
			if ( Adapter->WPAOn )
				AuthenticationModeMax = Ndis802_11AuthModeMax;
			else
                AuthenticationModeMax = 3;
               
			if ( *mode >= AuthenticationModeMax ){
                Status=NDIS_STATUS_INVALID_DATA;
			}else{
				Adapter->CardSetting.AuthMode = (UCHAR) *mode;
				ZDDbgPrint((_T("Set Authentication Mode = %d\n"), *mode));
			    Status = NDIS_STATUS_SUCCESS;
			}
			break;
        case OID_802_11_ASSOCIATION_INFORMATION://Set, Not finished yet!
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_ASSOCIATION_INFORMATION\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_ASSOCIATION_INFORMATION:
/*{
PNDIS_802_11_ASSOCIATION_INFORMATION pAssoInfo;
	pAssoInfo=(PNDIS_802_11_ASSOCIATION_INFORMATION)infoBuffer_p;
	return NDIS_STATUS_SUCCESS;
}*/ 
            return NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_TEST://Set
            if ( Adapter->ZDConfigRunning ){
                INITSTRTX(DebugPrint, (_T("ZDConfig is running = %x\n"), Adapter->ZDConfigRunning));
			    INITSTRTX(DebugPrint, (_T("OID_802_11_ASSOCIATION_INFORMATION\n")));
				Status = NDIS_STATUS_SUCCESS;
				break;
			}
		case OID_ZDX_802_11_TEST:
/*{
PNDIS_802_11_TEST	p80211Test=(PNDIS_802_11_TEST)infoBuffer_p;
NDIS_STATUS	GeneralStatus=NDIS_STATUS_MEDIA_SPECIFIC_INDICATION;
	if (p80211Test->Type==1)
	{
		NdisMIndicateStatus(adapter_p->MiniportAdapterHandle,
			GeneralStatus,
			&p80211Test->AuthenticationEvent,
			p80211Test->Length-8);
	}
	else if(p80211Test->Type==2)
	{
		NdisMIndicateStatus(adapter_p->MiniportAdapterHandle,
			GeneralStatus,
			&p80211Test->RssiTrigger,
			p80211Test->Length-8);
	}
	else
	{
		return NDIS_STATUS_INVALID_DATA; 
	}
	*bytesRead_p=p80211Test->Length;
	break;
}*/
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_PRIVACY_FILTER:
			INITSTRTX(DebugPrint, (_T("OID_802_11_PRIVACY_FILTER\n")));
			Adapter->func8021x = (USHORT)*(PULONG)InformationBuffer;
			Status = NDIS_STATUS_SUCCESS;
			break;
		case OID_802_11_RELOAD_DEFAULTS:
			DebugPrint = TRUE;
			INITSTRTX(DebugPrint, (_T("OID_802_11_RELOAD_DEFAULTS\n")));
			INITSTRTX(DebugPrint, (_T("No action\n")));
			Status = NDIS_STATUS_SUCCESS;
			break;
//#endif //NDIS51_MINIPORT

		case OID_802_11_POWER_MODE:

			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			tmpvalue = *(PULONG)InformationBuffer;
		
			DebugPrint = 1;
			
			INITSTRTX(DebugPrint, (_T("OID_802_11_POWER_MODE %d\n"), tmpvalue));
				
			if (tmpvalue == Ndis802_11PowerModeCAM){
				Adapter->PSMSupported = 0;
				Adapter->CardSetting.ATIMWindow = 0x0;
				Adapter->TestPS = 0;
				Adapter->SuggestionMode = CAM;
				Adapter->PwrState = CAM;
	
				TurnOn_RF(Adapter);
			}
			else{
				Adapter->PSMSupported = 1;
				Adapter->CardSetting.ATIMWindow = 0x5;

				if (tmpvalue == Ndis802_11PowerModeMAX_PSP)
					Adapter->TestPS = 1;

				if (tmpvalue == Ndis802_11PowerModeFast_PSP)
					Adapter->TestPS = 0;
			}
			tmpvalue = Adapter->CardSetting.BeaconInterval;
			UpdatePreTBTT(Adapter, tmpvalue-5);
			
			Mgt_SendNotification(Adapter, RQ_DISCONNECT);			
			Mgt_SendNotification(Adapter, RQ_CONNECTNETWORK);

			Status = NDIS_STATUS_SUCCESS;
			
			break;
		
		case OID_802_11_TX_POWER_LEVEL:

			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			
			INITSTRTX(DebugPrint, (_T("OID_802_11_TX_POWER_LEVEL\n")));
			
			tmpvalue = *(NDIS_802_11_TX_POWER_LEVEL *)InformationBuffer;
				
			// need transform
			//Write_TxGain1(Adapter, (UCHAR) tmpvalue, cTX_CCK);
			//Write_TxGain1(Adapter, (UCHAR) tmpvalue, cTX_OFDM);

			Status = NDIS_STATUS_SUCCESS;
			
			break;

		case OID_802_11_FRAGMENTATION_THRESHOLD:
			
			DebugPrint = 1;
		
			INITSTRTX(DebugPrint, (_T("OID_802_11_FRAGMENTATION_THRESHOLD %d\n"), InformationBufferLength));

			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			
			
			tmpvalue = *(NDIS_802_11_FRAGMENTATION_THRESHOLD *)InformationBuffer;

			Adapter->CardSetting.FragThreshold = tmpvalue;
			
			INITSTRTX(DebugPrint, (_T("OID_802_11_FRAGMENTATION_THRESHOLD %d\n"), tmpvalue));

			Status = NDIS_STATUS_SUCCESS;
			
			break;

		case OID_802_11_RTS_THRESHOLD:
		
			DebugPrint = 1;

			INITSTRTX(DebugPrint, (_T("OID_802_11_RTS_THRESHOLD %d\n"), InformationBufferLength));
			
			if (InformationBufferLength != 4){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}
			
			tmpvalue = *(PULONG)InformationBuffer;
	
			INITSTRTX(DebugPrint, (_T("OID_802_11_RTS_THRESHOLD %d\n"), tmpvalue));

			Adapter->CardSetting.RTSThreshold = tmpvalue;

			Status = NDIS_STATUS_SUCCESS;
			
			break;
	
		case OID_802_11_DESIRED_RATES:

			if (InformationBufferLength > RATEARRAY_NUM){
				Status =  (NDIS_STATUS_INVALID_LENGTH);
				break;
			}

			DebugPrint = 1;
			INITSTRTX(DebugPrint, (_T("OID_802_11_DESIRED_RATES %d\n"), InformationBufferLength));
		
			//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
			ZDDbg((_T("Get SpinLock\n")));
			ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);

			j = 0;
			for(i=0; i<(USHORT)InformationBufferLength; i++){

				if (Rate_Convert((UCHAR)((*((PUCHAR)InformationBuffer+i)) & 0x7F), 0) > 0xb) continue;	//invalid rate

				Adapter->AllowRateArray[j] = Rate_Convert(*((PUCHAR)InformationBuffer+i), 0); 
	
				INITSTRTX(DebugPrint, (_T("allow rate 0x%x\n"), Adapter->AllowRateArray[j]));
		
				j++;
			}

			Adapter->AllowRateArrayCount = (USHORT)j;
			
			//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
			ZDDbg((_T("---------->>> Release SpinLock\n")));
			ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
			//**************************************************
			// need notify firmware
			//**************************************************

			ClearOppositeRateInfo(Adapter);
			{
				BOOLEAN	bRet;
				bRet = BuildOppositeRateInfo(	Adapter, 
												Adapter->BSSID, 
												Adapter->CardSetting.Info_SupportedRates,
												Adapter->CardSetting.Capability,
												0);
#if	(defined(GCCK) && defined(OFDM))
				if (Adapter->CardSetting.Info_ExtSupportedRates[1]){
					if (bRet)
						BuildOppositeRateInfo(	Adapter, 
												Adapter->BSSID, 
												Adapter->CardSetting.Info_ExtSupportedRates, 
												Adapter->CardSetting.Capability,
												1);
				}
			}
#endif

			Status = NDIS_STATUS_SUCCESS;
			
			break;

		default:
			INITSTRTX(DebugPrint, (_T("default\n")));
			*BytesRead = InformationBufferLength;
			Status = NDIS_STATUS_NOT_SUPPORTED;
			break;
	}
#ifndef HOST_IF_USB
	//KeReleaseSpinLock(&Adapter->Lock, OldIrql);
#endif

    //DbgPrint("      status = %x\n", Status);

    return(Status);
}

//-----------------------------------------------------------------------------
// Procedure:   ZD1205QueryInformation
//
// Description: ZD1205QueryInformation handles a query operation for a single
//              OID. Basically we return information about the current state of
//              the OID in question.
//
// Arguments:
//      MiniportAdapterContext - The context value returned by the Miniport
//                               when the adapter was initialized (see the call
//                               NdisMSetAttributes. In reality, it is a
//                               pointer to ZD1205_ADAPTER.
//      Oid - The Oid that is to be queried.
//      InformationBuffer -  A pointer to the buffer that holds the result of
//                           the query.
//      InformationBufferLength - The length of InformationBuffer.
//
// Result:
//      BytesWritten - If the call is successful, returns the number of bytes
//                     written into InformationBuffer.
//      BytesNeeded - If there is not enough data in OvbBuffer to satisfy the
//                    OID, returns the amount of storage needed.
//
// Returns:
//      NDIS_STATUS_SUCCESS
//      NDIS_STATUS_NOT_SUPPORTED
//      NDIS_STATUS_BUFFER_TO_SHORT
//-----------------------------------------------------------------------------

#ifdef HOST_IF_USB
#define VENDORDESCRIPTOR	"ZyDAS ZD1211 wireless lan Adapter"
#elif defined(OFDM)
#define VENDORDESCRIPTOR	"ZyDAS ZD1212 wireless lan Adapter"
#else
#define VENDORDESCRIPTOR	"ZyDAS ZD1205 wireless lan Adapter"
#endif

NDIS_STATUS
ZD1205QueryInformation(
                     IN NDIS_HANDLE MiniportAdapterContext,
                     IN NDIS_OID Oid,
                     IN PVOID InformationBuffer,
                     IN ULONG InformationBufferLength,
                     OUT PULONG BytesWritten,
                     OUT PULONG BytesNeeded
                     )

{
    // order is important here because the OIDs should be in order
    // of increasing value
    static
    NDIS_OID        ZD1205GlobalSupportedOids[] =
    {
        OID_GEN_SUPPORTED_LIST,
        OID_GEN_HARDWARE_STATUS,
        OID_GEN_MEDIA_SUPPORTED,
        OID_GEN_MEDIA_IN_USE,
        OID_GEN_MAXIMUM_LOOKAHEAD,
        OID_GEN_MAXIMUM_FRAME_SIZE,
        OID_GEN_LINK_SPEED,
        OID_GEN_TRANSMIT_BUFFER_SPACE,
        OID_GEN_RECEIVE_BUFFER_SPACE,
        OID_GEN_TRANSMIT_BLOCK_SIZE,
        OID_GEN_RECEIVE_BLOCK_SIZE,
        OID_GEN_VENDOR_ID,
        OID_GEN_VENDOR_DESCRIPTION,
        OID_GEN_CURRENT_PACKET_FILTER,
        OID_GEN_CURRENT_LOOKAHEAD,
        OID_GEN_DRIVER_VERSION,
        OID_GEN_VENDOR_DRIVER_VERSION,
        OID_GEN_MAXIMUM_TOTAL_SIZE,
        OID_GEN_PROTOCOL_OPTIONS,
        OID_GEN_MAC_OPTIONS,
        OID_GEN_MEDIA_CONNECT_STATUS,
        OID_GEN_MAXIMUM_SEND_PACKETS,
        OID_GEN_SUPPORTED_GUIDS,
        OID_GEN_XMIT_OK,
        OID_GEN_RCV_OK,
		OID_GEN_DIRECTED_BYTES_XMIT,
		OID_GEN_DIRECTED_BYTES_RCV,
        OID_GEN_XMIT_ERROR,
        OID_GEN_RCV_ERROR,
        OID_GEN_RCV_NO_BUFFER,
        OID_GEN_RCV_CRC_ERROR,
        OID_GEN_TRANSMIT_QUEUE_LENGTH,
        OID_802_3_PERMANENT_ADDRESS,
        OID_802_3_CURRENT_ADDRESS,
        OID_802_3_MULTICAST_LIST,
        OID_802_3_MAXIMUM_LIST_SIZE,
        /* for ndis 4 packet priority
        OID_802_3_MAC_OPTIONS,
        */
        OID_802_3_RCV_ERROR_ALIGNMENT,
        OID_802_3_XMIT_ONE_COLLISION,
        OID_802_3_XMIT_MORE_COLLISIONS,
        OID_802_3_XMIT_DEFERRED,
        OID_802_3_XMIT_MAX_COLLISIONS,
        OID_802_3_RCV_OVERRUN,
        OID_802_3_XMIT_UNDERRUN,
        OID_802_3_XMIT_HEARTBEAT_FAILURE,
        OID_802_3_XMIT_TIMES_CRS_LOST,
        OID_802_3_XMIT_LATE_COLLISIONS,
        /* tcp/ip checksum offload */
        /*
        OID_TCP_TASK_OFFLOAD,
        */

		/* For 802.11 OIDs */
//#ifdef NDIS51_MINIPORT
        OID_GEN_PHYSICAL_MEDIUM,                // Query
        OID_802_11_BSSID,                       // Query and Set
        OID_802_11_SSID,                        // Query and Set
        OID_802_11_NETWORK_TYPE_IN_USE,         // Query and Set
		OID_802_11_POWER_MODE,					// Query and Set
		OID_802_11_TX_POWER_LEVEL,				// Query and Set
		OID_802_11_RSSI,                        // Query and Indication
        OID_802_11_RSSI_TRIGGER,                // Query and Indication
        OID_802_11_BSSID_LIST,                  // Query
        OID_802_11_BSSID_LIST_SCAN,             // Set
        OID_802_11_INFRASTRUCTURE_MODE,         // Query and Set
		OID_802_11_FRAGMENTATION_THRESHOLD,		
        OID_802_11_RTS_THRESHOLD,
		OID_802_11_SUPPORTED_RATES,             // only query
        OID_802_11_DESIRED_RATES,
		OID_802_11_CONFIGURATION,               // Query and Set
        OID_802_11_STATISTICS,                  // Query
        OID_802_11_ADD_WEP,                     // Set
        OID_802_11_WEP_STATUS,                  // Query and Set
        OID_802_11_REMOVE_WEP,                  // Set
        OID_802_11_DISASSOCIATE,                // Set
        OID_802_11_AUTHENTICATION_MODE,         // Query and Set
        OID_802_11_RELOAD_DEFAULTS,             // Set
		OID_802_11_PRIVACY_FILTER,              // Query and Set for 8021x
//#endif
        /* powermanagement */
        OID_PNP_CAPABILITIES,
        OID_PNP_SET_POWER,
        OID_PNP_QUERY_POWER,
        OID_PNP_ADD_WAKE_UP_PATTERN,
        OID_PNP_REMOVE_WAKE_UP_PATTERN,
        OID_PNP_ENABLE_WAKE_UP,
        /* end powermanagement */
        /* custom oid WMI support */
        OID_CUSTOM_DRIVER_SET,
        OID_CUSTOM_DRIVER_QUERY,
        OID_CUSTOM_ARRAY,
        OID_CUSTOM_STRING

    };


    // String describing our adapter
    char VendorDescriptor[] = VENDORDESCRIPTOR;


    PZD1205_ADAPTER   Adapter;

    UCHAR           VendorId[4];

    NDIS_MEDIUM     Medium = NdisMedium802_3;
    NDIS_HARDWARE_STATUS HardwareStatus = NdisHardwareStatusReady;

    UINT            GenericUlong;
    USHORT          GenericUShort;
    UCHAR           GenericArray[6];

    NDIS_STATUS     Status = NDIS_STATUS_SUCCESS;


    // Common variables for pointing to result of query
    PVOID           MoveSource = (PVOID) (&GenericUlong);
    ULONG           MoveBytes = sizeof(GenericUlong);
    PVOID           MoveSource2 = 0;
    ULONG           MoveBytes2 = 0;
	USHORT			i,j;
	ULONG			DebugPrint;
    UCHAR           GenericArray2[14];

//#ifdef NDIS51_MINIPORT
    PNDIS_802_11_BSSID_LIST        pZDBSSIDList;
    PNDIS_802_11_BSSID_LIST_EX     pBSSIDList;
    PNDIS_802_11_CONFIGURATION  pConfiguration;
    NDIS_802_11_SSID            Ssid;
	PNDIS_802_11_NETWORK_TYPE_LIST	pNdis80211NTList;
	PNDIS_WLAN_BSSID_EX pBssid;
	PUCHAR          pch;
//#endif

    DEBUGFUNC(_T("ZD1205QueryInformation"));

    Adapter = PZD1205_ADAPTER_FROM_CONTEXT_HANDLE(MiniportAdapterContext);

	DebugPrint = Adapter->DbgMsgFlag & DBGMSG_OID;
    // Initialize the result
    *BytesWritten = 0;
    *BytesNeeded = 0;


	//DbgPrint("query oid = %x\r\n", Oid);

    // Switch on request type
    switch (Oid)
    {

	case OID_ZD_GET_TALLIES_1202:
	case OID_ZD_GET_TALLIES:
	case OID_ZD_IO_READ:
	case OID_ZD_CMD:
	case OID_ZD_GETRID:
	case OID_ZD_802_11_BSSID_LIST:
	case OID_LINK_SIGNAL_STRENGTH:
	case OID_LINK_QUALITY:
	case OID_ZD_GET_STA_LIST:
	case OID_ZD_FILTER_LIST:
	case OID_ZD_FILTER_MODE:
	case OID_ZD_AP_MODE:

		Status = ZD1211Old_QueryInformation(
						MiniportAdapterContext,
						Oid,
						InformationBuffer,
						InformationBufferLength,
						BytesWritten,
						BytesNeeded
						);

		return Status;

	case OID_ZD_CUSTOM:
	case OID_ZD_RD:

		Status = ZD1211_Custom_QueryInformation(
						MiniportAdapterContext,
						Oid,
						InformationBuffer,
						InformationBufferLength,
						BytesWritten,
						BytesNeeded
						);

		return Status;

	case OID_GEN_MAC_OPTIONS:
		INITSTRTX(DebugPrint, (_T("OID_GEN_MAC_OPTIONS\n")));
        // NDIS_MAC_OPTION_COPY_LOOKAHEAD_DATA is set to indicate to the
        // protocol that it can access the lookahead data by any means that
        // it wishes.  On some systems there are fast copy routines that
        // may have trouble accessing shared memory.  Netcard drivers that
        // indicate data out of shared memory, should not have this flag
        // set on these troublesome systems  For the time being this driver
        // will set this flag.  This should be safe because the data area
        // of the RFDs is contained in uncached memory.

        // NOTE: Don't set NDIS_MAC_OPTION_RECEIVE_SERIALIZED if we
        // are doing multipacket (ndis4) style receives.

        GenericUlong = (ULONG)(NDIS_MAC_OPTION_TRANSFERS_NOT_PEND   |
            NDIS_MAC_OPTION_COPY_LOOKAHEAD_DATA  |
            NDIS_MAC_OPTION_NO_LOOPBACK
            );
        break;


    case OID_GEN_SUPPORTED_LIST:
		INITSTRTX(DebugPrint, (_T("OID_GEN_SUPPORTED_LIST\n")));

        MoveSource = (PVOID) (ZD1205GlobalSupportedOids);
        MoveBytes = sizeof(ZD1205GlobalSupportedOids);
        break;


    case OID_GEN_HARDWARE_STATUS:
		INITSTRTX(DebugPrint, (_T("OID_GEN_HARDWARE_STATUS\n")));

        MoveSource = (PVOID)(&HardwareStatus);
        MoveBytes = sizeof(NDIS_HARDWARE_STATUS);
        break;


    case OID_GEN_MEDIA_SUPPORTED:
    case OID_GEN_MEDIA_IN_USE:
		INITSTRTX(DebugPrint, (_T("OID_GEN_MEDIA_IN_USE\n")));

        MoveSource = (PVOID) (&Medium);
        MoveBytes = sizeof(NDIS_MEDIUM);
        break;

    case OID_GEN_MAXIMUM_LOOKAHEAD:
    case OID_GEN_CURRENT_LOOKAHEAD:
    case OID_GEN_MAXIMUM_FRAME_SIZE:
		INITSTRTX(DebugPrint, (_T("OID_GEN_MAXIMUM_FRAME_SIZE\n")));

        GenericUlong = MAXIMUM_ETHERNET_PACKET_SIZE - ENET_HEADER_SIZE;
        break;

    case OID_GEN_MAXIMUM_TOTAL_SIZE:
    case OID_GEN_TRANSMIT_BLOCK_SIZE:
    case OID_GEN_RECEIVE_BLOCK_SIZE:
		INITSTRTX(DebugPrint, (_T("OID_GEN_RECEIVE_BLOCK_SIZE\n")));

        GenericUlong = (ULONG) MAXIMUM_ETHERNET_PACKET_SIZE;
        break;

    case OID_GEN_VENDOR_DRIVER_VERSION:
		{
			ULONG ver = 0;
			UCHAR* time = __DATE__;

			switch (time[0])
			{
			    case 'J':
					if ( time[1] == 'u' )
						if ( time[2] == 'n' )
                            ver |= 0x600;
						else
							ver |= 0x700;
					else
						ver |= 0x100;
					break;
			    case 'A':
					if ( time[1] == 'p' )
                        ver |= 0x400;
					else
						ver |= 0x800;
					break;
			    case 'M':
					if ( time[2] == 'r' )
                        ver |= 0x300;
					else
						ver |= 0x500;
					break;
			    case 'D':
					ver |= 0xC00;
					break;
			    case 'F':
					ver |= 0x200;
					break;
			    case 'N':
					ver |= 0xB00;
					break;
			    case 'O':
					ver |= 0xA00;
					break;
			    case 'S':
					ver |= 0x900;
					break;
			}
			if ( (time[4] >= '0')&&( time[4] <= '9' ) )
                ver |= ((time[4] - 48) << 4);   // date
			ver |= (time[5] - 48);          // date
			ver |= ((time[10] - 48) << 12);  // year

			ver |= DRIVER_MKS_MAJOR_VERSION << 24;
			ver |= DRIVER_MKS_MINOR_VERSION << 16;

		    GenericUlong = ver;
		}
		break;

    case OID_GEN_TRANSMIT_BUFFER_SPACE:
		INITSTRTX(DebugPrint, (_T("OID_GEN_TRANSMIT_BUFFER_SPACE\n")));

        GenericUlong = (ULONG) MAXIMUM_ETHERNET_PACKET_SIZE *
            Adapter -> RegNumTcb;
        break;


    case OID_GEN_RECEIVE_BUFFER_SPACE:
		INITSTRTX(DebugPrint, (_T("OID_GEN_RECEIVE_BUFFER_SPACE\n")));

        GenericUlong = (ULONG) MAXIMUM_ETHERNET_PACKET_SIZE *
            Adapter -> NumRfd;
        break;


    case OID_GEN_VENDOR_ID:
		INITSTRTX(DebugPrint, (_T("OID_GEN_VENDOR_ID\n")));

        NdisMoveMemory(VendorId, Adapter->AiPermanentNodeAddress, 3);
        VendorId[3] = 0x0;
        MoveSource = (PVOID) VendorId;
        MoveBytes = sizeof(VendorId);
        break;


    case OID_GEN_VENDOR_DESCRIPTION:
		INITSTRTX(DebugPrint, (_T("OID_GEN_VENDOR_DESCRIPTION\n")));

        MoveSource = (PVOID) Adapter->vendorDesc;
        MoveBytes = Adapter->vendorDesclen;
        break;


    case OID_GEN_DRIVER_VERSION:
		INITSTRTX(DebugPrint, (_T("OID_GEN_DRIVER_VERSION\n")));

        GenericUShort = (USHORT) ZD1205_DRIVER_VERSION;
        MoveSource = (PVOID)(&GenericUShort);
        MoveBytes = sizeof(GenericUShort);
        break;

        // WMI support
    case OID_GEN_SUPPORTED_GUIDS:
 		INITSTRTX(DebugPrint, (_T("OID_GEN_SUPPORTED_GUIDS\n")));
		Status = NDIS_STATUS_NOT_SUPPORTED; //stub
        break;

        /*
        ******************************************************************************
        // Task Offload
        case OID_GEN_TASK_OFFLOAD:
        // here we set up the capabilities that we support
        // later the protocol will come back with a set requesting
        // some subset of the  specific capabilities we support.
        // this is all commented out because it is just a stub
        //


        //             TaskOffload.Size = sizeof(NDIS_TASK_OFFLOAD);
        //             TaskOffload.Task = NDIS_TASK_TCP_IP_CHECKSUM;
        //             // offsetnext should be 0 if this is the last task supported.
        //             TaskOffload.OffsetNextTask = (ULONG) (&TaskOffload + sizeof(NDIS_TASK_OFFLOAD));
        //             TaskOffload.TaskBufferLength = sizeof(NDIS_TASK_TCP_IP_CHECKSUM);
        //
        //             //set up our TaskBuffer
        //             TaskBufferDescriptor.Receive.TcpChecksum = TRUE;
        //             TaskOffload.TaskBuffer = &TaskBufferDescriptor;
        //
        //             MoveSource = (PVOID) &TaskOffload;
        //             MoveBytes = sizeof(NDIS_TASK_OFFLOAD) * NUM_TASKS_SUPPORTED;

          Status = NDIS_STATUS_NOT_SUPPORTED; // stub
          break;

        ******************************************************************************
        */
    case OID_802_3_PERMANENT_ADDRESS:
 		INITSTRTX(DebugPrint, (_T("OID_802_3_PERMANENT_ADDRESS\n")));

        ETH_COPY_NETWORK_ADDRESS(
            (PCHAR) GenericArray,
            Adapter->AiPermanentNodeAddress);

        MoveSource = (PVOID) (GenericArray);
        MoveBytes = ETH_LENGTH_OF_ADDRESS;
        break;


    case OID_802_3_CURRENT_ADDRESS:
 		INITSTRTX(DebugPrint, (_T("OID_802_3_CURRENT_ADDRESS\n")));

        ETH_COPY_NETWORK_ADDRESS(
            GenericArray,
            Adapter->AiNodeAddress);

        MoveSource = (PVOID) (GenericArray);
        MoveBytes = ETH_LENGTH_OF_ADDRESS;
        break;


    case OID_802_3_MAXIMUM_LIST_SIZE:
 		INITSTRTX(DebugPrint, (_T("OID_802_3_MAXIMUM_LIST_SIZE\n")));

        GenericUlong = (ULONG) MAX_MULTICAST_ADDRESSES;
        break;

    case OID_GEN_MAXIMUM_SEND_PACKETS:
 		INITSTRTX(DebugPrint, (_T("OID_GEN_MAXIMUM_SEND_PACKETS\n")));
        GenericUlong = (ULONG) MAX_ARRAY_SEND_PACKETS;
        break;

    case OID_GEN_LINK_SPEED:
		DebugPrint = 0;
        if ( (Adapter->CardSetting.LastSentTxRate > Adapter->CardSetting.LastSentRxRate)||
			 (Adapter->IPCFlag == 4) )
		    GenericUlong = 
		            Rate_Convert_to_MS(Adapter->CardSetting.LastSentTxRate) * 10000 / 2;
		else
		    GenericUlong = 
		            Rate_Convert_to_MS(Adapter->CardSetting.LastSentRxRate) * 10000 / 2;
		INITSTRTX(DebugPrint, (_T("OID_GEN_LINK_SPEED %d\n"), GenericUlong));
/*		switch (Adapter->CardSetting.LastSentTxRate){
			case 0:
				GenericUlong = 10000;
				break;
			case 1:
				GenericUlong = 20000;
				break;
			case 2:
				GenericUlong = 55000;
				break;
			case 3:
				GenericUlong = 110000;
				break;
			case 4:
				GenericUlong = 60000;
				break;
			case 5:
				GenericUlong = 90000;
				break;
			case 6:
				GenericUlong = 120000;
				break;
			case 7:
				GenericUlong = 180000;
				break;
			case 8:
				GenericUlong = 240000;
				break;
			case 9:
				GenericUlong = 360000;
				break;
			case 0xa:
				GenericUlong = 480000;
				break;
			case 0xb:
				GenericUlong = 540000;
				break;
		}
*/		break;
    case OID_GEN_MEDIA_CONNECT_STATUS:
/*
#ifdef NDIS51_MINIPORT
		if (Adapter->Notification & RQ_CONNECTNETWORK)
		{
			//ZDDbgPrint((_T("OID_GEN_MEDIA_CONNECT_STATUS pending\n")));
			ASSERT(!Adapter->bQueryPending);
			Adapter->bQueryPending = TRUE;
			Adapter->QueryRequest.Oid = Oid;                       
			Adapter->QueryRequest.InformationBuffer = InformationBuffer;                       
			Adapter->QueryRequest.InformationBufferLength = InformationBufferLength;
			Adapter->QueryRequest.BytesWritten = BytesWritten;                       
			Adapter->QueryRequest.BytesNeeded = BytesNeeded;                       
			NdisMSetTimer(&Adapter->LinkDetectionTimer, NIC_LINK_DETECTION_DELAY);
            Status = NDIS_STATUS_PENDING;   
		}
		else
		{
			if (Oid == OID_GEN_LINK_SPEED)
			{
				
				// We won't always know what link speed we are actually running at, but
				// report the value that the we detected when the driver loaded.
            #if !(defined(GCCK) && defined(OFDM))
                if (Adapter->adapterReady){
                    GenericUlong =  110000;
                }
                else{
                    GenericUlong =  110000;
                }
            #else
                GenericUlong =  540000;     //``JWEI 2003/12/02
            #endif
			}
			else  // OID_GEN_MEDIA_CONNECT_STATUS
			{
				if (Adapter->adapterReady){
				//	ZDDbgPrint((_T("OID_GEN_MEDIA_CONNECT_STATUS NdisMediaStateConnected\n")));
					GenericUlong = NdisMediaStateConnected;
				}
				else{
				//	ZDDbgPrint((_T("OID_GEN_MEDIA_CONNECT_STATUS NdisMediaStateDisconnected\n")));
					GenericUlong = NdisMediaStateDisconnected;
				}
			}
		}
		break;
#else
*/
 		INITSTRTX(DebugPrint, (_T("OID_GEN_MEDIA_CONNECT_STATUS\n")));
		if ( Adapter->adapterReady == TRUE ) 
		{
			GenericUlong = NdisMediaStateConnected;
		}
		else
		{
			GenericUlong = NdisMediaStateDisconnected;
		}
#ifdef RF_TEST
			GenericUlong = NdisMediaStateConnected;
#endif
		MoveBytes = sizeof(NDIS_MEDIA_STATE);
        break;
//#endif

    case OID_PNP_CAPABILITIES:
 		INITSTRTX(DebugPrint, (_T("OID_PNP_CAPABILITIES\n")));
        //TRACEPOWER((_T("QUERY:Got a Query Capabilities Call\n")));
        // since we are stubbing power management, return only the
        // D0 power state indicating that the lowest power state we
        // support is D0 (full power)
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
		/*
		Power_Management_Capabilities.WakeUpCapabilities.MinMagicPacketWakeUp   = NdisDeviceStateD0;
        Power_Management_Capabilities.WakeUpCapabilities.MinPatternWakeUp       = NdisDeviceStateD0;
        Power_Management_Capabilities.WakeUpCapabilities.MinLinkChangeWakeUp    = NdisDeviceStateD0;

        MoveSource = (PVOID) &Power_Management_Capabilities;
        MoveBytes = sizeof(NDIS_PNP_CAPABILITIES);
		*/

        break;

    case OID_PNP_QUERY_POWER:
 		INITSTRTX(DebugPrint, (_T("OID_PNP_QUERY_POWER\n")));
        // Adapter->NextPowerState = (NDIS_DEVICE_POWER_STATE) InformationBuffer;
        // return success indicating we will do nothing to jeapordize the
        // transition...
        // Status is pre-set in this routine to Success
        // but since we aren't actually supporting power manangement
        // return failure.
        Status = NDIS_STATUS_SUCCESS; //stub

        break;

        // WMI support
        // this is the uint case
    case OID_CUSTOM_DRIVER_QUERY:
 		INITSTRTX(DebugPrint, (_T("OID_CUSTOM_DRIVER_QUERY\n")));
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
        break;

    case OID_CUSTOM_DRIVER_SET:
 		INITSTRTX(DebugPrint, (_T("OID_CUSTOM_DRIVER_SET\n")));
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
        break;

        // this is the array case
    case OID_CUSTOM_ARRAY:
 		INITSTRTX(DebugPrint, (_T("OID_CUSTOM_ARRAY\n")));
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
        break;

        // this is the string case
    case OID_CUSTOM_STRING:
 		INITSTRTX(DebugPrint, (_T("OID_CUSTOM_STRING\n")));
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
        break;

//#ifdef NDIS51_MINIPORT
	case OID_GEN_PHYSICAL_MEDIUM:
 		INITSTRTX(DebugPrint, (_T("OID_GEN_PHYSICAL_MEDIUM\n")));
        GenericUlong = NdisPhysicalMediumWirelessLan;
		break;
	case OID_802_11_BSSID:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID\n")));
		INITSTRTX(DebugPrint, (_T("Value = \n")));
		if((Adapter->adapterReady == TRUE && Adapter->CardSetting.BSSType==INFRASTRUCTURE_BSS) ||
			Adapter->CardSetting.BSSType == PSEUDO_IBSS ||
			Adapter->CardSetting.BSSType == INDEPENDENT_BSS)
		{
            MoveBytes = sizeof(NDIS_802_11_MAC_ADDRESS);
			MoveSource=(PVOID)&Adapter->BSSID[0];	
			for (i=0;i<6;i++){
				INITSTRTX(DebugPrint, (_T("%x "), Adapter->BSSID[i]));
			}
		}
		else
		{
			INITSTRTX(DebugPrint, (_T("Not Ready\n")));
			Status = NDIS_STATUS_ADAPTER_NOT_READY;
		}
		INITSTRTX(DebugPrint, (_T("\n")));
		break;
	case OID_802_11_SSID:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_SSID\n")));
		if ( Adapter->adapterReady ){
		//if (1){// Ask JLee
			Ssid.SsidLength=Adapter->CardSetting.Info_SSID[1];
		    NdisMoveMemory(&Ssid.Ssid[0],
			    &Adapter->CardSetting.Info_SSID[2],
			    Adapter->CardSetting.Info_SSID[1]);
		    Adapter->CardSetting.Info_SSID[2+Adapter->CardSetting.Info_SSID[1]] = 0;
		    INITSTRTX(DebugPrint, (_T("Value = \n")));
		    INITSTRTX(DebugPrint, (_T("%s \n"), (char*)&Adapter->CardSetting.Info_SSID[2]));
		}else{
			Ssid.SsidLength = 0;
		}
		MoveSource=(PVOID)&Ssid;
		MoveBytes=sizeof(ULONG)+Ssid.SsidLength;
		break;
	case OID_802_11_NETWORK_TYPE_IN_USE:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_NETWORK_TYPE_IN_USE\n")));
        GenericUlong = Ndis802_11OFDM24; // 11G
		break;
	case OID_802_11_NETWORK_TYPES_SUPPORTED:
		if (InformationBuffer == 0 || 
			(InformationBufferLength < (sizeof(NDIS_802_11_NETWORK_TYPE_LIST) + sizeof(NDIS_802_11_NETWORK_TYPE) * 1))
			) // 1211 supoort 11b & 11g
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			// The value of BytesWritten will be assigned to BytesNeeded
			//  at exit of this routine.
			//ASSERT(0);
			*BytesWritten = 0;
			*BytesNeeded = (sizeof(NDIS_802_11_NETWORK_TYPE_LIST) + sizeof(NDIS_802_11_NETWORK_TYPE) * 1);
			
			break;
		}
		pNdis80211NTList = (PNDIS_802_11_NETWORK_TYPE_LIST) InformationBuffer;
		pNdis80211NTList->NumberOfItems = 2;
		pNdis80211NTList->NetworkType[0] = Ndis802_11DS;
		pNdis80211NTList->NetworkType[1] = Ndis802_11OFDM24;
		*BytesWritten = (sizeof(NDIS_802_11_NETWORK_TYPE_LIST) + sizeof(NDIS_802_11_NETWORK_TYPE) * 1);
		*BytesNeeded = 0;
		break;
	case OID_802_11_RSSI:
 		//if (InformationBuffer == 0 || (InformationBufferLength != 4)) 
		if (InformationBuffer == 0 || InformationBufferLength < sizeof(GenericUlong))// jxiao
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = 4;
			
			break;
		}
		DebugPrint = 0;
		INITSTRTX(DebugPrint, (_T("OID_802_11_RSSI\n")));
		if (Adapter->adapterReady != TRUE)
		{
			INITSTRTX(DebugPrint, (_T("Value = -200\n")));
			GenericUlong = -200; // No signal received.
		}
		else{
			//GenericUlong = 19 * Adapter->RxSignalStrength / 10 - 200;
			GenericUlong = Adapter->RxSignalStrength - 100;
			INITSTRTX(DebugPrint, (_T("Value = %d\n"), (NDIS_802_11_RSSI)GenericUlong));
		}
		break;
	case OID_802_11_RSSI_TRIGGER:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_RSSI_TRIGGER\n")));
        GenericUlong = Adapter->RssiTrigLevel;
		INITSTRTX(DebugPrint, (_T("Value = %x\n"),Adapter->RssiTrigLevel));
		break;
		
	case OID_802_11_BSSID_LIST:
		DebugPrint = 1;
 		//INITSTRTX(DebugPrint, (_T("OID_802_11_BSSID_LIST, WPA=%d\n"), Adapter->WPAOn));
		if ( !Adapter->WPAOn ){  // WPA off for WHQL test
			if (InformationBuffer == 0 || 
				(InformationBufferLength < 
				(sizeof(ULONG) + Adapter->BSSCnt * sizeof(NDIS_WLAN_BSSID)) )
				)
			{
				Status = NDIS_STATUS_BUFFER_TOO_SHORT;
				// The value of BytesWritten will be assigned to BytesNeeded
				//  at exit of this routine.
				//ASSERT(0);
				*BytesWritten = 0;
				*BytesNeeded = (sizeof(ULONG) + Adapter->BSSCnt * sizeof(NDIS_WLAN_BSSID));
				
				break;
			}
			pZDBSSIDList = (PNDIS_802_11_BSSID_LIST) InformationBuffer;					
			pZDBSSIDList->NumberOfItems = 0;
			for(i=0; i<Adapter->BSSCnt; i++)
			{
				if (Adapter->BSSInfo[i].OnUpdating){ 
					continue;
				}
				for (j=0;j<i;j++){
					if (memcmp(Adapter->BSSInfo[j].BSSID, Adapter->BSSInfo[i].BSSID, 6)
						== 0){
						break;
					}
				}
				if (j!=i){ // It's a duplication
					continue;
				}
				// the size of structure
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Length=sizeof(NDIS_WLAN_BSSID);
				// BSSID (Mac address of AP)
				NdisMoveMemory(
					&pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].MacAddress[0],
					&Adapter->BSSInfo[i].BSSID[0],
					6
					);
				//SSID
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Ssid.SsidLength =
					Adapter->BSSInfo[i].SSID[1];
				NdisMoveMemory(
					&pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Ssid.Ssid[0],
					&Adapter->BSSInfo[i].SSID[2],
					Adapter->BSSInfo[i].SSID[1]);
				// RSSI (Received signal strength Indication
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Rssi=
					Adapter->BSSInfo[i].SignalStrength - 100;
				
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Privacy=
					(Adapter->BSSInfo[i].Capability[0] & BIT_4);
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].NetworkTypeInUse =
					Ndis802_11DS;
				// The size of configuration structure
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Configuration.Length=
					sizeof(NDIS_802_11_CONFIGURATION);
				// Beacon Interval
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Configuration.BeaconPeriod=
					(((USHORT)Adapter->BSSInfo[i].BeaconInterval[1]) >> 8) +
					Adapter->BSSInfo[i].BeaconInterval[0];				
				// ATIM window size
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Configuration.ATIMWindow=
					(((USHORT)Adapter->BSSInfo[i].ATIMWindow[1]) >> 8) +
					Adapter->BSSInfo[i].ATIMWindow[0];							
				// Channel Freq in KHz
				pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].Configuration.DSConfig=
					(2412+(Adapter->BSSInfo[i].Channel-1)*5)*1000;				
				//    if (adapter_p->portType==PORT_TYPE_PSIBSS)
				if (Adapter->BSSInfo[i].Capability[0] & 2) // IBSS, If bit1 of Capability Information field equal to 1
					pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].InfrastructureMode=
					Ndis802_11IBSS;
				//     else if(adapter_p->portType==PORT_TYPE_BSS)
				if (Adapter->BSSInfo[i].Capability[0] & 1) // ESS, If bit0 of Capability Information field equal to 1
					pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].InfrastructureMode=
					Ndis802_11Infrastructure;
				
				NdisMoveMemory(
					&pZDBSSIDList->Bssid[pZDBSSIDList->NumberOfItems].SupportedRates[0],
					&Adapter->BSSInfo[i].SupportedRates[2],
					8);
				pZDBSSIDList->NumberOfItems ++;
			}
			*BytesWritten = pZDBSSIDList->NumberOfItems*sizeof(NDIS_WLAN_BSSID) + sizeof(ULONG);
			*BytesNeeded = 0;

            /*
			pch = (PUCHAR) pBSSIDList->Bssid;
			pBssid = (PNDIS_WLAN_BSSID_EX)pch;
			for ( i=0; i<pBSSIDList->NumberOfItems; i++ ){

                USHORT k;

				ZDDbgPrint((_T("SSID = ")));
				for ( k=0; k<pBssid->Ssid.SsidLength; k++ )
					ZDDbgPrint((_T("%c"), pBssid->Ssid.Ssid[k]));
				ZDDbgPrint((_T("\n")));
				ZDDbgPrint((_T("BSSID = ")));
				for ( k=0; k<6; k++ )
					ZDDbgPrint((_T("%2x "), pBssid->MacAddress[k]));
				ZDDbgPrint((_T("\n")));
				ZDDbgPrint((_T("WPASupport = %d\n"), Adapter->BSSInfo[i].WPASupport));
				ZDDbgPrint((_T("Infrastructure mode = %d\n"), pBssid->InfrastructureMode));
				ZDDbgPrint((_T("IE = ")));
				for ( k=0; k<pBssid->IELength; k++ )
					ZDDbgPrint((_T("%2x "), pBssid->IEs[k]));
				ZDDbgPrint((_T("\n\n")));

				pch = (PUCHAR) pBssid + pBssid->Length;
			    pBssid = (PNDIS_WLAN_BSSID_EX)pch;          
			}
            */

			return Status;
		}else{  // WPA on
		    if (InformationBuffer == 0 || 
			     (InformationBufferLength < 
			     (sizeof(ULONG) + Adapter->BSSCnt * (sizeof(NDIS_WLAN_BSSID_EX)+MAX_REPORT_IEs_SIZE)) ))
			{
			    Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			    // The value of BytesWritten will be assigned to BytesNeeded
			    //  at exit of this routine.
			
			    *BytesWritten = 0;
			    *BytesNeeded = (sizeof(ULONG) + Adapter->BSSCnt * (sizeof(NDIS_WLAN_BSSID_EX)+MAX_REPORT_IEs_SIZE));
			
			    break;
			}
		    ZDDbgPrint((_T("---->InformationBufferLength = %d\n"), InformationBufferLength));
		    pBSSIDList = (PNDIS_802_11_BSSID_LIST_EX) InformationBuffer;
		    pBssid = &pBSSIDList->Bssid[0];
		    pBSSIDList->NumberOfItems = 0;
		    *BytesWritten = sizeof(ULONG);
		    for(i=0; i<Adapter->BSSCnt; i++)
			{

			    PUCHAR	pch;
			    PNDIS_802_11_VARIABLE_IEs p80211VarIe,pSrcVarIe;
			    PNDIS_802_11_FIXED_IEs p80211FixIe;
			    UCHAR   buf[4] = { 0, 0x50, 0xf2, 0x01 };

				if (Adapter->BSSInfo[i].OnUpdating){ 
					continue;
				}
				for (j=0;j<i;j++){
					if (memcmp(Adapter->BSSInfo[j].BSSID, Adapter->BSSInfo[i].BSSID, 6)
						== 0){
						break;
					}
				}
				if (j!=i){ // It's a duplication
					continue;
				}

			    p80211FixIe = (PNDIS_802_11_FIXED_IEs)pBssid->IEs;
                pch = (PUCHAR)&pBssid->IEs[sizeof(NDIS_802_11_FIXED_IEs)];
			    p80211VarIe=(PNDIS_802_11_VARIABLE_IEs)pch;

			    // the size of structure
			    pBssid->Length=sizeof(NDIS_WLAN_BSSID_EX);
			    // BSSID (Mac address of AP)
			    NdisMoveMemory(
				    &pBssid->MacAddress[0],
				    &Adapter->BSSInfo[i].BSSID[0],
				    6
				    );
			    //SSID
			    pBssid->Ssid.SsidLength =
				    Adapter->BSSInfo[i].SSID[1];
			    NdisMoveMemory(
				    &pBssid->Ssid.Ssid[0],
				    &Adapter->BSSInfo[i].SSID[2],
				    Adapter->BSSInfo[i].SSID[1]);
                pBssid->Ssid.Ssid[Adapter->BSSInfo[i].SSID[1]] = 0;
				// RSSI (Received signal strength Indication
			    pBssid->Rssi = Adapter->BSSInfo[i].SignalStrength - 100;
			    pBssid->Privacy = (Adapter->BSSInfo[i].Capability[0] & BIT_4) >> 4;
			    pBssid->NetworkTypeInUse = Ndis802_11DS;
			    // The size of configuration structure
			    pBssid->Configuration.Length = sizeof(NDIS_802_11_CONFIGURATION);
			    // Beacon Interval
			    pBssid->Configuration.BeaconPeriod=
				    (((USHORT)Adapter->BSSInfo[i].BeaconInterval[1]) >> 8) +
				    Adapter->BSSInfo[i].BeaconInterval[0];				
			    // ATIM window size
			    pBssid->Configuration.ATIMWindow=
				    (((USHORT)Adapter->BSSInfo[i].ATIMWindow[1]) >> 8) +
				    Adapter->BSSInfo[i].ATIMWindow[0];							
			    // Channel Freq in KHz
			    pBssid->Configuration.DSConfig=
				    (2412+(Adapter->BSSInfo[i].Channel-1)*5)*1000;				
			    //    if (adapter_p->portType==PORT_TYPE_PSIBSS)
			    if (Adapter->BSSInfo[i].Capability[0] & 2) // IBSS, If bit1 of Capability Information field equal to 1
				    pBssid->InfrastructureMode = Ndis802_11IBSS;
				//     else if(adapter_p->portType==PORT_TYPE_BSS)
			    if (Adapter->BSSInfo[i].Capability[0] & 1) // ESS, If bit0 of Capability Information field equal to 1
				    pBssid->InfrastructureMode = Ndis802_11Infrastructure;
				
			    NdisMoveMemory(
				   	&pBssid->SupportedRates[0],
					&Adapter->BSSInfo[i].SupportedRates[2],
					Adapter->BSSInfo[i].SupportedRates[1]);
#ifdef OFDM
			    NdisMoveMemory(
				   	&pBssid->SupportedRates[Adapter->BSSInfo[i].SupportedRates[1]],
					&Adapter->BSSInfo[i].ExtSupportedRates[2],
					Adapter->BSSInfo[i].ExtSupportedRates[1]);
#endif
			    p80211FixIe->BeaconInterval = (Adapter->BSSInfo[i].BeaconInterval[1] << 8)
				                          + Adapter->BSSInfo[i].BeaconInterval[0];
			    p80211FixIe->Capabilities = (Adapter->BSSInfo[i].Capability[1] << 8)
				                          + Adapter->BSSInfo[i].Capability[0];
			    NdisMoveMemory(
				    p80211FixIe->Timestamp,
				    Adapter->BSSInfo[i].TimeStamp,
				    8);
			    pBssid->IELength = sizeof(NDIS_802_11_FIXED_IEs);
			    FILL_802_11_VAR_IE(p80211VarIe, // Var IE Base Ptr
				    0,			// Element ID:SSID
				    &Adapter->BSSInfo[i].SSID[2], // Source Data
				    Adapter->BSSInfo[i].SSID[1]) // Data length
			    pBssid->IELength += VAR_IE_SIZE(p80211VarIe);
			    NEXT_802_11_VAR_IE(p80211VarIe)
			    FILL_802_11_VAR_IE(p80211VarIe, // Var IE Base Ptr
				    1,			// Element ID:supported rate
				    &Adapter->BSSInfo[i].SupportedRates[2], // Source Data
				    (UCHAR)4) // Data length
			    pBssid->IELength += VAR_IE_SIZE(p80211VarIe);
			    NEXT_802_11_VAR_IE(p80211VarIe)
			    FILL_802_11_VAR_IE(p80211VarIe, // Var IE Base Ptr
				    3,			// Element ID:DS Parameters
				    (PUCHAR)&Adapter->BSSInfo[i].Channel, // Source Data
				    (UCHAR)1) // Data length
			    pBssid->IELength += VAR_IE_SIZE(p80211VarIe);
			    NEXT_802_11_VAR_IE(p80211VarIe)
			    pSrcVarIe = (PNDIS_802_11_VARIABLE_IEs) ( Adapter->BSSInfo[i].wpaIEs 
				                                          + Adapter->BSSInfo[i].IEstart );
			    if ( Adapter->BSSInfo[i].WPASupport )
				{
				    NdisMoveMemory(p80211VarIe, Adapter->BSSInfo[i].wpaIEs + Adapter->BSSInfo[i].IEstart, pSrcVarIe->Length+2);
				    pBssid->IELength += VAR_IE_SIZE(p80211VarIe);
				}
			    pBssid->Length=(sizeof(NDIS_WLAN_BSSID_EX)-1+
				    pBssid->IELength +3) & 0xFFFFFFFC;
			    //pBssid->Length=(sizeof(NDIS_WLAN_BSSID_EX)-1+pBssid->IELength);
			    *BytesWritten += pBssid->Length;
				ASSERT((*BytesWritten) <= 
					sizeof(ULONG) + Adapter->BSSCnt * (sizeof(NDIS_WLAN_BSSID_EX)+MAX_REPORT_IEs_SIZE));
			    pch = (PUCHAR) pBssid + pBssid->Length;
			    pBssid = (PNDIS_WLAN_BSSID_EX)pch;

				pBSSIDList->NumberOfItems ++;
			}

			
		    /*	
			pch = (PUCHAR) pBSSIDList->Bssid;
			pBssid = (PNDIS_WLAN_BSSID_EX)pch;
			for ( i=0; i<pBSSIDList->NumberOfItems; i++ ){

                USHORT k;

				ZDDbgPrint((_T("SSID = ")));
				for ( k=0; k<pBssid->Ssid.SsidLength; k++ )
					ZDDbgPrint((_T("%c"), pBssid->Ssid.Ssid[k]));
				ZDDbgPrint((_T("\n")));
				ZDDbgPrint((_T("BSSID = ")));
				for ( k=0; k<6; k++ )
					ZDDbgPrint((_T("%2x "), pBssid->MacAddress[k]));
				ZDDbgPrint((_T("\n")));
				ZDDbgPrint((_T("WPASupport = %d\n"), Adapter->BSSInfo[i].WPASupport));
				ZDDbgPrint((_T("Infrastructure mode = %d\n"), pBssid->InfrastructureMode));
				ZDDbgPrint((_T("IE = ")));
				for ( k=0; k<pBssid->IELength; k++ )
					ZDDbgPrint((_T("%2x "), pBssid->IEs[k]));
				ZDDbgPrint((_T("\n\n")));

				pch = (PUCHAR) pBssid + pBssid->Length;
			    pBssid = (PNDIS_WLAN_BSSID_EX)pch;          
			}
			*/			
			
			*BytesNeeded = 0;
            return Status;
		}
		break;
	case OID_802_11_INFRASTRUCTURE_MODE:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_INFRASTRUCTURE_MODE\n")));
		if (Adapter->CardSetting.BSSType==PSEUDO_IBSS){
			GenericUlong = 3;	// for PSEUDO IBSS
			INITSTRTX(DebugPrint, (_T("Value = %x\n"), GenericUlong));
		}
		else if (Adapter->CardSetting.BSSType==INDEPENDENT_BSS)
		{
			GenericUlong = Ndis802_11IBSS;
			INITSTRTX(DebugPrint, (_T("Value = %x\n"), Ndis802_11IBSS));
		}
		else if(Adapter->CardSetting.BSSType==INFRASTRUCTURE_BSS)
		{
			GenericUlong = Ndis802_11Infrastructure;
			INITSTRTX(DebugPrint, (_T("Value = %x\n"), Ndis802_11Infrastructure));
		}
		else
		{
			GenericUlong = Ndis802_11AutoUnknown;
			INITSTRTX(DebugPrint, (_T("Value = %x\n"), Ndis802_11AutoUnknown));
		}
		break;
	case OID_802_11_SUPPORTED_RATES:
		DebugPrint = 1;
		if (InformationBuffer == 0 || ((UCHAR)InformationBufferLength < 
			((Adapter->CardSetting.Info_SupportedRates[1]) + (Adapter->CardSetting.Info_ExtSupportedRates[1])))
			)
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = (Adapter->CardSetting.Info_SupportedRates[1]) + (Adapter->CardSetting.Info_ExtSupportedRates[1]);
 			
			INITSTRTX(DebugPrint, (_T("OID_802_11_SUPPORTED_RATES BUFFER_TOO_SHORT %d\n"), *BytesNeeded));
			
			break;
		}	
 		INITSTRTX(DebugPrint, (_T("OID_802_11_SUPPORTED_RATES\n")));
        MoveSource = (PVOID) &Adapter->PernmentSupportedRates[2];
        MoveBytes = Adapter->PernmentSupportedRates[1];
		//if ( (Adapter->IsUSB2_0) || (Adapter->busbswitch == 1)) // Removed by jxiao on 2004/08/02
		if (1)			// Added by jxiao on 2004/08/02
		{
            MoveSource2 = (PVOID) &Adapter->PernmentExtSupportedRates[2];
            MoveBytes2 = Adapter->PernmentExtSupportedRates[1];
		}
		else
		{
		    MoveBytes2 = 0;
		}
		break;
	case OID_802_11_DESIRED_RATES:
		if (InformationBuffer == 0 || ((UINT)InformationBufferLength < Adapter->AllowRateArrayCount))
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = Adapter->AllowRateArrayCount;
			
			break;
		}
		DebugPrint = 1;
  		INITSTRTX(DebugPrint, (_T("OID_802_11_DESIRED_RATES %d\n"), Adapter->AllowRateArrayCount));

		for(i=0; i<Adapter->AllowRateArrayCount; i++){

			*((PUCHAR)InformationBuffer+i) = Rate_Convert_to_MS(Adapter->AllowRateArray[i]); 
		}

		*BytesWritten = Adapter->AllowRateArrayCount;
		*BytesNeeded = 0;

		return Status;

		//break;
	case OID_802_11_CONFIGURATION:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_CONFIGURATION\n")));
		if (InformationBuffer == 0 || 
			(InformationBufferLength < 
			sizeof(NDIS_802_11_CONFIGURATION) )
			)
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			// The value of BytesWritten will be assigned to BytesNeeded
			//  at exit of this routine.
			//ASSERT(0);
			*BytesWritten = 0;
			*BytesNeeded = sizeof(NDIS_802_11_CONFIGURATION);
			
			break;
		}		
		
		pConfiguration=(PNDIS_802_11_CONFIGURATION)InformationBuffer;			
		pConfiguration->Length=sizeof(NDIS_802_11_CONFIGURATION);
		pConfiguration->BeaconPeriod=Adapter->CardSetting.BeaconInterval;
		pConfiguration->ATIMWindow=Adapter->CardSetting.ATIMWindow;
		pConfiguration->DSConfig=(2412+(Adapter->CardSetting.Channel-1)*5)*1000;
		
		if (Adapter->CardSetting.Channel == 14 )
			pConfiguration->DSConfig = 2484000;

		*BytesWritten =sizeof(NDIS_802_11_CONFIGURATION);
		*BytesNeeded = 0;
		return Status;
		//break;
	case OID_802_11_STATISTICS:
 		INITSTRTX(DebugPrint, (_T("OID_802_11_STATISTICS\n")));
        Status = NDIS_STATUS_NOT_SUPPORTED; //stub
		break;
	case OID_802_11_WEP_STATUS:
 		//INITSTRTX(DebugPrint, (_T("OID_802_11_WEP_STATUS\n")));
		if ( Adapter->encryMode < 3 )
		    if (Adapter->CardSetting.EncryMode)
			    GenericUlong = Ndis802_11WEPEnabled;
		    else
			    GenericUlong = Ndis802_11WEPDisabled;
		else
		    GenericUlong = Adapter->encryMode;
		INITSTRTX(DebugPrint, (_T("Value = %x\n"), GenericUlong));
		break;
	case OID_802_11_PRIVACY_FILTER:
		GenericUlong = (ULONG)Adapter->func8021x;
		break;
	case OID_802_11_AUTHENTICATION_MODE: 
		// jhlee 3314
		// return the authentication mode
		//INITSTRTX(DebugPrint, (_T("OID_802_11_AUTHENTICATION_MODE\n")));
		GenericUlong=Adapter->CardSetting.AuthMode;
		//INITSTRTX(DebugPrint, (_T("Value = %x\n"), Adapter->CardSetting.AuthMode));
		//ZDDbgPrint((_T("Query Authentication Mode = %d\n"), Adapter->CardSetting.AuthMode));

		break;
//#endif

    case OID_802_11_ASSOCIATION_INFORMATION://Query
		ZDDbgPrint((_T("Query Association Information\n")));
		{
            PNDIS_802_11_ASSOCIATION_INFORMATION pAssoInfo;
            PNDIS_802_11_VARIABLE_IEs pVarIe,pVarIe2;
            PUCHAR	pCh;

			if ( !Adapter->CardSetting.WPASupport ||
		         InformationBuffer==NULL || 
		         InformationBufferLength < sizeof(NDIS_802_11_ASSOCIATION_INFORMATION) )
		        break;
	        pAssoInfo=(PNDIS_802_11_ASSOCIATION_INFORMATION)InformationBuffer;
        	if ( Adapter->adapterReady != TRUE )
		        break;
			
	        pAssoInfo->AvailableRequestFixedIEs =
		                      NDIS_802_11_AI_REQFI_CAPABILITIES +
		                      NDIS_802_11_AI_REQFI_LISTENINTERVAL;
	        pAssoInfo->RequestFixedIEs.Capabilities = Adapter->CardSetting.Capability;
	        pAssoInfo->RequestFixedIEs.ListenInterval = 1;
	        pAssoInfo->AvailableResponseFixedIEs =
		                      NDIS_802_11_AI_RESFI_CAPABILITIES +
		                      NDIS_802_11_AI_RESFI_STATUSCODE +
		                      NDIS_802_11_AI_RESFI_ASSOCIATIONID;
		
	        pAssoInfo->ResponseFixedIEs.Capabilities = Adapter->CardSetting.Capability;
	        pAssoInfo->ResponseFixedIEs.StatusCode = 0; // success
	        pAssoInfo->ResponseFixedIEs.AssociationId = Adapter->AID;
	        pCh = (PUCHAR)InformationBuffer+sizeof(NDIS_802_11_ASSOCIATION_INFORMATION);
	        pVarIe=(PNDIS_802_11_VARIABLE_IEs)pCh;
	        pAssoInfo->OffsetRequestIEs = sizeof(NDIS_802_11_ASSOCIATION_INFORMATION);
	        // Fill SSID Information Element	
         	if (InformationBufferLength < (sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+2+Adapter->CardSetting.Info_SSID[1]))
		        break;
	        FILL_802_11_VAR_IE(pVarIe, 0, &Adapter->CardSetting.Info_SSID[2], (UCHAR)Adapter->CardSetting.Info_SSID[1])
	        pAssoInfo->RequestIELength =VAR_IE_SIZE(pVarIe);
	        NEXT_802_11_VAR_IE(pVarIe);
	        // Fill supported rate Information Element
	        if (InformationBufferLength < (sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+pAssoInfo->RequestIELength+Adapter->CardSetting.Info_SupportedRates[1]))
		        break;
	        FILL_802_11_VAR_IE(pVarIe, 1, &Adapter->CardSetting.Info_SupportedRates[2], 4)
	        pAssoInfo->RequestIELength +=VAR_IE_SIZE(pVarIe);
	        NEXT_802_11_VAR_IE(pVarIe);

			// Fill WPA IE
	        pVarIe2 = (PNDIS_802_11_VARIABLE_IEs) (Adapter->CardSetting.wpaIEs + Adapter->CardSetting.IEstart);
	        if (InformationBufferLength < (sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+pAssoInfo->RequestIELength+VAR_IE_SIZE(pVarIe2)))
		        break;
	        NdisMoveMemory(pVarIe, Adapter->CardSetting.wpaIEs + Adapter->CardSetting.IEstart, VAR_IE_SIZE(pVarIe2));
	        pAssoInfo->RequestIELength +=VAR_IE_SIZE(pVarIe);
	        NEXT_802_11_VAR_IE(pVarIe);
	        pAssoInfo->OffsetResponseIEs=sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+pAssoInfo->RequestIELength;
	        if (InformationBufferLength < (sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+pAssoInfo->RequestIELength+Adapter->CardSetting.Info_SupportedRates[1]+2))
		        break;
	        FILL_802_11_VAR_IE(pVarIe, 1, &Adapter->CardSetting.Info_SupportedRates[2], Adapter->CardSetting.Info_SupportedRates[1]);
	        pAssoInfo->ResponseIELength = VAR_IE_SIZE(pVarIe);
	        pAssoInfo->Length = sizeof(NDIS_802_11_ASSOCIATION_INFORMATION)+
		                        pAssoInfo->RequestIELength +
		                        pAssoInfo->ResponseIELength;
	        *BytesWritten = pAssoInfo->Length;
	        *BytesNeeded = 0;

	        return NDIS_STATUS_SUCCESS;
		}

	case OID_802_11_POWER_MODE:

		if (InformationBuffer == 0 || (InformationBufferLength != 4)) 
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = 4;
			
			break;
		}
        
		if (!Adapter->PSMSupported)
			GenericUlong = Ndis802_11PowerModeCAM;
		else{
			if (Adapter->TestPS)
				GenericUlong = Ndis802_11PowerModeMAX_PSP;
			else
				GenericUlong = Ndis802_11PowerModeFast_PSP;
		}
		
		DebugPrint = 1;
 		INITSTRTX(DebugPrint, (_T("OID_802_11_POWER_MODE %d\n"), GenericUlong));

		break;

	case OID_802_11_TX_POWER_LEVEL:
		
		if (InformationBuffer == 0 || (InformationBufferLength != 4)) 
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = 4;
			
			break;
		}
 		INITSTRTX(DebugPrint, (_T("OID_802_11_TX_POWER_LEVEL\n")));

		//need tranform
		//GenericUlong = Adapter->TxGainSetting; 

		break;

	case OID_802_11_FRAGMENTATION_THRESHOLD:
		
		DebugPrint = 1;

 		INITSTRTX(DebugPrint, (_T("OID_802_11_FRAGMENTATION_THRESHOLD %d\n"), InformationBufferLength));
		
		if (InformationBuffer == 0 || (InformationBufferLength != 4)) 
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = 4;
			
			break;
		}
	
		GenericUlong =  Adapter->CardSetting.FragThreshold; 

 		INITSTRTX(DebugPrint, (_T("OID_802_11_FRAGMENTATION_THRESHOLD %d\n"), GenericUlong));

		break;

 	case OID_802_11_RTS_THRESHOLD:

		DebugPrint = 1;
	
		INITSTRTX(DebugPrint, (_T("OID_802_11_RTS_THRESHOLD %d\n"), InformationBufferLength));

		if (InformationBuffer == 0 || (InformationBufferLength != 4)) 
		{
			Status = NDIS_STATUS_BUFFER_TOO_SHORT;
			*BytesWritten = 0;
			*BytesNeeded = 4;
			
			break;
		}

		GenericUlong =  Adapter->CardSetting.RTSThreshold; 

		INITSTRTX(DebugPrint, (_T("OID_802_11_RTS_THRESHOLD %d\n"), GenericUlong));
		
		break;
	case OID_ZDX_802_11_WPA_MIC_ERROR:
		ZDDbgPrint((_T("Query OID_ZDX_802_11_WPA_MIC_ERROR\n")));

        NdisMoveMemory(GenericArray2,Adapter->WPAMICErrorLog,14);
		NdisZeroMemory(Adapter->WPAMICErrorLog,14);
        MoveSource = (PVOID) (GenericArray2);
        MoveBytes = 14;
        break;

   default:
 		INITSTRTX(DebugPrint, (_T("default\n")));

        // The query is for a driver statistic, so we need to first
        // update our statistics in software.

        //DumpStatsCounters(Adapter);

        switch (Oid)
        {
		case OID_GEN_DIRECTED_BYTES_XMIT:
			if (InformationBuffer == 0 || (InformationBufferLength < sizeof(ULONG))) 
			{
				Status = NDIS_STATUS_INVALID_LENGTH;
				*BytesWritten = 0;
				*BytesNeeded = 8;
				break;
			}
			MoveSource = &Adapter->txUnicastOctets;
			if (InformationBufferLength > 8)
			{
                MoveBytes = 8;
			}
             else
                MoveBytes = InformationBufferLength;
			//GenericUlong = (ULONG) Adapter->txUnicastOctets;
			break;
		case OID_GEN_DIRECTED_BYTES_RCV:
			if (InformationBuffer == 0 || (InformationBufferLength < sizeof(ULONG))) 
			{
				Status = NDIS_STATUS_INVALID_LENGTH;
				*BytesWritten = 0;
				*BytesNeeded = 8;
				break;
			}
			MoveSource = &Adapter->rxUnicastOctets;
			if (InformationBufferLength > 8)
			{
                MoveBytes = 8;
			}
             else
                MoveBytes = InformationBufferLength;
			//GenericUlong = (ULONG) Adapter->rxUnicastOctets;
			break;
        case OID_GEN_XMIT_OK:

            GenericUlong = (ULONG) Adapter->GoodTransmits;
        #if fZD1211_LOOPBACK
        //JWEI 2004/03/22
            if (Adapter->TestFlag & LOOPBACKTEST)
                GenericUlong = (ULONG) Adapter->LBTxCnt;
        #endif
            break;

        case OID_GEN_RCV_OK:

            GenericUlong = (ULONG) Adapter->GoodReceives;
        #if fZD1211_LOOPBACK
        //JWEI 2004/03/22
            if (Adapter->TestFlag & LOOPBACKTEST)
                GenericUlong = (ULONG) Adapter->LBRxCnt;
        #endif
            break;

        case OID_GEN_XMIT_ERROR:

            GenericUlong = 0;
            //GenericUlong = (ULONG) (Adapter->TxAbortExcessCollisions +
            //    Adapter->TxDmaUnderrun +
            //    Adapter->TxLostCRS +
            //    Adapter->TxLateCollisions);
            break;

        case OID_GEN_RCV_ERROR:
            GenericUlong = 0;
            // receive error counters are kept on chip.
            //GenericUlong = (ULONG) (Adapter->RcvCrcErrors +
            //    Adapter->RcvAlignmentErrors +
            //    Adapter->RcvResourceErrors +
            //    Adapter->RcvDmaOverrunErrors +
            //    Adapter->RcvRuntErrors);
            break;

        case OID_GEN_RCV_NO_BUFFER:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->RcvResourceErrors;
            break;

        case OID_GEN_RCV_CRC_ERROR:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->RcvCrcErrors;
            break;

        case OID_GEN_TRANSMIT_QUEUE_LENGTH:

            GenericUlong = (ULONG) Adapter->RegNumTcb;
            break;

        case OID_802_3_RCV_ERROR_ALIGNMENT:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->RcvAlignmentErrors;
            break;

        case OID_802_3_XMIT_ONE_COLLISION:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->OneRetry;
            break;

        case OID_802_3_XMIT_MORE_COLLISIONS:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->MoreThanOneRetry;
            break;

        case OID_802_3_XMIT_DEFERRED:
			GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxOKButDeferred;
            break;

        case OID_802_3_XMIT_MAX_COLLISIONS:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxAbortExcessCollisions;
            break;

        case OID_802_3_RCV_OVERRUN:
			GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->RcvDmaOverrunErrors;
            break;

        case OID_802_3_XMIT_UNDERRUN:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxDmaUnderrun;
            break;

        case OID_802_3_XMIT_HEARTBEAT_FAILURE:
			GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxLostCRS;
            break;

        case OID_802_3_XMIT_TIMES_CRS_LOST:
			GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxLostCRS;
            break;

        case OID_802_3_XMIT_LATE_COLLISIONS:
            GenericUlong = 0;
            //GenericUlong = (ULONG) Adapter->TxLateCollisions;
            break;
        default:
            Status = NDIS_STATUS_NOT_SUPPORTED;
			//Status = NDIS_STATUS_SUCCESS;
			MoveBytes = 0;
            break;
        }
    }

    if (Status == NDIS_STATUS_SUCCESS)
    {
        if ((MoveBytes + MoveBytes2) > InformationBufferLength)
        {
            // Not enough room in InformationBuffer. Punt
            *BytesNeeded = MoveBytes + MoveBytes2;

            Status = NDIS_STATUS_BUFFER_TOO_SHORT;
        }
        else
        {
            // Copy result into InformationBuffer
            *BytesWritten = MoveBytes + MoveBytes2;
            if (MoveBytes > 0)
                NdisMoveMemory(InformationBuffer, MoveSource, MoveBytes);
            if (MoveBytes2 > 0)
                NdisMoveMemory(((PUCHAR)InformationBuffer + MoveBytes), MoveSource2, MoveBytes2);
       }
    }

	//DbgPrint("      status = %x\n", Status);

    return (Status);
}   /* end of ZD1205QueryInformation */

void 
Change_EncryMode(
			IN PZD1205_ADAPTER Adapter,
			IN UCHAR	EncMode,
			IN UCHAR	DecMode
			)
{
	// Assure no Tx/Rx frame processing
#ifndef OFDM	
	ZD1205_WRITE_REGISTER(Adapter,EncryType, EncMode ); // For WEP 64
#endif
	Adapter->CardSetting.EncryMode = EncMode;

	if (EncMode == NO_WEP){
		Adapter->CardSetting.Capability &= ~BIT_4;
	}
	else{
		Adapter->CardSetting.Capability |= BIT_4;
	}

}


//-----------------------------------------------------------------------------
// Procedure:	SetAPClentsMACAddress
//
// Description: 
//
// Arguments:
//				Adapter
//				UCHAR	UserId	--	Starting from 0.
//				PCHAR	pMacAddress	--	pointer of the input MAC address.
//
// Return:
//				VOID
// Algorithm:
//				DWOffset = Int(UserId/4) * 6;	//UserId starting from 0
//				ByteOffset = UserId % 4;
//				for (j=0;j<6;j++){
//					tmp = *(DWOffset+j);
//					tmp &= ~(0xff << (ByteOffset*8));
//					AddrByte = Retrieve a byte from the input MAC address;
//					tmp |= (AddrByte << (ByteOffset*8));
//					*(DwOffset+j) = tmp;
//				}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Procedure:	SetKeyContext
//
// Description: 
//
// Arguments:	
//				Adapter
//				UCHAR	UserId	--	BIT_7	0:	Set User's Key Context
//											1:	Set Default Key Context
//									BIT_0 ~ BIT_6:	UserId 
//				UCHAR	EncMode	--	WEP64, WEP128 or AES.
//				UCHAR	KeyID
//				PCHAR	PKeyContent
//
// Return:
//				VOID
// Algorithm:
//				Initial_Offset = WEP64_OFFSET;	//(WEP128_OFFSET, AES_OFFSET, 
//																DEFAULT_OFFSET)
//				DWOffset = Initial_Offset +
//							int((UserId*KEY_CONTEXT_SIZE + KeyID*KEY_SIZE)/4);
//												// KeyID starting from 0
//				ByteOffset = (UserId*KEY_CONTEXT_SIZE + KeyID*KEY_SIZE)%4;
//				for (j=0;j<KEY_SIZE;j++){
//					tmp = *(DWOffset);
//					tmp &= ~(0xff << (ByteOffset*8));
//					KeyByte = Retrieve a byte from the input Key content;
//					tmp |= (KeyByte << (ByteOffset*8));
//					*(DWOffset) = tmp;
//					if (ByteOffset == 3){
//						DWOffset += 1;
//						ByteOffset = 0;
//					}else{
//						ByteOffset +=1;
//					}
//				}
//-----------------------------------------------------------------------------

#ifdef HOST_IF_USB

#define MAX_WrIndex	30

void
USB_SetKeyContext(
			IN PZD1205_ADAPTER Adapter,
			IN UCHAR	UserId,
			IN UCHAR	EncMode,
			IN UCHAR	KeyID,
			IN PUCHAR	pKeyContent
			)
{
	ULONG		Initial_Offset;
	ULONG		Key_Context_Size_In_DW;
	ULONG		Key_Size;
	ULONG		DWOffset;
	ULONG		ByteOffset;
	ULONG		tmp;
	USHORT		j;
	UCHAR		KeyByte;

    #ifndef fWRITE_WORD_REG
    USHORT      MacAddress[MAX_WrIndex];
    ULONG       MacData[MAX_WrIndex];
    USHORT      WrIndex = 0;
    PUSHORT     pWriteAddr;
    PULONG      pWriteData;
    #else
    USHORT      WriteAddr[cMAX_MULTI_WRITE_REG_NUM * 3];
    USHORT      WriteData[cMAX_MULTI_WRITE_REG_NUM * 3];
    USHORT      WriteIndex = 0;
    PUSHORT     pWriteAddr;
    PUSHORT     pWriteData;
    #endif
    USHORT      TotalRegCount;
    
    DEBUGFUNC(_T("SetKeyContext"));
    INITSTRWPA((_T("\n")));

    if (UserId & BIT_7)
    {   // Set default key
        // Set Roll call table clear
    #ifndef fWRITE_WORD_REG
        MacAddress[WrIndex] = CAM_ROLL_CALL_TBL_L;
        MacData[WrIndex] = 0x0;
        WrIndex++;

        MacAddress[WrIndex] = CAM_ROLL_CALL_TBL_H;
        MacData[WrIndex] = 0x0;
        WrIndex++;
        //ZD1205_WRITE_REGISTER(Adapter,CAM_ROLL_CALL_TBL_L, 0x0);
        //ZD1205_WRITE_REGISTER(Adapter,CAM_ROLL_CALL_TBL_H, 0x0);
    #else
        mFILL_WRITE_REGISTER32(CAM_ROLL_CALL_TBL_L, 0x0);
        mFILL_WRITE_REGISTER32(CAM_ROLL_CALL_TBL_H, 0x0);
    #endif

        // Get Default Key start address
        Initial_Offset = DEFAULT_KEY_START_DWADDR;

        // Set Key_Context_Size
        Key_Context_Size_In_DW = 8; // in unit of ULONG

        // Set Encryption mode
    #ifndef fWRITE_WORD_REG
        MacAddress[WrIndex] = CAM_MODE;
        MacData[WrIndex] = (Adapter->CurrentCAMMode | HOST_RW);
        WrIndex++;
        //ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
        //ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, (OldMode | HOST_RW));
    #else
        mFILL_WRITE_REGISTER32(CAM_MODE, (Adapter->CurrentCAMMode | HOST_RW));
    #endif
        
        switch(EncMode)
        {
        case AES:
            INITSTR((_T("CAM_AES_CCM\n")));
        #ifndef fWRITE_WORD_REG
            MacAddress[WrIndex] = CAM_DATA;
            MacData[WrIndex] = CAM_AES_CCM;
            WrIndex++;
            //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_AES_CCM);
        #else
            mFILL_WRITE_REGISTER32(CAM_DATA, CAM_AES_CCM);
        #endif
            Key_Size = 16;//32; //yarco
            break;
        case TKIP:
            INITSTR((_T("CAM_TKIP\n")));
        #ifndef fWRITE_WORD_REG
            MacAddress[WrIndex] = CAM_DATA;
            MacData[WrIndex] = CAM_TKIP;
            WrIndex++;
            //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_TKIP);
        #else
            mFILL_WRITE_REGISTER32(CAM_DATA, CAM_TKIP);
        #endif
            Key_Size = 16;//32; //yarco
            break;  
        case WEP64:
            INITSTR((_T("CAM_WEP_64\n")));
        #ifndef fWRITE_WORD_REG
            MacAddress[WrIndex] = CAM_DATA;
            MacData[WrIndex] = CAM_WEP_64;
            WrIndex++;
            //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_64);
        #else
            mFILL_WRITE_REGISTER32(CAM_DATA, CAM_WEP_64);
        #endif
            Key_Size = 5;
            break;
        case WEP128:
            INITSTR((_T("CAM_WEP_128\n")));
        #ifndef fWRITE_WORD_REG
            MacAddress[WrIndex] = CAM_DATA;
            MacData[WrIndex] = CAM_WEP_128;
            WrIndex++;
            //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_128);
        #else
            mFILL_WRITE_REGISTER32(CAM_DATA, CAM_WEP_128);
        #endif
            Key_Size = 13;
            break;
        case WEP256:
            INITSTR((_T("CAM_WEP_256\n")));
        #ifndef fWRITE_WORD_REG
            MacAddress[WrIndex] = CAM_DATA;
            MacData[WrIndex] = CAM_WEP_256;
            WrIndex++;
            //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_256);
        #else
            mFILL_WRITE_REGISTER32(CAM_DATA, CAM_WEP_256);
        #endif
            Key_Size = 29;
            break;
        default:
            ASSERT(0);
            break;
        }
    #ifndef fWRITE_WORD_REG
        MacAddress[WrIndex] = CAM_ADDRESS;
        MacData[WrIndex] = (DEFAULT_ENC_TYPE_DWADDR | WRITE_EN);
        WrIndex++;
        //ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, (DEFAULT_ENC_TYPE_DWADDR | WRITE_EN));     
        
        //MacAddress[WrIndex] = CAM_MODE;
        //MacData[WrIndex] = Adapter->CurrentCAMMode;
        //WrIndex++;
        //ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, OldMode);
    #else
        mFILL_WRITE_REGISTER32(CAM_ADDRESS, (DEFAULT_ENC_TYPE_DWADDR | WRITE_EN));
    #endif
    }
    else{
        //Initial_Offset = USER_KEY_START_ADDR;
    }


    DWOffset = Initial_Offset + (KeyID*Key_Context_Size_In_DW);
    ByteOffset = 0;

    //MacAddress[WrIndex] = CAM_MODE;
    //MacData[WrIndex] = (Adapter->CurrentCAMMode | HOST_RW);
    //WrIndex++;
    //ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
    //ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, (OldMode | HOST_RW));

    INITSTRWPA((_T("Key_Size = %d\n"), Key_Size));
    for (j=0;j<(Key_Size/4+1);j++){

        KeyByte = *(pKeyContent);
        tmp = KeyByte;
        pKeyContent++;
        
        KeyByte = *(pKeyContent);
        tmp |= KeyByte << 8;
        pKeyContent++;
        
        KeyByte = *(pKeyContent);
        tmp |= KeyByte << 16;
        pKeyContent++;
        
        KeyByte = *(pKeyContent);
        tmp |= KeyByte << 24;
        pKeyContent++;
    
    #ifndef fWRITE_WORD_REG
        MacAddress[WrIndex] = CAM_DATA;
        MacData[WrIndex] = tmp;
        WrIndex++;
        MacAddress[WrIndex] = CAM_ADDRESS;
        MacData[WrIndex] = (DWOffset | WRITE_EN);
        WrIndex++;

        ZDDbgPrint((_T("Key %d = 0x%x\n"), DWOffset, tmp));
        //ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, tmp);
        //ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, (DWOffset | WRITE_EN));
    #else
        mFILL_WRITE_REGISTER32(CAM_DATA, tmp);
        mFILL_WRITE_REGISTER32(CAM_ADDRESS, (DWOffset | WRITE_EN));
    #endif

        DWOffset ++;
    }

    #ifndef fWRITE_WORD_REG
    MacAddress[WrIndex] = CAM_MODE;
    MacData[WrIndex] = Adapter->CurrentCAMMode;
    WrIndex++;
    //ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, OldMode);

    ASSERT(MAX_WrIndex >=  WrIndex);
    #else
    mFILL_WRITE_REGISTER32(CAM_MODE, Adapter->CurrentCAMMode);
    ASSERT(WriteIndex <= cMAX_MULTI_WRITE_REG_NUM * 3);
    #endif

    // Write to Register
    
    #ifndef fWRITE_WORD_REG
    TotalRegCount = WrIndex;
    pWriteAddr = MacAddress;
    pWriteData = MacData;
    #else
    TotalRegCount = WriteIndex;
    pWriteAddr = WriteAddr;
    pWriteData = WriteData;
    #endif

//JWEI 2004/03/18
    while (TotalRegCount > cMAX_MULTI_WRITE_REG_NUM)
    {
        ZD1211_WriteMultiRegister(Adapter, pWriteAddr, pWriteData, cMAX_MULTI_WRITE_REG_NUM, TRUE);

        TotalRegCount -= cMAX_MULTI_WRITE_REG_NUM;
        pWriteAddr += cMAX_MULTI_WRITE_REG_NUM;
        pWriteData += cMAX_MULTI_WRITE_REG_NUM;
    }

    if (TotalRegCount)
    {
        ZD1211_WriteMultiRegister(Adapter, pWriteAddr, pWriteData, TotalRegCount, TRUE);
    }
}

#endif

void
SetKeyContext(
			IN PZD1205_ADAPTER Adapter,
			IN UCHAR	UserId,
			IN UCHAR	EncMode,
			IN UCHAR	KeyID,
			IN PUCHAR	pKeyContent
			)
{
	ULONG		Initial_Offset;
	ULONG		Key_Context_Size_In_DW;
	ULONG		Key_Size;
	ULONG		DWOffset;
	ULONG		ByteOffset;
	ULONG		tmp;
	ULONG		OldMode;
	USHORT		j;
	UCHAR		KeyByte;
	
	DEBUGFUNC(_T("SetKeyContext"));
    INITSTRWPA((_T("\n")));

#ifdef HOST_IF_USB

	USB_SetKeyContext(
			Adapter,
			UserId,
			EncMode,
			KeyID,
			pKeyContent
			);

	return;

#endif

	if (UserId & BIT_7){	// Set default key
		// Set Roll call table clear
		ZD1205_WRITE_REGISTER(Adapter,CAM_ROLL_CALL_TBL_L, 0x0);
		ZD1205_WRITE_REGISTER(Adapter,CAM_ROLL_CALL_TBL_H, 0x0);

		// Get Default Key start address
		Initial_Offset = DEFAULT_KEY_START_DWADDR;

		// Set Key_Context_Size
		Key_Context_Size_In_DW = 8;	// in unit of ULONG

		// Set Encryption mode
		ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
		while(OldMode & BIT_31){
			NdisStallExecution(10);
			ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
		}	

		//ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, (OldMode | HOST_RW));
		switch(EncMode){
		case AES:
			INITSTR((_T("CAM_AES_CCM\n")));
			ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_AES_CCM);
			Key_Size = 16;//32; //yarco
			break;
		case TKIP:
			INITSTR((_T("CAM_TKIP\n")));
			ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_TKIP);
			//ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, 0x22222222);//CAM_TKIP);
			Key_Size = 16;//32; //yarco
			break;	
		case WEP64:
			INITSTR((_T("CAM_WEP_64\n")));
			ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_64);
			Key_Size = 5;
			break;
		case WEP128:
			INITSTR((_T("CAM_WEP_128\n")));
			ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_128);
			Key_Size = 13;
			break;
		case WEP256:
			INITSTR((_T("CAM_WEP_256\n")));
			ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, CAM_WEP_256);
			Key_Size = 29;
			break;
		default:
			ASSERT(0);
			break;
		}
		ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, (DEFAULT_ENC_TYPE_DWADDR | WRITE_EN));		
		//ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, OldMode);
	}
	else{
		//Initial_Offset = USER_KEY_START_ADDR;
	}


	DWOffset = Initial_Offset +	(KeyID*Key_Context_Size_In_DW);
	ByteOffset = 0;

	ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
	//ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, (OldMode | HOST_RW));

	INITSTRWPA((_T("Key_Size = %d\n"), Key_Size));
	for (j=0;j<(Key_Size/4+1);j++){
	//for (j=0;j<4;j++){
		//ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, DWOffset);
		// Read twice to ensure valid data
		//ZD1205_READ_REGISTER(Adapter,CAM_DATA, &tmp);
		//ZD1205_READ_REGISTER(Adapter,CAM_DATA, &tmp);

		//tmp &= ~(0xff << (ByteOffset<<3));

		KeyByte = *(pKeyContent);
		tmp = KeyByte;
		pKeyContent++;
		
		KeyByte = *(pKeyContent);
		tmp |= KeyByte << 8;
		pKeyContent++;
		
		KeyByte = *(pKeyContent);
		tmp |= KeyByte << 16;
		pKeyContent++;
		
		KeyByte = *(pKeyContent);
		tmp |= KeyByte << 24;
		pKeyContent++;
	
		//tmp |= (KeyByte << (ByteOffset<<3));
		
		//yarco debug 4413
		while(OldMode & BIT_31){
			NdisStallExecution(10);
			ZD1205_READ_REGISTER(Adapter,CAM_MODE, &OldMode);
		}	
		ZD1205_WRITE_REGISTER(Adapter,CAM_DATA, tmp);
		ZD1205_WRITE_REGISTER(Adapter,CAM_ADDRESS, (DWOffset | WRITE_EN));

		DWOffset ++;
		//if (ByteOffset == 3){
		//	DWOffset += 1;
		//	ByteOffset = 0;
		//}else{
		//	ByteOffset +=1;
		//}
	}

	//ZD1205_WRITE_REGISTER(Adapter,CAM_MODE, OldMode);
}

#define		BEACON_TIME		1	


void
ResetDevice(
			IN PZD1205_ADAPTER Adapter
				)
{
	UCHAR	BeaconInterval[2];
	ULONG	tmpvalue;

	// Device will reset after 1ms
	BeaconInterval[0] = 0x2;
	BeaconInterval[1] = 0x0;
	UpdateBeaconInterval(Adapter, &BeaconInterval[0]);		
	ZD1205_WRITE_REGISTER(Adapter, Pre_TBTT, 0x1);

	//++ Ensure the following is an atomic operation.
#ifndef HOST_IF_USB
	irql = KeGetCurrentIrql();
	if ( irql < DISPATCH_LEVEL )
		KeRaiseIrql(DISPATCH_LEVEL, &OldIrql);
#endif
	//Adapter->DeviceInSleep = TRUE;
	ZD1205_READ_REGISTER(Adapter, PS_Ctrl, &tmpvalue);
	ZD1205_WRITE_REGISTER(Adapter, PS_Ctrl, (tmpvalue | BIT_0));
#ifndef HOST_IF_USB
	Adapter->DeviceInSleep = TRUE;
	if ( irql < DISPATCH_LEVEL )
		KeLowerIrql(OldIrql);
#endif
	// Delay 1ms to ensure device had been reset
	//NdisMSleep(1000);
#ifndef HOST_IF_USB
	NdisStallExecution(1000);
#endif

}


void
SleepResetDevice(
			IN PZD1205_ADAPTER Adapter
				)
{
	ULONG	tmpvalue;
	ULONG	ul_pretbtt;
	ULONG	ul_BcnItvl;
	ULONGLONG	TSFTimer;
	int		TryCount = 0;
	DEBUGFUNC(_T("SleepResetDevice"));

	// Prepare to enter sleep mode
	INITSTR((_T("Prepare to enter sleep mode\n")));

	//++ Turn off RF
	TurnOff_RF(Adapter);
	//--

	// Setup Pre_TBTT
	ZD1205_READ_REGISTER(Adapter, BCNInterval, &ul_BcnItvl);
	ul_BcnItvl &= 0xffff;
	if (Adapter->RF_Mode == AL2230_RF)
		UpdatePreTBTT(Adapter, ul_BcnItvl-15);
	else
		UpdatePreTBTT(Adapter, ul_BcnItvl-5);

	// Read exact value of Pre_TBTT
	ZD1205_READ_REGISTER(Adapter, Pre_TBTT, &ul_pretbtt);
	INITSTR((_T("Pre_TBTT = %d\n"), ul_pretbtt));

	while(1){
		// Make sure that the time issued sleep-command is not too close t0 Pre_TBTT.
		// Also make sure that sleep-command is out of Beacon-Tx duration.
		ZD1205_READ_REGISTER(Adapter,TSF_LowPart, &tmpvalue);
		TSFTimer = tmpvalue;
		ZD1205_READ_REGISTER(Adapter,TSF_HighPart, &tmpvalue);
		TSFTimer += (((ULONGLONG)tmpvalue) << 32);
		TSFTimer = TSFTimer >> 10; // in unit of TU
		INITSTR((_T("TSF(TU) %d \n"), TSFTimer));
		INITSTR((_T("BeaconInterval = %d\n"), ul_BcnItvl));

		TryCount++;
		if (TryCount > 10)	// if so, there must be something error
			break;

		if (ul_BcnItvl){
			INITSTR((_T("TSF mod BeaconInterval = %d\n"), (TSFTimer % ul_BcnItvl)));
		}
		else{
			INITSTR((_T("ul_BcnItvl = 0")));
			break;
		}

		if ((ul_pretbtt > (TSFTimer % ul_BcnItvl)) ||
			(Adapter->SurpriseRemoved)){
			//++ Ensure the following is an atomic operation.
#ifndef HOST_IF_USB
			irql = KeGetCurrentIrql();
			if ( irql < DISPATCH_LEVEL )
			    KeRaiseIrql(DISPATCH_LEVEL, &OldIrql);
#endif
			if ((((ul_pretbtt - (TSFTimer % ul_BcnItvl)) >= 3) &&
				((TSFTimer % ul_BcnItvl) > BEACON_TIME) &&
				(!Adapter->DoNotSleep))   ||
				(Adapter->SurpriseRemoved)){
				
#ifdef HOST_IF_USB
#ifndef CE_ALL
				//protect DeviceInSleep
				KeWaitForSingleObject(  &Adapter->PSSpinlockEvent, 
										Executive, 
										KernelMode, 
										FALSE, 
										NULL
										);      
#else
				WaitForSingleObject(Adapter->PSSpinlockEvent, INFINITE);
#endif
#endif				
				ZD1205_READ_REGISTER(Adapter,PS_Ctrl, &tmpvalue);
				ZD1205_WRITE_REGISTER(Adapter,PS_Ctrl, (tmpvalue | BIT_0));
				Adapter->DeviceInSleep = TRUE;

#ifndef HOST_IF_USB
			    if ( irql < DISPATCH_LEVEL )
				    KeLowerIrql(OldIrql);
#endif
				//--
				INITSTR((_T("Has been entered sleep mode\n")));
				
#ifdef HOST_IF_USB
				//protect DeviceInSleep
#ifndef CE_ALL
				KeSetEvent(&Adapter->PSSpinlockEvent, IO_NO_INCREMENT, FALSE);
#else  // CE_ALL
                SetEvent(Adapter->PSSpinlockEvent);
#endif  // CE_ALL
#endif				
				break;
			}
#ifndef HOST_IF_USB
			if ( irql < DISPATCH_LEVEL )
			    KeLowerIrql(OldIrql);
#endif
		}
		ZD1205_Sleep(1000);
	}
}


BOOLEAN
DestPowerSave(
			IN PZD1205_ADAPTER Adapter,
			IN PCHAR pDestAddr
			)
{
	ULONG		tmpvalue;

	if (Adapter->CardSetting.BSSType == INDEPENDENT_BSS){
		if ((Adapter->CardSetting.ATIMWindow != 0) && (Adapter->adapterReady)){
			// We must make sure that Device has been in IBSS mode and PwrMgt mode.
			ZD1205_READ_REGISTER(Adapter, BCNInterval, &tmpvalue);
			if ((tmpvalue & BIT_25) && (tmpvalue & BIT_26)){
				// ATIM could be sent only when BCNController is active.
				if ((*(pDestAddr) & BIT_0) || (Adapter->IBSS_Wakeup_Dest)){ // We should issue ATIM for multicast frame.
					Adapter->IBSS_Wakeup_Dest = FALSE;
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

void
Reset_Tally(
		IN PZD1205_ADAPTER Adapter
		)
{
	/*
	Adapter->Hw_TotalRxFrm=0;
	Adapter->Hw_CRC32Cnt=0;
	Adapter->Hw_CRC16Cnt=0;
	Adapter->Hw_DecrypErr_UNI=0;
	Adapter->Hw_DecrypErr_Mul=0;
	Adapter->Hw_RxFIFOOverrun=0;
	Adapter->Hw_TotalTxFrm=0;
	Adapter->Hw_UnderrunCnt=0;
	Adapter->Hw_RetryCnt=0;
	
	Adapter->DriverRxFrmCnt=0;
	Adapter->DriverDiscardedFrm=0;
	Adapter->LessThanDataMinLen=0;
	Adapter->GreaterThanMaxLen=0;
	Adapter->PLCP_MacLen_Mismatch=0;
	Adapter->NotifyNDISRxFrmCnt=0;
	Adapter->RetryFailCnt=0;
	Adapter->LossAP=0;
	Adapter->rxMulticastFrm=0;
	Adapter->rxMulticastOctets=0;
	Adapter->rxUnicastFrm=0;
	Adapter->rxUnicastOctets=0;
	Adapter->txMulticastFrm=0;
	Adapter->txMulticastOctets=0;
	Adapter->txUnicastFrm=0;
	Adapter->txUnicastOctets=0;
	Adapter->rxBroadcastFrm = 0;
	Adapter->rxBroadcastOctets = 0;
*/

	Adapter->txUnicastFrm = 0;		//txUnicastFrames
	Adapter->txMulticastFrm = 0;		//txMulticastFrames
	Adapter->txUnicastOctets = 0;	//txUniOctets  byte size
	Adapter->txMulticastOctets = 0;	//txMultiOctets  byte size
	Adapter->txFrmUpperNDIS = 0;
	Adapter->txFrmDrvMgt = 0;
	Adapter->RetryFailCnt = 0;		
	Adapter->Hw_TotalTxFrm = 0;		//Hardware total Tx Frame
	Adapter->Hw_RetryCnt = 0;		//txMultipleRetriesFrames
	Adapter->Hw_UnderrunCnt = 0;//
	Adapter->DriverRxFrmCnt = 0;//
	Adapter->rxUnicastFrm = 0;		//rxUnicastFrames
	Adapter->rxMulticastFrm = 0;	//rxMulticastFrames
	Adapter->NotifyNDISRxFrmCnt = 0;//
	Adapter->rxUnicastOctets = 0;	//rxUniOctets  byte size
	Adapter->rxMulticastOctets = 0;	//rxMultiOctets  byte size
	Adapter->DriverDiscardedFrm = 0;// Discard by ValidateFrame
	Adapter->LessThanDataMinLen = 0;//
	Adapter->GreaterThanMaxLen = 0;//
	Adapter->DriverDiscardedFrmCauseByMulticastList = 0;
	Adapter->DriverDiscardedFrmCauseByFrmCtrl = 0;
	Adapter->rxNeedFrgFrm = 0;		// need more frg frm
	Adapter->DriverRxMgtFrmCnt = 0;
	Adapter->rxBroadcastFrm = 0;	//Receive broadcast frame count
	Adapter->rxBroadcastOctets = 0;	//Receive broadcast frame byte size
	Adapter->Hw_TotalRxFrm = 0;//
	Adapter->Hw_CRC16Cnt = 0;		//rxPLCPCRCErrCnt
	Adapter->Hw_CRC32Cnt = 0;		//rxCRC32ErrCnt
	Adapter->Hw_DecrypErr_UNI = 0;//
	Adapter->Hw_DecrypErr_Mul = 0;//
	Adapter->Hw_RxFIFOOverrun = 0;//
	Adapter->LossAP = 0;//			
#ifdef HOST_IF_USB
    Adapter->Continue2Rx = 0;               // Reserve 1
    Adapter->WaitLenInfoCnt = 0;            // Reserve 2
#endif

#if	(defined(GCCK) && defined(OFDM))
	Adapter->rx11bDataFrame = 0;
	Adapter->rxOFDMDataFrame = 0;
#endif
#ifdef HOST_IF_USB
	Adapter->REG_6e4_Add = 0;
#endif

}
void
TurnOn_RF(
	  		IN PZD1205_ADAPTER Adapter
		)
{
//ULONG	systemUpTime;
//	NdisGetSystemUpTime(&systemUpTime);
//	DbgPrint(" RF off for %u at %u\n", systemUpTime-Adapter->tRFChange,systemUpTime);
//	Adapter->tRFChange=systemUpTime;
//static UCHAR    DbgCnt = 0;
	if (Adapter->ZDConfigTurnOffRF) 
		return;

	if (Adapter->LED_Ctrl_Type ==1)//chi 2004/08/06 LED_Ctrl_Type-->RF_LED
	{
		RF_LED_ON(Adapter);
	}


    switch(Adapter->RF_Mode){
        case GCT_RF:
            Set_IF_Synthesizer(Adapter, 0x1c0008);
            break;
        case RFMD_RF:
    //JWEI 2004/02/14
            if (!(Adapter->PhyTest & BIT_2))
                Set_IF_Synthesizer(Adapter, 0x000007);
            if (!(Adapter->PhyTest & BIT_0))
            {
            ULONG   tmpvalue;

                AcquireCtrOfPhyReg(Adapter);
 				ZD1205_WRITE_REGISTER(Adapter, CR10, 0x89);
				ZD1205_WRITE_REGISTER(Adapter, CR11, 0x00);
                ZD1205_READ_REGISTER(Adapter, CR11, &tmpvalue);
                tmpvalue &= 0xFF;
                if (tmpvalue != 0x00)
                {
                    if (Adapter->PhyTest & BIT_1)
                    {
                    UCHAR   ii;

                        for (ii = 0; ii < 10; ii ++)
                        {
                            ZDDbgPrint((_T(" [On_%d.%02X]\r\n"), ii, tmpvalue));
                            ZD1205_Sleep(1000);
                            ZD1205_WRITE_REGISTER(Adapter, CR11, 0x00);
                            ZD1205_READ_REGISTER(Adapter, CR11, &tmpvalue);
                            if ((tmpvalue & 0xFF) == 0x00)
                                break;
                        }
                    }
                    else
                        ZDDbgPrint((_T(" [On_.%02X]\r\n"), tmpvalue));
                }
                ReleaseCtrOfPhyReg(Adapter);
            }
            ZDDbgPrint((_T("Turn On RF+++++++++++++++++++++++++++++++++++++\n")));
			
        #if 0
            ZDDbgPrint((_T(" <On%X> "), Adapter->PhyTest));
            DbgCnt ++;
            if (DbgCnt >= 8)
            {
                DbgCnt = 0;
                ZDDbgPrint((_T("\r\n")));
            }
        #endif
            break;

        case AL2230_RF:
            {
				ULONG   tmpvalue;

                AcquireCtrOfPhyReg(Adapter);
                tmpvalue &= 0xFF;
                {
                    UCHAR   ii;

                    for (ii = 0; ii < 10; ii ++)
                    {
                        ZDDbgPrint((_T(" [On_%d.%02X]\r\n"), ii, tmpvalue));
                        ZD1205_Sleep(1000);
                        ZD1205_WRITE_REGISTER(Adapter, CR11, 0x00);
                        ZD1205_READ_REGISTER(Adapter, CR11, &tmpvalue);
                        if ((tmpvalue & 0xFF) == 0x00)
                            break;
                    }
                }
				ZD1205_WRITE_REGISTER(Adapter, CR251, 0x3f); 
                ReleaseCtrOfPhyReg(Adapter);
            }
            ZDDbgPrint((_T("Turn On RF------------------------------------\n")));
            break;  
			
        default:
            break;
    }
}

void
TurnOff_RF(
	  		IN PZD1205_ADAPTER Adapter
		)
{
//ULONG	systemUpTime;
//	NdisGetSystemUpTime(&systemUpTime);
//	DbgPrint("    ----------RF ON for %u at %u\n", systemUpTime-Adapter->tRFChange,systemUpTime);
//	Adapter->tRFChange=systemUpTime;
		
	if (Adapter->LED_Ctrl_Type ==1)//chi 2004/08/06 LED_Ctrl_Type-->RF_LED
	{
		RF_LED_OFF(Adapter);
	}

    switch(Adapter->RF_Mode){
        case GCT_RF:
            Set_IF_Synthesizer(Adapter, 0x1c0000);
            break;
        case RFMD_RF:
    //JWEI 2004/02/14
            if (!(Adapter->PhyTest & BIT_0))
            {
            ULONG   tmpvalue;

                AcquireCtrOfPhyReg(Adapter);
                ZD1205_WRITE_REGISTER(Adapter, CR11, 0x15);
                ZD1205_READ_REGISTER(Adapter, CR11, &tmpvalue);
                ZD1205_WRITE_REGISTER(Adapter, CR10, 0x81);
                ReleaseCtrOfPhyReg(Adapter);
                tmpvalue &= 0xFF;
                if (tmpvalue != 0x15)
                    ZDDbgPrint((_T(" [Off_%02X]\r\n"), tmpvalue));
            }
            if (!(Adapter->PhyTest & BIT_2))
                Set_IF_Synthesizer(Adapter, 0x00000F);
            ZDDbgPrint((_T("Turn Off RF------------------------------------\n")));
            break;

        case AL2230_RF:
            {

                AcquireCtrOfPhyReg(Adapter);
                ZD1205_WRITE_REGISTER(Adapter, CR11, 0x04);
				ZD1205_WRITE_REGISTER(Adapter, CR251, 0x2f); 
                ReleaseCtrOfPhyReg(Adapter);
            }
            ZDDbgPrint((_T("Turn Off RF------------------------------------\n")));
            break;  
			
		default:
            break;
    }
}


void
Write_TxGain(
			 IN PZD1205_ADAPTER Adapter,
			 ULONG		txgain
		)
{
	ULONG	tmpvalue;
	UCHAR	i;

    switch(Adapter->RF_Mode)
    {
		case GCT_RF:
			txgain &= 0x3f;
			Adapter->TxGainSetting = (UCHAR)txgain;
			tmpvalue = 0;
			// Perform Bit-Reverse
			for (i=0;i<6;i++){
				if (txgain & BIT_0){
					tmpvalue |= (0x1 << (15-i));
				}
				txgain = (txgain >> 1);
			}
			tmpvalue |= 0x0c0000;
			Set_IF_Synthesizer(Adapter, tmpvalue);
			Set_IF_Synthesizer(Adapter, 0x150800);
			Set_IF_Synthesizer(Adapter, 0x150000);
			break;
        case AL2210_RF:
            if (txgain > AL2210_MAX_TX_PWR_SET)
                txgain = AL2210_MAX_TX_PWR_SET;
            else if (txgain < AL2210_MIN_TX_PWR_SET)
                txgain = AL2210_MIN_TX_PWR_SET;
            Adapter->TxGainSetting = (UCHAR) txgain;
            AcquireCtrOfPhyReg(Adapter);
            ZD1205_WRITE_REGISTER(Adapter, CR31, txgain);
            ReleaseCtrOfPhyReg(Adapter);
            break;
		default:
			break;
	}
}

//``JWEI 2003/12/22
void Write_TxGain0(IN PZD1205_ADAPTER Adapter, UCHAR *pTxGain, UCHAR TxPwrType)
{
    switch (Adapter->RF_Mode)
    {
        case MAXIM_NEW_RF:                  //``JWEI 2003/12/22
            *pTxGain &= MAXIM2_MAX_TX_PWR_SET;
        #if 1
            AcquireCtrOfPhyReg(Adapter);
            if (TxPwrType != cTX_OFDM)
            {
                ZD1205_WRITE_REGISTER(Adapter, CR31, *pTxGain);
            }
            else
            {
            #if !fTX_GAIN_OFDM
                ZD1205_WRITE_REGISTER(Adapter, CR31, *pTxGain);
            #else
                ZD1205_WRITE_REGISTER(Adapter, CR51, *pTxGain);
                ZD1205_WRITE_REGISTER(Adapter, CR52, *pTxGain);
                ZD1205_WRITE_REGISTER(Adapter, CR53, *pTxGain);
            #endif
            }
            ReleaseCtrOfPhyReg(Adapter);
        #endif
            break;
        case RFMD_RF:                  //
		case AL2230_RF:
        #if 1
            AcquireCtrOfPhyReg(Adapter);
            if (TxPwrType != cTX_OFDM)
            {
                ZD1205_WRITE_REGISTER(Adapter, CR31, *pTxGain);
            }
            else
            {
            #if !fTX_GAIN_OFDM
                ZD1205_WRITE_REGISTER(Adapter, CR31, *pTxGain);
            #else
                ZD1205_WRITE_REGISTER(Adapter, CR51, *pTxGain);
                ZD1205_WRITE_REGISTER(Adapter, CR52, *pTxGain);
                ZD1205_WRITE_REGISTER(Adapter, CR53, *pTxGain);
            #endif
            }
            ReleaseCtrOfPhyReg(Adapter);
        #endif
            break;
        default:
            break;
    }
}

void Write_TxGain1(IN PZD1205_ADAPTER Adapter, UCHAR txgain, UCHAR TxPwrType)
{
UCHAR   *pTxGain;

    Write_TxGain0(Adapter, &txgain, TxPwrType);

#if fTX_GAIN_OFDM
    if (TxPwrType != cTX_OFDM)
        pTxGain = &(Adapter->TxGainSetting);
    else
        pTxGain = &(Adapter->TxGainSetting2);
#else
    pTxGain = &(Adapter->TxGainSetting);
#endif
    JWeiDbgPrint3(1, (" [Gain1 = 0x%02X, 0x%02X] ", *pTxGain, txgain));
    *pTxGain = txgain;
}

void Write_TxGain2(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType)
{
UCHAR   *pTxGain;

    if (TxPwrType != cTX_OFDM)
    {
        pTxGain = &(Adapter->TxGainSetting);
    //    JWeiDbgPrint3(1, (" [GainCCK = 0x%02X] ", *pTxGain));
    }
    else
    {
    #if fTX_GAIN_OFDM
        pTxGain = &(Adapter->TxGainSetting2);
    #else
        pTxGain = &(Adapter->TxGainSetting);
    #endif
    //    JWeiDbgPrint3(1, (" [GainOFDM = 0x%02X] ", *pTxGain));
    }
    Write_TxGain0(Adapter, pTxGain, TxPwrType);
}

void IncreaseTxPower(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType)
{
UCHAR   *pTxGain;

#if fTX_GAIN_OFDM
    if (TxPwrType != cTX_OFDM)
        pTxGain = &(Adapter->TxGainSetting);
    else
        pTxGain = &(Adapter->TxGainSetting2);
#else
    pTxGain = &(Adapter->TxGainSetting);
#endif

    JWeiDbgPrint3(0, ("\n"));
    JWeiDbgPrint3(0, (" ****[Inc 0x%02X", *pTxGain));
    switch (Adapter->RF_Mode)
    {
        case MAXIM_NEW_RF:
            if (*pTxGain < MAXIM2_MAX_TX_PWR_SET)
                (*pTxGain) ++;
            break;
        //JWEI 2004/02/24
        case RFMD_RF:
            if (*pTxGain < RFMD_MAX_TX_PWR_SET)
                (*pTxGain) ++;
            break;
        case AL2230_RF:
            if (*pTxGain < AL2230_MAX_TX_PWR_SET)
                (*pTxGain) += 2;
            break;
    #if 0
        case GCT_RF:
            if (*pTxGain < GCT_MAX_TX_PWR_SET)
                (*pTxGain) ++;
            break;
        case AL2210_RF:
            if (*pTxGain > AL2210_MIN_TX_PWR_SET)
                (*pTxGain) --;
            break;
    #endif
        default:
            break;
    }
    JWeiDbgPrint3(0, ("-> 0x%02X]****\n", *pTxGain));
    Write_TxGain2(Adapter, TxPwrType);
}

void DecreaseTxPower(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType)
{
UCHAR   *pTxGain;

#if fTX_GAIN_OFDM
    if (TxPwrType != cTX_OFDM)
        pTxGain = &(Adapter->TxGainSetting);
    else
        pTxGain = &(Adapter->TxGainSetting2);
#else
    pTxGain = &(Adapter->TxGainSetting);
#endif

    JWeiDbgPrint3(0, ("\n"));
    JWeiDbgPrint3(0, (" ****[Dec 0x%02X", *pTxGain));
    switch (Adapter->RF_Mode)
    {
        case MAXIM_NEW_RF:
            if (*pTxGain > MAXIM2_MIN_TX_PWR_SET)
                (*pTxGain) --;
            break;
        //JWEI 2004/02/24
        case RFMD_RF:
            if (*pTxGain > RFMD_MIN_TX_PWR_SET)
                (*pTxGain) --;
            break;
        case AL2230_RF:
            if (*pTxGain > AL2230_MIN_TX_PWR_SET)
                (*pTxGain) -= 2;
            break;
    #if 0
        case GCT_RF:
            if (*pTxGain > GCT_MIN_TX_PWR_SET)
                (*pTxGain) --;
            break;
        case AL2210_RF:
            if (*pTxGain < AL2210_MAX_TX_PWR_SET)
                (*pTxGain) ++;
            break;
    #endif
        default:
            break;
    }
    JWeiDbgPrint3(0, ("-> 0x%02X]****\n", *pTxGain));
    Write_TxGain2(Adapter, TxPwrType);
}

// Switch to another antenna
void SwitchAntenna(PZD1205_ADAPTER Adapter)
{
#if 0
    JWeiDbgPrint2(("Switch antenna\n"));
#else
ULONG   tmpvalue;

	// For AL2230 and RFMD only
	if (Adapter->RF_Mode == AL2230_RF ||
		Adapter->RF_Mode == RFMD_RF)
	{
		AcquireCtrOfPhyReg(Adapter);
		if (Adapter->CurrentAntenna)
		{// Switch to Antenna 0
			ZD1205_WRITE_REGISTER(Adapter, CR10, 0x89);
			if (Adapter->bTxFoloRx)
				ZD1205_WRITE_REGISTER(Adapter, CR9, 0x20);
			Adapter->CurrentAntenna=0;
		}
		else
		{// Switch to Antenna 1
			ZD1205_WRITE_REGISTER(Adapter, CR10, 0x8B);
			if (Adapter->bTxFoloRx)
				ZD1205_WRITE_REGISTER(Adapter, CR9, 0x24);
			Adapter->CurrentAntenna=1;
		}
		ReleaseCtrOfPhyReg(Adapter);
#if DBG_ANTDIV
		//DbgPrint("Switch to Ant %d\n",Adapter->CurrentAntenna); // jxiaoDbg
#endif
		return;
	}

    AcquireCtrOfPhyReg(Adapter);
    ZD1205_READ_REGISTER(Adapter, CR10, &tmpvalue);
    tmpvalue ^= BIT_1;
    ZD1205_WRITE_REGISTER(Adapter, CR10, tmpvalue);
	Adapter->CurrentAntenna=tmpvalue & BIT_1;
	//jxiaoDbg
	//DbgPrint(" Switch to Ant %d\n",Adapter->CurrentAntenna);
    JWeiDbgPrint2(("Switch to antenna %d\n", (tmpvalue & BIT_1) >> 1));
    ZD1205_READ_REGISTER(Adapter, CR9, &tmpvalue);
    tmpvalue ^= BIT_2;
    ZD1205_WRITE_REGISTER(Adapter, CR9, tmpvalue);
    ReleaseCtrOfPhyReg(Adapter);
#endif
}

