/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    u_tx.c

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/

#include "precomp.h"

//---------------------------------------------------------------------------
//	Function prototype
//---------------------------------------------------------------------------

ULONG
USB_BuildDataToSend(PZD1205_ADAPTER	Adapter)
{
    PZD1205SwTcb			SwTcb;
    PTBD_STRUC				Tbd;
	PUCHAR					dst = Adapter->pTxEPBuffer;
	ULONG					TotalLength = 0;

	BOOLEAN					bIs8021XAuth = 0;
	
	// Setup Debug flag	
	ULONG				DebugPrint = Adapter->USBDbgFlag & DBGMSG_TX;
	DEBUGFUNC(_T("USB_BuildDataToSend"));

	//ZDUSBDbg((_T("----- start -----\n")));


	if (QueueEmpty(&Adapter->ActiveChainList)){

		//USBDBGSTR(DebugPrint,("ActiveChainList empty, so stop Tx\n"));
		//INITSTR((_T("ActiveChainList empty, so stop Tx\n")));

		return 0;
	}


    
	SwTcb = (PZD1205SwTcb) QueueGetHead(&Adapter->ActiveChainList);

	Tbd = SwTcb->FirstTbd;

	ASSERT((TotalLength + Tbd->TbdCount) <= BODY_RESERVED_SIZE + sizeof(CTRL_STRUC) + sizeof(HEADER_STRUC));

	// We skip TCB address, Address 1, NextLength = 16 bytes, add 2 bytes for total length

	NdisMoveMemory(	dst,
					(PUCHAR)(SwTcb->HwCtrlPtr),
					3
					);
	dst += 3;
	TotalLength += 3;


	NdisMoveMemory(	dst,
					(PUCHAR)(SwTcb->HwCtrlPtr)+(3+8),	// 8 mean skip TCB address
					1						// misc
					);

	dst += 1;
	TotalLength += 1;

	dst += 2;								// reserver 2 bytes for total length
	TotalLength += 2;

	NdisMoveMemory(	dst,
					(PUCHAR)(SwTcb->HwCtrlPtr)+(3+8+1+6+2),	// 6:skip address 1, 2:skip next length
					5
					);

	dst += 5;
	TotalLength += 5;

    //USBDBGSTR(DebugPrint,("Tx Ctrl Length = %d\n", TotalLength));
	//INITSTR((_T("Tx Ctrl Length = %d\n"), TotalLength));

	Tbd++;

	ASSERT((TotalLength + Tbd->TbdCount) <= BODY_RESERVED_SIZE + sizeof(CTRL_STRUC) + sizeof(HEADER_STRUC));

	NdisMoveMemory(	dst,
					SwTcb->HwHeaderPtr,
					Tbd->TbdCount
					);

    //USBDBGSTR(DebugPrint,("MAC Header Length = %d\n", Tbd->TbdCount));
	//INITSTR((_T("MAC Header Length = %d\n"), Tbd->TbdCount));

	dst += Tbd->TbdCount;
	TotalLength += Tbd->TbdCount;
	Tbd++;

	ASSERT((TotalLength + Tbd->TbdCount) <= BODY_RESERVED_SIZE + sizeof(CTRL_STRUC) + sizeof(HEADER_STRUC));

    //USBDBGSTR(DebugPrint,("CoalesceRemoveLen %d, PrvFragLenTx %d\n", SwTcb->Coalesce->CoalesceRemoveLen, Tbd->PrvFragLen));
	//INITSTR((_T("CoalesceRemoveLen %d, PrvFragLenTx %d\n"), SwTcb->Coalesce->CoalesceRemoveLen, Tbd->PrvFragLen));

	NdisMoveMemory(	dst,
					&(SwTcb->Coalesce->HwCoalesce->FrmBody[
							SwTcb->Coalesce->CoalesceRemoveLen
							+ Tbd->PrvFragLen]),
					Tbd->TbdCount
					);

    //USBDBGSTR(DebugPrint,("Tx DATA Length = %d\n", Tbd->TbdCount));
	//INITSTR((_T("Tx DATA Length = %d\n"), Tbd->TbdCount));
#if 0
	if ((*((PUSHORT)(dst+6)) == 0x8E88) && (Tbd->PrvFragLen == 0) &&
		(*(dst+9) == 3)	&&	//802.1x Packet type EAPOL-key
		//(*((PUSHORT)(dst+10)) > 0)	&&	//802.1x Packet length
		(*((PUSHORT)(dst+10)) == 0x5F00)	&&	//802.1x Packet length
		(*(dst+14) & BIT_3) //Is pairwire key
		){
		// first fragment and is 802.1x auth packet, and is pairwire key
		bIs8021XAuth = TRUE;
		//ZDDbgPrint((_T("Differ Sned EAPOL-Key 0x%x\n"), *((PUSHORT)(dst+13))));
	}
#endif
	dst += Tbd->TbdCount;
	TotalLength += Tbd->TbdCount;
	Tbd++;
	
	if (SwTcb->Tcb->TxCbTbdNumber == 4){
		// extra MIC 
		//USBDBGSTR(DebugPrint,(" extra MIC %d\n", Tbd->TbdCount));
		//INITSTR((_T(" extra MIC %d\n"), Tbd->TbdCount));

		NdisMoveMemory(	dst,
						SwTcb->HwMicPtr,
						Tbd->TbdCount
						);
		TotalLength += Tbd->TbdCount;
	}


    //USBDBGSTR(DebugPrint,("TotalLength = %d\n", TotalLength));
	//INITSTR((_T("TotalLength = %d\n"), TotalLength));

	{	// write down total length
		*((PUSHORT)(Adapter->pTxEPBuffer+4)) = (USHORT)TotalLength + 14;

		//USBDBGSTR(DebugPrint,("Adapter->pTxEPBuffer+4 = %d\n", *((PUSHORT)(Adapter->pTxEPBuffer+4))));
		//INITSTR((_T("Adapter->pTxEPBuffer+4 = %d\n"), *((PUSHORT)(Adapter->pTxEPBuffer+4)) ));
		ASSERT(*(PUSHORT)(Adapter->pTxEPBuffer+4) > 20);
	}
 
	if ((SwTcb->LastFrag) && (SwTcb->Provider==UPPER_NDIS)){

		if (!SwTcb->bHasCompleteBeforeSend){
			//NdisMSendComplete(
			//	Adapter->ZD1205AdapterHandle,
			//	SwTcb->Packet,
			//	NDIS_STATUS_SUCCESS);

			SwTcb->bHasCompleteBeforeSend = TRUE;
		}

		// For WPA bug, delay Tx for a while
		if (bIs8021XAuth && (!SwTcb->bHasBeenDelayedBefore)){

			Mgt_SendNotification(Adapter, RQ_RESTART_TXRXEP);

			SwTcb->bHasBeenDelayedBefore = TRUE;
			
			return 0;
		}
	}

    //ZDUSBDbg((_T("-----  end  -----\n")));

	return TotalLength;
}

NDIS_STATUS
USB_StartTxEP(PZD1205_ADAPTER Adapter)
{
    NDIS_STATUS      status;

	DEBUGFUNC(_T("USB_StartTxEP"));
	//INITSTR((_T("\n")));

	if ( Adapter->USBInfo.hTxEP != NULL )
	{
		INITSTR((_T("USB_StartTxEP Tx EP already started!!!!\n")));
	
		return NDIS_STATUS_SUCCESS;
	}
    
	if (!Adapter->bUSBDeveiceAttached)
	{
	    //INITSTR((_T("Device not attached!!\n")));
		return NDIS_STATUS_FAILURE;
	}
 
    //ResetEvent(Adapter->USBTxEPStopEvent);

	NdisAllocateMemory(	(PVOID *)(&Adapter->pTxEPBuffer),
						BODY_RESERVED_SIZE + sizeof(CTRL_STRUC) + sizeof(HEADER_STRUC),
						0,
						HighestAcceptableMax
						);

    //status = USB_MPSenToTxEP(Adapter);

    //SetEvent(Adapter->StartTxEvent);

    return status;
}

NDIS_STATUS
USB_StopTxEP(PZD1205_ADAPTER Adapter)
{
    return STATUS_SUCCESS;
}

NDIS_STATUS
USB_MPSenToTxEP(PZD1205_ADAPTER Adapter, UCHAR HandleNo)
{
	ULONG				DataLength;
	HANDLE              handle;
    int                 priority;
	DWORD               ret, oldTime;
	BOOL                bRet;
	ULONGLONG           time;
	ZD1211_IRQL         OldIrql;
	int                 ii=0;

	DEBUGFUNC(_T("USB_MPSenToTxEP"));
	//INITSTR((_T("\n")));
   
	handle = GetCurrentThread();
    ZDUSBDbg((_T("----- start -----\n")));

	if (!Adapter->bUSBDeveiceAttached)
	{
	    //INITSTR((_T("Device not attached!!\n")));
		USB_FreeTxEPResource(Adapter);
		ZDDbgPrint((_T("USB device not attached\n")));
		return NDIS_STATUS_FAILURE;
	}
    

	priority = CeGetThreadPriority(handle);

	CeSetThreadPriority(handle, 251);
	//CeSetThreadPriority(handle, 248);

	//ResetEvent(Adapter->WaitTxEvent);


	ZDDbg((_T("Get SpinLock\n")));
	ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);

	DataLength = USB_BuildDataToSend(Adapter);

	if (!DataLength)
	{
        //USB_FreeTxEPResource(Adapter);
		ZDDbgPrint((_T("DataLength = 0\n")));
	//	CeSetThreadQuantum(handle, oldTime);
		ZDDbg((_T("---------->>> Release SpinLock\n")));
		ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
		return NDIS_STATUS_FAILURE;
	}
	

	Adapter->TxSendStartTime = GetTickCount();	// record Tx start time

	Adapter->TxCount++;

    //Adapter->USBInfo.hTxEP = (Adapter->USBInfo.lpUsbFuncs->lpIssueBulkTransfer)(
    Adapter->TxTransfer[HandleNo].handle = (Adapter->USBInfo.lpUsbFuncs->lpIssueBulkTransfer)(
		                               Adapter->USBInfo.hPipe[EP_DATA_OUT],
									   USB_MPSenToTxEP_Complete,
									   //NULL,
									   (LPVOID) &(Adapter->TxTransfer[HandleNo].status),
									   USB_OUT_TRANSFER, //| USB_NO_WAIT,
									   DataLength,
									   (PVOID)(Adapter->pTxEPBuffer),
									   0
									   );

	Adapter->TxTransfer[HandleNo].status++;
	//SetEvent(Adapter->TransferLockEvent);
		
    Adapter->txrun = 0;

	//if ( Adapter->USBInfo.hTxEP == NULL )
	//{
	//	DbgPrint("!!!!!!!!!! Failed to start TX EP !!!!!!!!!!\n");
		//USB_FreeTxEPResource(Adapter);
	    //ZDDbg((_T("---------->>> Release SpinLock\n")));
	    //ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);		
		//return NDIS_STATUS_FAILURE;
	//}
	{
		PZD1205SwTcb          SwTcb = 0;

		//ZDDbgPrint((_T("Send Length %d\n"), dwLen));

		SwTcb = (PZD1205SwTcb) QueueGetHead(&Adapter->ActiveChainList);

		if (SwTcb) 
			SwTcb->Tcb->CbStatus = CB_STATUS_COMPLETE;

		ProcessTXInterrupt(Adapter, &OldIrql);	
	}

	ZDDbg((_T("---------->>> Release SpinLock\n")));
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);
    
	//if ( !Adapter->adapterReady )
    //ret = WaitForSingleObject(Adapter->WaitTxEvent, 20); // wait 500 ms


	//DbgPrint("Sending length = %d\r\n", DataLength);
	//DbgPrint("Sending length = %x\r\n", Adapter->TxCount);

	//DbgPrint("----- end -----");
    ZDUSBDbg((_T("-----  end  -----\n")));

	return NDIS_STATUS_SUCCESS;
}

DWORD WINAPI
USB_MPSenToTxEP_Complete(LPVOID pContext)
{
	//PZD1211_TX_CONTEXT   pTxContext = (PZD1211_TX_CONTEXT) pContext;
	//PZD1205_ADAPTER   Adapter = (PZD1205_ADAPTER) pTxContext->Adapter;
	// Setup Debug flag
	//ULONG				 DebugPrint = Adapter->USBDbgFlag & DBGMSG_TX;
	PUCHAR   pStatus = (PUCHAR) pContext;

	DEBUGFUNC(_T("USB_MPSenToTxEP_Complete"));
	//INITSTR((_T("\n")));

	//Adapter->TxCount++;
    ZDUSBDbg((_T("----- start -----\n")));

    (*pStatus)++;

    //SetEvent(Adapter->WaitTxEvent);


	//Adapter->TxPending--;
    ZDUSBDbg((_T("-----  end  -----\n")));

    return 0;

}

void
USB_FreeTxEPResource(PZD1205_ADAPTER Adapter)
{

    if ( Adapter->USBInfo.hTxEP )
	{
	    (Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(Adapter->USBInfo.hTxEP);
		Adapter->USBInfo.hTxEP = NULL;
	}
}

BOOLEAN
USB_ResetTxQueue(PZD1205_ADAPTER Adapter)
{
	/*
    while(Adapter->FirstTxQueue)
    {
        PNDIS_PACKET QueuePacket = Adapter->FirstTxQueue;

        Adapter->NumPacketsQueued--;
        DequeuePacket(Adapter->FirstTxQueue, Adapter->LastTxQueue);

        // we must release the lock here before returning control to ndis
        // (even temporarily like this)
		//KeReleaseSpinLock(&Adapter->Lock, OldIrql);

        NdisMSendComplete(
            Adapter->ZD1205AdapterHandle,
            QueuePacket,
			NDIS_STATUS_SUCCESS);
            //NDIS_STATUS_FAILURE);
	
		//KeAcquireSpinLock(&Adapter->Lock, &OldIrql);
    }

	if ( Adapter->USBInfo.hTxEP )
	{
		// Tx loop still running, so can not clean ActiveChainList
		return FALSE;
	}

    while (!(QueueEmpty(&Adapter->ActiveChainList)))
    {
        // here we have to fail any sends that haven't completed yet
        PZD1205SwTcb pSwTcb = (PZD1205SwTcb) QueuePopHead(&Adapter->ActiveChainList);

		if (pSwTcb->LastFrag){
			if (pSwTcb->Provider==UPPER_NDIS)
			{

				if (!pSwTcb->bHasCompleteBeforeSend)
				{
					NdisMSendComplete(
						Adapter->ZD1205AdapterHandle,
						pSwTcb->Packet,
						NDIS_STATUS_SUCCESS);
				}

			}
			else
			{
				NdisQueryPacket(pSwTcb->Packet, NULL, NULL, &pSwTcb->FirstBuffer, NULL);
				NdisFreeBuffer(pSwTcb->FirstBuffer);
				NdisFreePacket(pSwTcb->Packet);
			}
		}
    }
    
	// Clear out our software transmit structures
    NdisZeroMemory((PVOID) Adapter->XmitCached, Adapter->XmitCachedSize);

    SetupTransmitQueues(Adapter, FALSE);
    */
	return TRUE;
}

NDIS_STATUS
USB_CloseTxTransfer(PZD1205_ADAPTER Adapter)
{
    BOOL      bRet;
	DWORD     dwLen, dwError;
	int       ii;

	if ( (GetTickCount() - Adapter->TxSendStartTime) < 2000 )
		return NDIS_STATUS_SUCCESS;

	if ( Adapter->txrun )
		return NDIS_STATUS_SUCCESS;

	if ( Adapter->USBInfo.hTxEP != NULL )
	{
		Adapter->TxSendStartTime = 0;

		bRet = FALSE;
   
		bRet = (Adapter->USBInfo.lpUsbFuncs->lpIsTransferComplete)(Adapter->USBInfo.hTxEP);

		(Adapter->USBInfo.lpUsbFuncs->lpGetTransferStatus)(
						   Adapter->USBInfo.hTxEP,
						   &dwLen,
						   &dwError
						   );
        
		DbgPrint("close : sent bytes = %d", dwLen);

		if ( bRet )
		{
			//DbgPrint("Tx normal = %d", GetTickCount()-time);
			(Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(Adapter->USBInfo.hTxEP);
			Adapter->USBInfo.hTxEP = NULL;		    
		}
		else
		{
			DbgPrint("close : Tx abnormal!!!");
			if ( (dwError != USB_NO_ERROR) ) 
			{
				Adapter->TxEPRestart++;
				DbgPrint("Close : Tx EP error occurred!! = %d\n", dwError);
			}
			// wait until the transfer is cancelled
			(Adapter->USBInfo.lpUsbFuncs->lpAbortTransfer)(Adapter->USBInfo.hTxEP, USB_NO_WAIT);
            Adapter->USBInfo.hTxEP = NULL;
		}		
	}

    

	return NDIS_STATUS_SUCCESS;
}