/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    u_pnp.c

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/
#include "precomp.h"

#define fDUMP_READ_EEPDATA      0
#define fLOAD_FPGA_FW           0           //JWEI 2004/03/12
#define fLOAD_TEST_FW           0
#define fFORCE_LOAD_FW          (0 || fLOAD_FPGA_FW || fLOAD_TEST_FW)

//JWEI 2004/02/05
UCHAR WS11UPh[]
#ifndef fWRITE_WORD_REG
	#include "WS11UPh.h"
#else
	#if fMERGE_RX_FRAME
		#include "WS11UPhR.h"
		UCHAR WS11UPhm[]
		#include "WS11UPhm.h"
	#else
		#include "WS11UPhm.h"
	#endif
#endif

#if fLOAD_BOOTCODE
//JWEI 2004/02/27
UCHAR WS11Ur[]
#include "WS11Ur.h"

UCHAR WS11Ub[]
#include "WS11Ub.h"
#endif

//JWEI 2004/03/17
#ifdef fNEW_CODE_MAP
UCHAR WS11Ur2[(0xEE00 - 0xEC00) * 2] = { 0x0F, 0x9F, 0x00, 0xEE };  // JMP 0xEE00
#endif

BOOLEAN
Download_IncludeFile(PZD1205_ADAPTER Adapter);

//---------------------------------------------------------------------------
//	Function prototype
//---------------------------------------------------------------------------

LONG
USB_CompleteCountIncrement(IN OUT PZD1205_ADAPTER Adapter)
{
    LONG		result = 0;
	ZD1211_IRQL	OldIrql;	

	// Setup Debug flag	
	ULONG				DebugPrint = Adapter->USBDbgFlag & DBGMSG_USBIO;
	DEBUGFUNC(_T("USB_CompleteCountIncrement"));


	//KeAcquireSpinLock(&Adapter->EPIOCountLock, &OldIrql);
	ZDDbg((_T("Get SpinLock\n")));
	ZD1211_AcquireSpinLock(Adapter, &Adapter->EPIOCountLock, &OldIrql);

    result = InterlockedIncrement(&Adapter->EPIOCount);

    //
    // when OutStandingIO bumps from 1 to 2, clear the StopEvent
    //

    if(result == 1) {
	    ResetEvent(Adapter->USBEPStopEvent);
    }

    USBDBGSTR(DebugPrint,(_T("EPIOCount=%d\n"), result));

	//KeReleaseSpinLock(&Adapter->EPIOCountLock, OldIrql);
	//ZDDbg((_T("---------->>> Release SpinLock\n")));
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->EPIOCountLock, OldIrql);

    return result;
}

LONG
USB_CompleteCountDecrement(IN OUT PZD1205_ADAPTER Adapter)
{
    LONG		result = 0;
	ZD1211_IRQL	OldIrql;	

	// Setup Debug flag	
	ULONG				DebugPrint = Adapter->USBDbgFlag & DBGMSG_USBIO;
	DEBUGFUNC(_T("USB_CompleteCountDecrement"));


	//KeAcquireSpinLock(&Adapter->EPIOCountLock, &OldIrql);
	ZDDbg((_T("Get SpinLock\n")));
	ZD1211_AcquireSpinLock(Adapter, &Adapter->EPIOCountLock, &OldIrql);

    result = InterlockedDecrement(&Adapter->EPIOCount);

    //
    // when OutStandingIO bumps from 1 to 2, clear the StopEvent
    //

    if(result == 0) {
        SetEvent(Adapter->USBEPStopEvent);
    }

    USBDBGSTR(DebugPrint,(_T("EPIOCount=%d\n"), result));

	//KeReleaseSpinLock(&Adapter->EPIOCountLock, OldIrql);
	//ZDDbg((_T("---------->>> Release SpinLock\n")));
	ZD1211_ReleaseSpinLock(Adapter, &Adapter->EPIOCountLock, OldIrql);

    return result;
}

//-----------------------------------------------------------------------------
// Procedure:   ClaimAdapter
//
// Description: Download UMAC firmware, setup endpoint 
//				setup IRP, URB, Context and start Int endpoint
//				Int endpoint will be cancel in ZD1205Halt
//
// Arguments:
//    Adapter - ptr to Adapter object instance.
//
// Returns:
//    NDIS_STATUS_SUCCESS - If an adapter is successfully found and claimed
//    NDIS_STATUS_FAILURE- If an adapter is not found/claimed
//-----------------------------------------------------------------------------

NDIS_STATUS
ClaimAdapter(
             IN OUT PZD1205_ADAPTER Adapter
             )

{
    NDIS_STATUS         Status = NDIS_STATUS_SUCCESS;
	ZD1211_IRQL			OldIrql;
    USB_DEVICE_REQUEST  request;
	USB_TRANSFER        retHandle;

	// Setup Debug flag	
	ULONG				DebugPrint;
	DEBUGFUNC(_T("ClaimAdapter"));

	INITSTR((_T("\n")));
	Adapter->USBDbgFlag = 0;
	DebugPrint = Adapter->USBDbgFlag & DBGMSG_INIT;

///////////////////////////////////////////////////////////////////////////

	USBDBGSTR(DebugPrint,(_T("Init USB basic resource\n")));
    
	//NdisInitializeWorkItem(&Adapter->WorkItemReset, USB_MPResetWorkItem, Adapter);
	//NdisInitializeWorkItem(&Adapter->WorkItemOIDQuery, USB_MPOIDQueryWorkItem, Adapter);
	//NdisInitializeWorkItem(&Adapter->WorkItemOIDSet, USB_MPOIDSetWorkItem, Adapter);
	//NdisInitializeWorkItem(&Adapter->WorkItemHandleNonRxTx, USB_MPHandleNonRxTxWorkItem, Adapter);
	//NdisInitializeWorkItem(&Adapter->WorkItemAccessRegister, USB_MPAccessRegisterWorkItem, Adapter);
    

	NdisAllocateSpinLock(&Adapter->EPIOCountLock);
	//Adapter->EPIOCountLock = CreateEvent(NULL, FALSE, TRUE,NULL);
	Adapter->USBEPStopEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
    //Adapter->USBIntEPStopEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
    //Adapter->USBRxEPStopEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
    //Adapter->USBTxEPStopEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
    Adapter->OIDNotifyEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
	Adapter->EPINT_IORDRsp_Event = CreateEvent(NULL, FALSE, FALSE, NULL);
    Adapter->RegSpinlockEvent = CreateEvent(NULL, FALSE, TRUE, NULL);
    Adapter->PSSpinlockEvent = CreateEvent(NULL, FALSE, TRUE, NULL);
	Adapter->StartRxEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	//Adapter->ProcessRxEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	Adapter->StartTxEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	//Adapter->StartIntEvent = CreateEvent(NULL, FALSE, TRUE, NULL);
	Adapter->WaitIntEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	//Adapter->TransferLockEvent = CreateEvent(NULL, FALSE, TRUE, NULL);
	Adapter->WaitTxEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	Adapter->WaitRxEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	USBDBGSTR(DebugPrint,(_T("End init USB basic resource\n")));
///////////////////////////////////////////////////////////////////////////
           
    // Before we start get Descriptor from device,
    // we must download USB code to device first.
    if (!Download_IncludeFile(Adapter))
    {
        //ZD1205LogError(Adapter, USB_EVENT_22, NDIS_ERROR_CODE_OUT_OF_RESOURCES, 0);

		goto ClaimAdapter_Error;
	}

    if (!USB_GetDeviceInfo(Adapter))
	{
		goto ClaimAdapter_Error;
	}

    // set configuration to initialize firmware
	request.bmRequestType = USB_REQUEST_FOR_DEVICE;
	request.bRequest = USB_REQUEST_SET_CONFIGURATION;
	request.wValue = 1;
	request.wIndex = 0;
	request.wLength = 0;

	retHandle = (Adapter->USBInfo.lpUsbFuncs->lpIssueVendorTransfer)( 
			                 Adapter->USBInfo.hDevice,
							 NULL,
							 0,
							 USB_OUT_TRANSFER,
							 &request,
							 0,
							 0
							 );
	if ( retHandle == NULL )
	{
		INITSTR((_T("SET_CONFIGURATION failed!!\n")));
        (Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(retHandle);
		goto ClaimAdapter_Error;
	}

	ZDDbg((_T("Get SpinLock\n")));
	//ZD1211_AcquireSpinLock(Adapter, &Adapter->Lock, &OldIrql);
	//Status = USB_StartIntEP(Adapter);
	//ZDDbg((_T("---------->>> Release SpinLock\n")));
	//ZD1211_ReleaseSpinLock(Adapter, &Adapter->Lock, OldIrql);

	if (Status != NDIS_STATUS_SUCCESS)
	{
		//USBWARNSTR((_T("IoAllocateIrp for Adapter->pIntIrp error!\n")));
		INITSTR((_T("USB_StartIntEP failed!!\n")));

		goto ClaimAdapter_Error;
	}

    return NDIS_STATUS_SUCCESS;

ClaimAdapter_Error:
    
	return NDIS_STATUS_FAILURE;

}

BOOLEAN GetUSBSpecData(PZD1205_ADAPTER Adapter, PUCHAR pBuffer,
                       ULONG uImgLength, USHORT uCodeOfst)
{
    USB_DEVICE_REQUEST   request;
	USB_TRANSFER   retHandle;
    ULONG       uCurLength;

    
	DEBUGFUNC(_T("GetUSBSpecData"));
	INITSTR((_T("\n")));

    while (uImgLength > 0)
    {
        uCurLength = uImgLength;
        if (uCurLength > 60)
            uCurLength = 60;

		request.bmRequestType = USB_REQUEST_DEVICE_TO_HOST | USB_REQUEST_VENDOR;
		request.bRequest = FIRMWARE_READ_DATA;
		request.wValue = uCodeOfst;
		request.wIndex = 0;
		request.wLength = (USHORT) uCurLength;

		retHandle = (Adapter->USBInfo.lpUsbFuncs->lpIssueVendorTransfer)( 
			                     Adapter->USBInfo.hDevice,
							     NULL,
								 0,
								 USB_IN_TRANSFER | USB_SHORT_TRANSFER_OK,
								 &request,
								 pBuffer,
								 0
								 );
		if ( retHandle == NULL )
		{
		    INITSTR((_T("FIRMWARE_READ_DATA failed!!\n")));
            (Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(retHandle);
			return FALSE;
		}

        uImgLength -= uCurLength;
        pBuffer += uCurLength;
        uCodeOfst += (USHORT) (uCurLength / 2); // in Word (16 bit)
	}

    return TRUE;
}

BOOLEAN LoadUSBSpecCode(PZD1205_ADAPTER Adapter, PUCHAR pBuffer,
                        ULONG uImgLength, USHORT uCodeOfst, BOOLEAN bReboot)
{
    USB_DEVICE_REQUEST   request;
	USB_TRANSFER   retHandle;
	ULONG       uCurLength;
	UCHAR       ret;
	//BOOL        bRet;


    DEBUGFUNC(_T("LoadUSBSpecCode"));
	INITSTR((_T("\n")));

    INITSTR((_T("FIRMWARE_DOWNLOAD size = %d\n"), uImgLength));

    while (uImgLength > 0)
    {
        uCurLength = uImgLength;
        if (uCurLength > 0x1000)
            uCurLength = 0x1000;

		request.bmRequestType = USB_REQUEST_VENDOR;
		request.bRequest = FIRMWARE_DOWNLOAD;
		request.wValue = uCodeOfst;
		request.wIndex = 0;
		request.wLength = (USHORT) uCurLength;

		retHandle = (Adapter->USBInfo.lpUsbFuncs->lpIssueVendorTransfer)( 
			                     Adapter->USBInfo.hDevice,
							     NULL,
								 0,
								 USB_OUT_TRANSFER,
								 &request,
								 pBuffer,
								 0
								 );
		if ( retHandle == NULL )
		{
		    INITSTR((_T("FIRMWARE_DOWNLOAD failed!!\n")));
            (Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(retHandle);
			break;
		}
#if 0
		else
		{
		    bRet = (Adapter->USBInfo.lpUsbFuncs->lpIsTransferComplete)(retHandle);
            if ( !bRet )
			{
				INITSTR((_T("FIRMWARE_DOWNLOAD not completed yet!!\n")));
			}
			else
			{
                INITSTR((_T("FIRMWARE_DOWNLOAD completed!!\n")));
			}
		}
#endif
		(Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(retHandle);
        uImgLength -= uCurLength;
        pBuffer += uCurLength;
        uCodeOfst += (USHORT) (uCurLength / 2); // in Word (16 bit)
	}

    if ( bReboot )
	{
		request.bmRequestType = USB_REQUEST_DEVICE_TO_HOST | USB_REQUEST_VENDOR;
		request.bRequest = FIRMWARE_CONFIRM;
		request.wValue = 0;
		request.wIndex = 0;
		request.wLength = sizeof(ret);
	    
		retHandle = (Adapter->USBInfo.lpUsbFuncs->lpIssueVendorTransfer)( 
			                     Adapter->USBInfo.hDevice,
							     NULL,
								 0,
								 USB_IN_TRANSFER | USB_SHORT_TRANSFER_OK,
								 &request,
								 &ret,
								 0
								 );
        (Adapter->USBInfo.lpUsbFuncs->lpCloseTransfer)(retHandle);			
	}

    if (bReboot)
    {
        if ( retHandle != NULL )
        {
            if (ret & 0x80)
            {
                //USBWARNSTR(("Download USB code error 3!\n"));
				INITSTR((_T("Download USB code error 3!\n")));
                return FALSE;
            }
            else
            {
                //USBWARNSTR(("Download USB code success!\n"));
				INITSTR((_T("Download USB code success!\n")));
                return TRUE;
            }
        }
        else
        {
            //USBWARNSTR(("Download USB code error 2!\n"));
			INITSTR((_T("Download USB code error 2!\n")));
            return FALSE;
        }
    }

    return TRUE;
}


BOOLEAN
Download_IncludeFile(PZD1205_ADAPTER Adapter)
{
	BOOLEAN     ret;
	USHORT      EEPVer;

    // Setup Debug flag 
    ULONG               DebugPrint = Adapter->USBDbgFlag & DBGMSG_INIT;

    DEBUGFUNC(_T("Download_IncludeFile"));
	INITSTR((_T("\n")));
    USBDBGSTR(DebugPrint,(_T(" - start\n")));
    
    DebugPrint = 1;

//JWEI 2004/02/19
#if fLOAD_BOOTCODE
    EEPVer = WS11Ub[cEPDATA_OFFSET * 2] + (WS11Ub[cEPDATA_OFFSET * 2 + 1] << 8);
    //JWeiDbgPrint4((" --> EEP Ver:0x%04X / 0x%04X\n", Adapter->pDeviceDesc->bcdDevice, EEPVer));
    INITSTRTX(DebugPrint, (_T("EEPVer = %x\n"), EEPVer));
	INITSTRTX(DebugPrint, (_T("bcdDevice = %x\n"), Adapter->USBInfo.lpDeviceInfo->Descriptor.bcdDevice));
    if (Adapter->USBInfo.lpDeviceInfo->Descriptor.bcdDevice != EEPVer)
    {
    #ifdef fNEW_CODE_MAP
        if (Adapter->USBInfo.lpDeviceInfo->Descriptor.bcdDevice <= 0x4312)
            ret = LoadUSBSpecCode(Adapter, WS11Ur2, sizeof(WS11Ur2),
                                  cFIRMWARE_OLD_ADDR, FALSE);
    #endif

        ret = LoadUSBSpecCode(Adapter, WS11Ur, sizeof(WS11Ur),
                              cFIRMWARE_START_ADDR, TRUE);
        if (ret == FALSE)
        {
            //JWeiDbgPrint4(("Load WS11Ur fail\n"));
			INITSTR((_T("Load WS11Ur fail\n")));
            return FALSE;
        }

        ret = LoadUSBSpecCode(Adapter, WS11Ub + (cEPDATA_OFFSET * 2) + (E2P_END - E2P_SUBID),
                              sizeof(WS11Ub) - (cEPDATA_OFFSET * 2) - (E2P_END - E2P_SUBID),
                              cFIRMWARE_EEPROM_OFFSET + (E2P_END - E2P_SUBID) / 2,
                              TRUE);

        if (ret == FALSE)
        {
            //JWeiDbgPrint4(("Load WS11Ub fail\n"));
			INITSTR((_T("Load WS11Ub fail\n")));
            return FALSE;
        }

        if (Adapter->USBInfo.lpDeviceInfo->Descriptor.bcdDevice == 0x0101)
            ret = GetUSBSpecData(Adapter, WS11Ub + (cEPDATA_OFFSET * 2),
                                 (E2P_END - E2P_SUBID),
                                 cBOOTCODE_START_ADDR);
        else
            ret = GetUSBSpecData(Adapter, WS11Ub + (cEPDATA_OFFSET * 2),
                                 (E2P_END - E2P_SUBID),
                                 cFIRMWARE_EEPROM_OFFSET);

        if (ret == FALSE)
        {
            //JWeiDbgPrint4(("Read EEPROM Data fail\n"));
			INITSTR((_T("Read EEPROM Data fail\n")));
            return FALSE;
        }

        WS11Ub[(cEPDATA_OFFSET * 2) + (E2P_DEVICE_VER - E2P_SUBID)]
            = EEPVer & 0xFF;
        WS11Ub[(cEPDATA_OFFSET * 2) + (E2P_DEVICE_VER - E2P_SUBID) + 1]
            = EEPVer >> 8;
        ret = LoadUSBSpecCode(Adapter, WS11Ub,
                              (E2P_END - E2P_SUBID) + (cEPDATA_OFFSET * 2),
                              cBOOTCODE_START_ADDR,
                              FALSE);

        if (ret == FALSE)
        {
            //JWeiDbgPrint4(("Write EEPROM Data fail\n"));
			INITSTR((_T("Write EEPROM Data fail\n")));
            return FALSE;
        }
    }
#endif

    ret = LoadUSBSpecCode(Adapter, WS11UPh, sizeof(WS11UPh),
                          cFIRMWARE_START_ADDR, TRUE);
    if (ret == FALSE)
    {
        //JWeiDbgPrint4(("Load WS11UPh fail\n"));
		INITSTR((_T("Load WS11UPh fail\n")));
        return FALSE;
    }

    return TRUE;
}

BOOL
USB_GetDeviceInfo(PZD1205_ADAPTER Adapter)
{
    LPCUSB_DEVICE   lpDeviceInfo = NULL;
    LPCUSB_INTERFACE   lpIF;
    UCHAR   i, j, EPNum =0;    
    USB_PIPE   pipe[5];
	LPCUSB_FUNCS   lpUsbFuncs = Adapter->USBInfo.lpUsbFuncs;
	USB_HANDLE   hDevice = Adapter->USBInfo.hDevice;


    DEBUGFUNC(_T("USB_GetDeviceInfo"));

    for(i=0; i<5; i++)
        pipe[i] = NULL;

    //Show the device message
    if (!lpDeviceInfo)
    {
	    lpDeviceInfo = Adapter->USBInfo.lpUsbFuncs->lpGetDeviceInfo(hDevice);
    }

	INITSTR((_T("ZD1211U: Vender id = %x\n"), lpDeviceInfo->Descriptor.idVendor));
	INITSTR((_T("ZD1211U: Product id = %x\n"), lpDeviceInfo->Descriptor.idProduct));

    if (lpDeviceInfo->lpActiveConfig->dwNumInterfaces == 0 )
    	return FALSE;

  
    for (i =0; i <lpDeviceInfo->lpActiveConfig->dwNumInterfaces; i++)
    {
	    INITSTR((_T("ZD1211U: Interface[%d] has %d endpoints!!\n"), i, lpDeviceInfo->lpActiveConfig->lpInterfaces[i].Descriptor.bNumEndpoints));
    	lpIF = &lpDeviceInfo->lpActiveConfig->lpInterfaces[i];
    	for (j =0; j <lpDeviceInfo->lpActiveConfig->lpInterfaces[i].Descriptor.bNumEndpoints; j++)
    	{
	    	
	        if ((lpIF->lpEndpoints[j].Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK)
        	        ==USB_ENDPOINT_TYPE_INTERRUPT) 
        	{
    	  		if (pipe[EPNum]==NULL)         
            	{
        	        pipe[EPNum] = (*lpUsbFuncs->lpOpenPipe)(hDevice, &lpIF->lpEndpoints[j].Descriptor);
					EPNum++;
					INITSTR((_T("EP(%d), Interrupt Pipe initial ok!!\n"), j));
					DbgPrint("EP(%d), Interrupt Pipe initial ok!!\r\n", j);
                	continue;
            	}
	        }
            
    		if (USB_ENDPOINT_DIRECTION_IN(lpIF->lpEndpoints[j].Descriptor.bEndpointAddress))
    		{
    			if (pipe[EPNum]==NULL && 
	                    	(lpIF->lpEndpoints[j].Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK)
        	            	==USB_ENDPOINT_TYPE_BULK) 
                {                		
           	        pipe[EPNum] = (*lpUsbFuncs->lpOpenPipe)(hDevice,&lpIF->lpEndpoints[j].Descriptor);
                    EPNum++;
					Adapter->USBInfo.MaxPacketSize = lpIF->lpEndpoints[j].Descriptor.wMaxPacketSize;
					INITSTR((_T("EP(%d), Input Pipe initial ok!!\n"), j));
                    INITSTR((_T("MaxPacketSize = %d\n"), Adapter->USBInfo.MaxPacketSize));
                    DbgPrint("EP(%d), Input Pipe initial ok!!\r\n", j);
	                continue;
                }
    		}		
    
	        if (USB_ENDPOINT_DIRECTION_OUT(lpIF->lpEndpoints[j].Descriptor.bEndpointAddress))
	        {
        		if (pipe[EPNum]==NULL &&
	                    	(lpIF->lpEndpoints[j].Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK)
        	            	==USB_ENDPOINT_TYPE_BULK) 
            	{
        	        pipe[EPNum] = (*lpUsbFuncs->lpOpenPipe)(hDevice,&lpIF->lpEndpoints[j].Descriptor);
                	EPNum++;
					INITSTR((_T("EP(%d), Output Pipe initial ok!!\n"), j));
                    DbgPrint("EP(%d), Output Pipe initial ok!!\r\n", j);
                	continue;
            	}
        	}
    	}
    }
    
	if ( EPNum < 4 )
	 	return FALSE;

    Adapter->USBInfo.lpDeviceInfo = lpDeviceInfo;

	for(i=0; i<EPNum; i++)
	    Adapter->USBInfo.hPipe[i] = pipe[i];

    Adapter->bUSBDeveiceAttached = TRUE;

	return TRUE;
 
}
