/****************************************************************************
** COPYRIGHT (C) 2003-2004 ZYDAS CORPORATION                               **
** HTTP://WWW.ZYDAS.COM.TW/                                                **
****************************************************************************/

/****************************************************************************
Module Name:
    zd1205pr.h

This driver runs on the following hardware:
	ZD1211

Environment:
    Windows CE

Revision History

*****************************************************************************/


#ifndef _ZD1205PR_H
#define _ZD1205PR_H

//JWEI 2003/12/23
//#define fANT_DIVERSITY          (0 && defined(HOST_IF_USB))
//#define fTX_PWR_CTRL            (1 && defined(HOST_IF_USB))
#ifdef HOST_IF_USB
#define fANT_DIVERSITY          0 // 1
#define DBG_ANTDIV				0
#define fTX_PWR_CTRL            0
#define fZD1211_LOOPBACK        1
#define fDUMP_LOOPBACK_DATA     (0 && fZD1211_LOOPBACK)
#define fLOAD_BOOTCODE          1
#define fPROG_FLASH             (1 && fWRITE_WORD_REG)
#define fPROG_FLASH_BY_FW       (1 && fPROG_FLASH)
#define fMERGE_RX_FRAME         (ENHANCE_RX && fDRV_WRITE_RF_REG && fWRITE_WORD_REG)
#define fCHK_PING               0
#define fVERIFY_FLASH           (0 && fREAD_MUL_REG)
#define fQuickPhySet			(fREAD_MUL_REG && fWRITE_WORD_REG)
#endif

#if DBG || 0
#define JWeiDbgPrint(S)         DbgPrint S
#else
#define JWeiDbgPrint(S)
#endif
//#define JWeiDbgPrint(S)
#if fANT_DIVERSITY
#define JWeiDbgPrint2(S)        JWeiDbgPrint(S)
#else
#define JWeiDbgPrint2(S)
#endif
#if fTX_PWR_CTRL && 0
//#define JWeiDbgPrint3(S)        JWeiDbgPrint(S)
#define JWeiDbgPrint3(cnt, S)               \
{                                           \
    JWeiDbgPrint(S);                        \
    if (cnt)                                \
    {                                       \
        if (Adapter->JWeiDbgCnt3 ++ >= 4)   \
        {                                   \
            Adapter->JWeiDbgCnt3 = 0;       \
            JWeiDbgPrint(("\n"));           \
        }                                   \
    }                                       \
}
#else
#define JWeiDbgPrint3(cnt, S)
#endif
//JWEI 2004/02/19
#if fLOAD_BOOTCODE && 1
#define JWeiDbgPrint4(S)        JWeiDbgPrint(S)
#else
#define JWeiDbgPrint4(S)
#endif

#if 1
#define JWeiDbgPrint5(S)        JWeiDbgPrint(S)
#else                                       //JWEI 2004/03/14
#define JWeiDbgPrint5(S)
#endif
#if 0
#define JWeiDbgPrint6(S)            \
{                                   \
    if (Adapter->JWeiDbgCnt3)       \
        JWeiDbgPrint(S);            \
}
#else
#define JWeiDbgPrint6(S)
#endif
#if 0
// Show LED information
#define JWeiDbgPrint7(S)        JWeiDbgPrint(S)
#else                                       //JWEI 2004/03/14
#define JWeiDbgPrint7(S)
#endif

//
// We define the external interfaces to the ZD1205 driver.
// These routines are only external to permit separate
// compilation.  Given a truely fast compiler they could
// all reside in a single file and be static.
//


// =============================================
// Routines in ZD1205.c
// =============================================
USHORT
ZDLog10multiply100(int data);

BOOLEAN
Authenticate_OpenSystem(PZD1205_ADAPTER Adapter);

BOOLEAN
Authenticate_SharedKey(PZD1205_ADAPTER Adapter);


VOID
SoftwareReset(
              IN PZD1205_ADAPTER Adapter
              );

NTSTATUS
DriverEntry(
            IN PDRIVER_OBJECT DriverObject,
            IN PUNICODE_STRING RegistryPath
            );

BOOLEAN
ZD1205CheckForHang(
                 IN NDIS_HANDLE MiniportAdapterContext
                 );

VOID
ZD1205Halt(
         IN  NDIS_HANDLE MiniportAdapterContext
         );

VOID
ZD1205ShutdownHandler(
                    IN  NDIS_HANDLE MiniportAdapterContext
                    );

NDIS_STATUS
ZD1205Initialize(
               OUT PNDIS_STATUS OpenErrorStatus,
               OUT PUINT SelectedMediumIndex,
               IN PNDIS_MEDIUM MediumArray,
               IN UINT MediumArraySize,
               IN NDIS_HANDLE MiniportAdapterHandle,
               IN NDIS_HANDLE WrapperConfigurationContext
               );

NDIS_STATUS
ZD1205Reset(
          OUT PBOOLEAN AddressingReset,
          IN  NDIS_HANDLE MiniportAdapterContext
          );

VOID
ZD1205GetReturnedPackets(
                       IN NDIS_HANDLE  MiniportAdapterContext,
                       IN PNDIS_PACKET Packet
                       );

VOID
InitAndChainRfd(
                   IN OUT PZD1205_ADAPTER Adapter,
                   IN OUT PZD1205SwRfd SwRfdPtr
                   );

VOID
ZD1205AllocateComplete(NDIS_HANDLE MiniportAdapterContext,
                     IN PVOID VirtualAddress,
                     IN PNDIS_PHYSICAL_ADDRESS PhysicalAddress,
                     IN ULONG Length,
                     IN PVOID Context);


VOID
ZD1205ResetComplete(PVOID sysspiff1,
                  NDIS_HANDLE MiniportAdapterContext,
                  PVOID sysspiff2, PVOID sysspiff3);


PZD1205SwRfd
BuildSwRfd(PZD1205_ADAPTER Adapter,
           ReceiveMemoryDescriptor *newmem,
           UINT startpoint);

VOID
FreeSwRfd(ZD1205_ADAPTER *adapter,
          ZD1205SwRfd *rfd);

VOID
FreeRMD(ZD1205_ADAPTER *adapter,
        ReceiveMemoryDescriptor *rmd);

VOID
Set_RF_Channel(
					IN PZD1205_ADAPTER Adapter, 
					IN ULONG ChannelNo,
					IN UCHAR RF_Mode,
					IN UCHAR InitChOnly
			  );

VOID
PHY_Reg_Preset(
			   IN PZD1205_ADAPTER Adapter
			   );


VOID
GetDefaultConnection(
                     IN PZD1205_ADAPTER Adapter,
                     IN NDIS_HANDLE ConfigHandle
                     );

VOID
SaveDefaultConnection(
                     IN PZD1205_ADAPTER Adapter
                     );

VOID
DefaultConnSetup(
                 IN PZD1205_ADAPTER Adapter
                 );

UINT
HexStrToBin( UCHAR* pInStr,
			 UCHAR* pOutBinData,		// Need (1 * ConvLen) bytes space to use(NULL Terminate is not needed).
			 UINT	ConvLen
			 );			// How many couple of hexdecimal string to be convert


// =============================================
// Routines in interrup.c
// =============================================

VOID
ZD1205Isr(
        OUT PBOOLEAN InterruptRecognized,
        OUT PBOOLEAN QueueMiniportHandleInterrupt,
        IN NDIS_HANDLE MiniportAdapterContext
        );

VOID
ZD1205HandleInterrupt(
                    IN NDIS_HANDLE MiniportAdapterContext
                    );

BOOLEAN
StartReceiveUnit(
                 IN PZD1205_ADAPTER Adapter
                 );

BOOLEAN
ProcessRXInterrupt(
                   IN PZD1205_ADAPTER Adapter,
                    PZD1205SwRfd        *RxSwRfdArray,
                    int                 RxSwRfdTotal,
                    ZD1211_IRQL         *pOldIrql
                  );

// =============================================
// Routines in request.c
// =============================================

NDIS_STATUS
ZD1205ChangeMCAddresses(
                      IN PZD1205_ADAPTER Adapter,
                      IN UINT AddressCount
                      );


NDIS_STATUS
ZD1205SetInformation(
                   IN NDIS_HANDLE MiniportAdapterContext,
                   IN NDIS_OID Oid,
                   IN PVOID InformationBuffer,
                   IN ULONG InformationBufferLength,
                   OUT PULONG BytesRead,
                   OUT PULONG BytesNeeded
                   );

NDIS_STATUS
ZD1205QueryInformation(
                     IN NDIS_HANDLE MiniportAdapterContext,
                     IN NDIS_OID Oid,
                     IN PVOID InformationBuffer,
                     IN ULONG InformationBufferLength,
                     OUT PULONG BytesWritten,
                     OUT PULONG BytesNeeded
                     );

// =============================================
// Routines in routines.c
// =============================================

VOID
MdiWrite(
         IN PZD1205_ADAPTER Adapter,
         IN ULONG RegAddress,
         IN ULONG PhyAddress,
         IN USHORT DataValue
         );

VOID
MdiRead(
        IN PZD1205_ADAPTER Adapter,
        IN ULONG RegAddress,
        IN ULONG PhyAddress,
        IN OUT PUSHORT DataValue
        );

VOID
DumpStatsCounters(
                  IN PZD1205_ADAPTER Adapter
                  );

VOID
DoBogusMulticast(
                 IN PZD1205_ADAPTER Adapter
                 );

VOID
ZD1205IssueSelectiveReset(
                        IN PZD1205_ADAPTER Adapter
                        );

BOOLEAN
ZD1205SubmitCommandBlockAndWait(
                              IN PZD1205_ADAPTER Adapter
                              );

NDIS_MEDIA_STATE
GetConnectionStatus(
                    IN PZD1205_ADAPTER Adapter
                    );

// =============================================
// routines in send.c
// =============================================
VOID
ZD1205MultipleSend(
                 IN  NDIS_HANDLE             MiniportAdapterContext,
                 IN  PPNDIS_PACKET           PacketArray,
                 IN  UINT                    NumberOfPackets
                 );

VOID
ZD1205CopyFromPacketToBuffer(
                           IN PZD1205_ADAPTER Adapter,
                           IN PNDIS_PACKET Packet,
                           IN UINT BytesToCopy,
                           IN PCHAR DestBuffer,
                           IN PNDIS_BUFFER FirstBuffer,
                           OUT PUINT BytesCopied
                           );

BOOLEAN
ProcessTXInterrupt(
                   IN OUT PZD1205_ADAPTER Adapter,
                   ZD1211_IRQL			*pOldIrql
                   );

NDIS_STATUS
SetupNextSend(PZD1205_ADAPTER Adapter,
              PNDIS_PACKET Packet,
			  UCHAR	FrameType,
			  UCHAR EnCipher,
			  UCHAR	Provider,
			  PVOID ReturnPara
			  );


BOOLEAN
AcquireCoalesceBuffer(PZD1205_ADAPTER Adapter,
                      PCOALESCE *pCoalesce);


BOOLEAN
TransmitCleanup(PZD1205_ADAPTER Adapter,
				PZD1205SwTcb SwTcb);

void 
GetEthernetHeaderFromPacket(
		PZD1205_ADAPTER Adapter, 
		PNDIS_PACKET Packet,
		PNDIS_BUFFER FirstBuf,
		PETH_HEADER_STRUC pEnetHdr
		);

ULONG
CalNumOfFrag(PZD1205_ADAPTER Adapter, 
			 ULONG length
			 );


// =============================================
// routines in pci.c
// =============================================

USHORT
FindPciDevice50Scan(
                    IN PZD1205_ADAPTER Adapter,
                    IN USHORT     VendorID,
                    IN USHORT     DeviceID,
                    OUT PPCI_CARDS_FOUND_STRUC PciCardsFound
                    );

// =============================================
// routines in parse.c
// =============================================

NDIS_STATUS
ParseRegistryParameters(
                        IN PZD1205_ADAPTER Adapter,
                        IN NDIS_HANDLE ConfigHandle
                        );


// =============================================
// routines in physet.c
// =============================================

BOOLEAN
PhyDetect(
          IN PZD1205_ADAPTER Adapter
          );

VOID
ResetPhy(
         IN PZD1205_ADAPTER Adapter
         );

VOID
SelectPhy(
          IN PZD1205_ADAPTER Adapter,
          IN UINT SelectPhyAddress,
          IN BOOLEAN WaitAutoNeg
          );

BOOLEAN
SetupPhy(
         IN PZD1205_ADAPTER Adapter
         );

VOID
FindPhySpeedAndDpx(
                   IN PZD1205_ADAPTER Adapter,
                   IN UINT PhyId
                   );

VOID
ResetPhy(
         IN PZD1205_ADAPTER Adapter
         );




// =============================================
// routines in eeprom.c
// =============================================

VOID
ZD1205UpdateChecksum(
                   IN PZD1205_ADAPTER Adapter,
                   IN ULONG CSRBaseIoAddress
                   );

USHORT
ReadEEprom(
           IN PZD1205_ADAPTER Adapter,
           IN USHORT Reg,
           IN ULONG CSRBaseIoAddress
           );


VOID
ShiftOutBits(
             IN PZD1205_ADAPTER Adapter,
             IN USHORT data,
             IN USHORT count,
             IN ULONG CSRBaseIoAddress
             );

VOID
RaiseClock(
           IN PZD1205_ADAPTER Adapter,
           IN OUT USHORT *x,
           IN ULONG CSRBaseIoAddress
           );

VOID
LowerClock(
           IN PZD1205_ADAPTER Adapter,
           IN OUT USHORT *x,
           IN ULONG CSRBaseIoAddress
           );

USHORT
ShiftInBits(
            IN PZD1205_ADAPTER Adapter,
            IN ULONG CSRBaseIoAddress
            );

VOID
EEpromCleanup(
              IN PZD1205_ADAPTER Adapter,
              IN ULONG CSRBaseIoAddress
              );






// =============================================
// routines in init.c
// =============================================

NDIS_STATUS
ClaimAdapter(
             IN OUT PZD1205_ADAPTER Adapter
             );

NDIS_STATUS
SetupAdapterInfo(
                 IN OUT PZD1205_ADAPTER Adapter
                 );

NDIS_STATUS
SetupSharedAdapterMemory(
                         IN PZD1205_ADAPTER Adapter
                         );

NDIS_STATUS
SelfTestHardware(
                 IN PZD1205_ADAPTER Adapter
                 );

VOID
SetupTransmitQueues(
                    IN OUT PZD1205_ADAPTER Adapter,
                    IN BOOLEAN DebugPrint
                    );

VOID
SetupReceiveQueues (
                    IN PZD1205_ADAPTER Adapter
                    );

BOOLEAN
InitializeAdapter(
                  IN PZD1205_ADAPTER Adapter,
				  BOOLEAN	AbnormalPOR
                  );
void
InitializeAccessPoint(PZD1205_ADAPTER Adapter);

void 
IssueNullData(IN PZD1205_ADAPTER Adapter);

BOOLEAN
InitializeZD1205(
               IN PZD1205_ADAPTER Adapter
               );

BOOLEAN
Configure(
          IN PZD1205_ADAPTER Adapter
          );

BOOLEAN
SetupIAAddress(
               IN PZD1205_ADAPTER Adapter
               );

VOID
ClearAllCounters(
                 IN PZD1205_ADAPTER Adapter
                 );

PZD1205_DEFRAG_ENTITY
MatchingAddr2InDefragList(PZD1205_ADAPTER Adapter, 
							PZD1205SwRfd Swrfd,
							PULONG pStatus);


void
PerformAgingFunction(PZD1205_ADAPTER Adapter);

BOOLEAN
ProcessRetryFailInterrupt(PZD1205_ADAPTER Adapter, ZD1211_IRQL *pOldIrql);

VOID
ZD1205CopyFromBufferToPacket(  PZD1205_ADAPTER Adapter,
                           PNDIS_PACKET Packet,
                           UINT BytesToCopy,
                           PUCHAR SrcBuffer,
                           PNDIS_BUFFER FirstBuffer,
                           UINT Offset);

BOOLEAN 
Mgt_SendQueue(
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);

BOOLEAN
Mgt_RetrieveQueue(
			IN PZD1205_ADAPTER Adapter,
			OUT PZD1205_DEFRAG_ENTITY* DefragEntityPtr
			);

VOID
AP_GetReturnedMgtFrame(
						IN PZD1205_ADAPTER Adapter,
						IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
					);

VOID
GetReturnedMgtFrame(
						IN PZD1205_ADAPTER Adapter,
						IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
					);

void
Mgt_QueueInit(IN PZD1205_ADAPTER Adapter);

BOOLEAN
Associate(IN PZD1205_ADAPTER Adapter);

BOOLEAN
Deauthenticate(IN PZD1205_ADAPTER Adapter);

BOOLEAN
ProbeRequest(IN PZD1205_ADAPTER Adapter);

void
IBSS_ConnectNetwork(IN PZD1205_ADAPTER Adapter);

void
UpdateBSSID(IN PZD1205_ADAPTER Adapter,
			PUCHAR	pbssid);

void 
UpdateBeaconInterval(IN PZD1205_ADAPTER Adapter,
			PUCHAR	pbcnintvl);
void 
UpdateBeaconInterval_Send(IN PZD1205_ADAPTER Adapter,
			USHORT	index, BOOLEAN	bIsSoftAP, PUCHAR Beacon);

void 
UpdateBeaconInterval_Stop(IN PZD1205_ADAPTER Adapter);

void 
UpdateBeaconInterval_StartPS(IN PZD1205_ADAPTER Adapter);

void 
UpdateBeaconInterval_StopPS(IN PZD1205_ADAPTER Adapter);

void
UpdateSupportedRates(IN PZD1205_ADAPTER Adapter,
			PUCHAR	prates);

void
UpdateATIMWindow(IN PZD1205_ADAPTER Adapter,
			PUCHAR	patimwnd);

BOOLEAN
Infra_ConnectNetwork(IN PZD1205_ADAPTER Adapter);

void 
IssuePsPoll(IN PZD1205_ADAPTER Adapter);

BOOLEAN
APMgt_SendNotification(
			IN PZD1205_ADAPTER Adapter,
			IN ULONG	NotificationType
			);


BOOLEAN
Mgt_SendNotification(
			IN PZD1205_ADAPTER Adapter,
			IN ULONG	NotificationType
			);

BOOLEAN
Mgt_ClearNotification(
			IN PZD1205_ADAPTER Adapter,
			IN ULONG	NotificationType
			);

BOOLEAN
AnyActivity(			
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);

BOOLEAN
ValidateFrame(PZD1205_ADAPTER Adapter, 
			  PZD1205SwRfd      SwRfd
			  );

void
StartDownload(PZD1205_ADAPTER Adapter, 
			  ULONG		PhyAddr
			  );

void
StartUpload(PZD1205_ADAPTER Adapter, 
			ULONG		PhyAddr
			);

BOOLEAN
ProcessWakeupInterrupt(
                   IN PZD1205_ADAPTER Adapter
                   );

ULONG
ParseRxMgtFrame(			
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);

void
ChannelScan(
			IN PZD1205_ADAPTER Adapter,
			IN UINT ScanAll
			);

void 
AP_Monitoring(
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);
void 
IBSS_Monitoring(
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);
void 
Change_EncryMode(
			IN PZD1205_ADAPTER Adapter,
			IN UCHAR	EncMode,
			IN UCHAR	DecMode
			);

void
AcquireCtrOfPhyReg(
					IN PZD1205_ADAPTER Adapter
				  );

void
ReleaseCtrOfPhyReg(
					IN PZD1205_ADAPTER Adapter
				  );

BOOLEAN
Mgt_SendTestFrame(
					IN PZD1205_ADAPTER Adapter,
					UCHAR		pattern
				 );
void
AccLBRxCnt(			
			IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			);

void
SetKeyContext(
			IN PZD1205_ADAPTER Adapter,
			IN UCHAR	UserId,
			IN UCHAR	EncMode,
			IN UCHAR	KeyID,
			IN PUCHAR	pKeyContent
			);


void
ResetDevice(
			IN PZD1205_ADAPTER Adapter
				);

void
SleepResetDevice(
			IN PZD1205_ADAPTER Adapter
				);

BOOLEAN
ProcessCfgNextBcn(PZD1205_ADAPTER Adapter);

void
Mgt_ScanTest(
				IN PZD1205_ADAPTER Adapter,
				USHORT	ScanLen
			);

void
GetEnetFrameLock(
			IN PZD1205_ADAPTER Adapter
			);
void
ZD1205_Sleep(
			 LONG	TimeInUs
			 );

BOOLEAN
CheckSupportedRates(
			IN PZD1205_ADAPTER Adapter,
			UCHAR	rate
			);
USHORT
ConvertToSetPoint(
			IN PZD1205_ADAPTER Adapter,
			signed char	txpwr
			);
void
AdoptRegulatorySetting(
			IN PZD1205_ADAPTER Adapter,
			USHORT	BssIdx
			);

BOOLEAN
checkRecPort(
              IN PZD1205_ADAPTER Adapter,
			  PZD1205SwRfd       SwRfd
			  );
void
Reset_Tally(
		IN PZD1205_ADAPTER Adapter
		);
void
AcquireDoNotSleep(
			IN PZD1205_ADAPTER Adapter
			);
void
ReleaseDoNotSleep(
			IN PZD1205_ADAPTER Adapter
			);

BOOLEAN
DestPowerSave(
			IN PZD1205_ADAPTER Adapter,
			IN PCHAR pDestAddr
			);

BOOLEAN
ProbeResponse(IN PZD1205_ADAPTER Adapter,
			IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
			  );

BOOLEAN
ProcessATIMWndEndInterrupt(PZD1205_ADAPTER Adapter);

void 
ZD1205_WRITE_REGISTER(
					IN PZD1205_ADAPTER Adapter,
					ULONG   _offset, 
					ULONG	_Value
					);

void
ZD1205_READ_REGISTER(
					IN PZD1205_ADAPTER Adapter,
					ULONG _offset, 
					PULONG _pValue
					);

void
UpdatePreTBTT(IN PZD1205_ADAPTER Adapter,
			ULONG	pretbtt);

VOID 
LinkDetectionDpc(
    IN  PVOID	SystemSpecific1,
    IN  PVOID	FunctionContext,
    IN  PVOID	SystemSpecific2, 
    IN  PVOID	    SystemSpecific3
    );


VOID 
CMPerSecTimer(
    IN  PVOID	SystemSpecific1,
    IN  PVOID	FunctionContext,
    IN  PVOID	SystemSpecific2, 
    IN  PVOID	    SystemSpecific3
    );
    

VOID EapolParser(PZD1205_ADAPTER Adapter,
					PVOID		data,
					ULONG		length);
									    
    
VOID
HW_Set_GCT_Chips(
						IN PZD1205_ADAPTER Adapter, 
						IN ULONG ChannelNo,
						IN UCHAR InitChOnly
					  );

VOID
HW_Set_GRF5103_Chips(
						IN PZD1205_ADAPTER Adapter, 
						IN ULONG ChannelNo,
						IN UCHAR InitChOnly
					  );

VOID
HW_Set_PV2000_Chips(
						IN PZD1205_ADAPTER Adapter, 
						IN ULONG ChannelNo,
						IN UCHAR InitChOnly
					  );

VOID
Set_IF_Synthesizer(
			IN PZD1205_ADAPTER Adapter, 
			IN ULONG InputValue
		);

BOOLEAN
ProcessBusAbortInterrupt(
                   IN PZD1205_ADAPTER Adapter
                   );

VOID
OverWritePhyRegFromE2P(
						IN PZD1205_ADAPTER Adapter
						);
           
VOID
WritePhyReg(
			IN PZD1205_ADAPTER Adapter,
			UCHAR PhyIdx,
			UCHAR PhyValue
			);

VOID 
UpdateIntegrationValue(
			IN PZD1205_ADAPTER Adapter,
			ULONG	ChannelNo
			);

BOOLEAN
NeedReadProtection(
					IN PZD1205_ADAPTER Adapter,
					ULONG _offset, 
					PULONG _pValue
				);
BOOLEAN
NeedWriteProtection(
					IN PZD1205_ADAPTER Adapter,
					ULONG   _offset, 
					ULONG	_Value
				);
void
InitializeProtectedRegs(
					IN PZD1205_ADAPTER Adapter
					);

void
TurnOn_RF(
	  		IN PZD1205_ADAPTER Adapter
		);

void
TurnOff_RF(
	  		IN PZD1205_ADAPTER Adapter
		);

void
Write_TxGain(
			 IN PZD1205_ADAPTER Adapter,
			 ULONG		txgain
		);

//``JWEI 2003/12/23
void Write_TxGain1(IN PZD1205_ADAPTER Adapter, UCHAR txgain, UCHAR TxPwrType);
void Write_TxGain2(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType);
void IncreaseTxPower(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType);
void DecreaseTxPower(IN PZD1205_ADAPTER Adapter, UCHAR TxPwrType);
void SwitchAntenna(PZD1205_ADAPTER Adapter);
void
AP_ProcessEvents(
					IN PZD1205_ADAPTER Adapter
					);

void
AP_UpdateBeacon(IN PZD1205_ADAPTER Adapter);

void
SetBSSType(
		IN PZD1205_ADAPTER Adapter,
		UCHAR	bsstype
		);

void mkTim(Element *tim, TrafficMap_t *trf, UCHAR dtc, UCHAR dtp, USHORT aidLo, 
		   USHORT aidHi, BOOLEAN bc);

void
AP_ProcessAuthen(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		);

VOID
AP_Initialize(
                    IN PZD1205_ADAPTER Adapter,
                    IN BOOLEAN DebugPrint
                    );
VOID 
AP_AgeTimerFunction(
    IN  PVOID	SystemSpecific1,
    IN  PVOID	FunctionContext,
    IN  PVOID	SystemSpecific2, 
    IN  PVOID	    SystemSpecific3
    );

void
AP_CheckERP( IN PZD1205_ADAPTER	Adapter );

void
AP_CompleteAllPendingPktsAndTimers(
                    IN PZD1205_ADAPTER Adapter,
					ZD1211_IRQL           *pOldIrql
					);


PSTA_CONTEXT
FindSTAContext(
		IN PZD1205_ADAPTER Adapter,
		PCHAR	pAddr
		);

void
FREEaSTAContext(
		IN PZD1205_ADAPTER Adapter,
		PSTA_CONTEXT		STAContextPtr
		);

void
ProviderMSendComplete(
		IN PZD1205_ADAPTER Adapter,
		PZD1205SwTcb       pSwTcb,
	    ZD1211_IRQL			   *pOldIrql
		);

void
ProcessQueuedPackets(
                   IN PZD1205_ADAPTER Adapter
					);

void
AP_ForwardMulticastPkt(
			IN PZD1205_ADAPTER Adapter,
			PNDIS_PACKET	Packet,
			PETH_HEADER_STRUC	pEthHdr
			);

BOOLEAN
AP_CheckForward(
			IN PZD1205_ADAPTER Adapter,
			PETH_HEADER_STRUC	pEthHdr
			);

BOOLEAN
AP_ForwardUnicastPkt(
			IN PZD1205_ADAPTER Adapter,
			PNDIS_PACKET	Packet,
			PETH_HEADER_STRUC	pEthHdr
			);

void
AP_DisAssociateAllSTAs(
		IN PZD1205_ADAPTER Adapter
		);

BOOLEAN
AP_ReportSTAsMacList(
		IN PZD1205_ADAPTER Adapter,
		PMAC_LIST_DATA		pMacListData,
		ULONG				BufLen
		);

BOOLEAN
AP_AnySTAInPSMode(
		IN PZD1205_ADAPTER Adapter
		);

void
AP_CheckSTAsAlive(
		IN PZD1205_ADAPTER Adapter
		);

void
AP_DisAssociateOneSTA(
		IN PZD1205_ADAPTER Adapter,
		PSTA_CONTEXT		STAContextPtr,
		USHORT		Reason
		);

void
QueryOppositeRatePreamble(
		IN PZD1205_ADAPTER Adapter,
		PUCHAR			pAddr,
		PUCHAR			pRate,
		PUCHAR			pPreamble,
		PZD1205SwTcb	SwTcb
		);

void
RiseRateJudge(
        IN PZD1205_ADAPTER Adapter,
		PUCHAR	pAddr
		);

void
AP_SendDisAssociation(
		IN PZD1205_ADAPTER	Adapter,
		PUCHAR		pAddr1,
		USHORT		Reason
		);

void
AP_SnedNullDataCheckTxComplete(
		IN PZD1205_ADAPTER	Adapter,
		PSTA_CONTEXT		STAContextPtr
		);

#ifdef NDIS51_MINIPORT
VOID ZD1205PnPEventNotify(
    IN  NDIS_HANDLE             MiniportAdapterContext,
    IN  NDIS_DEVICE_PNP_EVENT   PnPEvent,
    IN  PVOID                   InformationBuffer,
    IN  ULONG                   InformationBufferLength
    );

VOID ZD1205CancelSendPackets(
    IN  NDIS_HANDLE     MiniportAdapterContext,
    IN  PVOID           CancelId);

VOID ZD1205Shutdown(
    IN  NDIS_HANDLE     MiniportAdapterContext);


#endif

VOID
AutoRateTimer(
        IN PVOID SystemSpecific1,
        IN NDIS_HANDLE MiniportAdapterContext,
        IN PVOID SystemSpecific2,
        IN PVOID SystemSpecific3
        );

UCHAR Rate_Adaption(IN PZD1205_ADAPTER Adapter, 
					PUCHAR	pMacAddr, 
					UCHAR   CurrentRate, 
					UCHAR   gear
					);

UCHAR Rate_Convert_to_MS(UCHAR rate_in_drv);

UCHAR Rate_Convert(UCHAR rate, USHORT capability);

BOOLEAN CheckAuthentication(PZD1205_ADAPTER Adapter, UCHAR* pSSID);

UCHAR
CalculateQuality(	PZD1205_ADAPTER Adapter,
					PZD1205SwRfd	SwRfd,
					PUCHAR			pQualityIndB
					);

UCHAR
CalculateStrength(	PZD1205_ADAPTER Adapter,
					PZD1205SwRfd	SwRfd
					);

NDIS_STATUS
ZD1211Old_SetInformation(
                   IN NDIS_HANDLE MiniportAdapterContext,
                   IN NDIS_OID Oid,
                   IN PVOID InformationBuffer,
                   IN ULONG InformationBufferLength,
                   OUT PULONG BytesRead,
                   OUT PULONG BytesNeeded
                   );


NDIS_STATUS
ZD1211Old_QueryInformation(
                     IN NDIS_HANDLE MiniportAdapterContext,
                     IN NDIS_OID Oid,
                     IN PVOID InformationBuffer,
                     IN ULONG InformationBufferLength,
                     OUT PULONG BytesWritten,
                     OUT PULONG BytesNeeded
                     );

NDIS_STATUS
ZD1211_Custom_SetInformation(
                   IN NDIS_HANDLE MiniportAdapterContext,
                   IN NDIS_OID Oid,
                   IN PVOID InformationBuffer,
                   IN ULONG InformationBufferLength,
                   OUT PULONG BytesRead,
                   OUT PULONG BytesNeeded
                   );

NDIS_STATUS
ZD1211_Custom_QueryInformation(
                     IN NDIS_HANDLE MiniportAdapterContext,
                     IN NDIS_OID Oid,
                     IN PVOID InformationBuffer,
                     IN ULONG InformationBufferLength,
                     OUT PULONG BytesWritten,
                     OUT PULONG BytesNeeded
                     );

void
Set_FilterBand(
			IN PZD1205_ADAPTER Adapter,
			ULONG	region_code
			);

void
SortRateArray( UCHAR *RateArray, 
			   int ArrayLen
			   );

void
ClearOppositeRateInfo(PZD1205_ADAPTER Adapter);

BOOLEAN
BuildOppositeRateInfo(	PZD1205_ADAPTER Adapter,
						PUCHAR			OppositeSA,
						PUCHAR			SupportRate,
						USHORT			Capability,
						BOOLEAN			bUpdateExtSupportRate
						);


#ifdef HOST_IF_USB
// =============================================
// Routines for USB interface
// =============================================

VOID
ZD1205DisableInterrupt(
                     IN PZD1205_ADAPTER Adapter
);

VOID
ZD1205EnableInterrupt(
                    IN PZD1205_ADAPTER Adapter
);



//NTSTATUS
//USB_MPCallUSBD(IN PZD1205_ADAPTER Adapter, IN PURB pUrb);

BOOLEAN
USB_READ_REGISTER(  IN PZD1205_ADAPTER  Adapter,
                    ULONG               Address,
                    PULONG              pValue,
                    BOOLEAN             AddUSBCSRAddress
                    );


BOOLEAN
USB_PACKAGE_READ_REGISTER(  IN PZD1205_ADAPTER  Adapter,
                            USHORT              *Address,
                            USHORT              *pValue,
                            USHORT              RegCount,
                            BOOLEAN             AddUSBCSRAddress
                          );

BOOLEAN
USB_WRITE_REGISTER( IN PZD1205_ADAPTER  Adapter,
                    ULONG               Address,
                    ULONG               Value,
                    BOOLEAN             AddUSBCSRAddress
                    );

                  //JWEI 2004/03/18
BOOLEAN
USB_PACKAGE_WRITE_REGISTER(
                    IN PZD1205_ADAPTER Adapter,
                    USHORT  *_offset,
                    USHORT  *_Value,
                    USHORT  RegCount,
                    BOOLEAN AddUSBCSRAddress
                    );

void WriteEEPROM(IN PZD1205_ADAPTER  Adapter,
                 USHORT rom_adr, USHORT ram_adr, USHORT len0);

//JWEI 2004/02/18
void ZD1211_READ_REGISTER(
                    IN PZD1205_ADAPTER Adapter,
                    ULONG _offset, 
                    PULONG _pValue,
                    BOOLEAN AddUSBCSRAddress
                    );

void ZD1211_ReadMultiRegister(  IN PZD1205_ADAPTER  Adapter,
                                USHORT              *Address,
                                USHORT              *pValue,
                                USHORT              RegCount,
                                BOOLEAN             AddUSBCSRAddress
                             );

void ZD1211_WRITE_REGISTER(
                    IN PZD1205_ADAPTER Adapter,
                    ULONG   _offset, 
                    ULONG   _Value,
                    BOOLEAN AddUSBCSRAddress
                    );


void ZD1211_WriteMultiRegister( IN PZD1205_ADAPTER Adapter,
                                USHORT  *Address,
                                USHORT  *Value,
                                USHORT  RegCount,
                                BOOLEAN AddUSBCSRAddress
                              );


NDIS_STATUS
USB_WaitAllEPStop(IN PZD1205_ADAPTER Adapter);

BOOL
USB_GetDeviceInfo(PZD1205_ADAPTER Adapter);

/*
NTSTATUS
USB_MPRcvFromRxEP(
    IN PZD1205_ADAPTER	Adapter,
	PURB                pUrb,
	PIRP                pIrp,
	PUSB_RX_CONTEXT		pContext
	);



NTSTATUS
USB_MPSenToTxEP(
    IN PZD1205_ADAPTER	Adapter,
	PURB                pUrb,
	PIRP                pIrp,
	PUSB_TX_CONTEXT		pContext
	);


VOID
Set_IF_Synthesizer(
			IN PZD1205_ADAPTER Adapter, 
			IN ULONG InputValue
		);


NDIS_STATUS
USB_QueryInformation(
                     IN NDIS_HANDLE MiniportAdapterContext,
                     IN NDIS_OID Oid,
                     IN PVOID InformationBuffer,
                     IN ULONG InformationBufferLength,
                     OUT PULONG BytesWritten,
                     OUT PULONG BytesNeeded
                     );

NDIS_STATUS
USB_SetInformation(
                   IN NDIS_HANDLE MiniportAdapterContext,
                   IN NDIS_OID Oid,
                   IN PVOID InformationBuffer,
                   IN ULONG InformationBufferLength,
                   OUT PULONG BytesRead,
                   OUT PULONG BytesNeeded
                   );

VOID
USB_MPHandleNonRxTxWorkItem( 
    IN NDIS_WORK_ITEM *pWorkItem,
    IN PVOID Context
        );

VOID
USB_MPAccessRegisterWorkItem(
    IN NDIS_WORK_ITEM *pWorkItem,
    IN PVOID Context
        );
*/

void
USB_SET_RF_REG( IN PZD1205_ADAPTER  Adapter,
                USHORT              *InputValue,
                BOOLEAN             bIs3683A
              );

NDIS_STATUS
USB_StartTxEP(PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_StopTxEP(PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_StartRxEP(PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_StopRxEP(PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_StartIntEP(IN PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_StopIntEP(IN PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_MPRcvFromIntEP(IN PZD1205_ADAPTER Adapter);

DWORD WINAPI
USB_MPRcvFromIntEP_Complete(LPVOID pContext);

NDIS_STATUS
USB_MPRcvFromRxEP(IN PZD1205_ADAPTER Adapter);

DWORD WINAPI
USB_MPRcvFromRxEP_Complete(LPVOID pContext);

NDIS_STATUS
USB_MPSenToTxEP(PZD1205_ADAPTER Adapter, UCHAR HandleNo);

DWORD WINAPI
USB_MPSenToTxEP_Complete(LPVOID pContext);

void
USB_FreeINTEPResource(PZD1205_ADAPTER Adapter);

void
USB_FreeRxEPResource(PZD1205_ADAPTER Adapter);

void
USB_FreeTxEPResource(PZD1205_ADAPTER Adapter);

DWORD WINAPI
USB_MPWriteReg_Complete(LPVOID pContext);

BOOLEAN
USB_ResetTxQueue(PZD1205_ADAPTER Adapter);

NDIS_STATUS
USB_CloseTxTransfer(PZD1205_ADAPTER Adapter);

LONG
USB_CompleteCountIncrement(IN OUT PZD1205_ADAPTER Adapter);

LONG
USB_CompleteCountDecrement(IN OUT PZD1205_ADAPTER Adapter);

ULONG   
ZD1211APMgtThread(IN PZD1205_ADAPTER Adapter);

void
AP_ProcessAuthen(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		);

void
AP_ProcessAssociationReq(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		);
void
AP_ProcessReAssociationReq(
		IN PZD1205_ADAPTER Adapter,
		IN PZD1205_DEFRAG_ENTITY DefragEntityPtr
		);


VOID 
ZD1211_AcquireSpinLock( IN PZD1205_ADAPTER Adapter,
                        IN PZD1211_SPIN_LOCK  SpinLock,
                        OUT PZD1211_IRQL  OldIrql
);

VOID 
ZD1211_ReleaseSpinLock( IN PZD1205_ADAPTER Adapter,
                        IN PZD1211_SPIN_LOCK  SpinLock,
                        IN ZD1211_IRQL  NewIrql
);

VOID
TerminateThreads(PZD1205_ADAPTER Adapter);

ULONG    
ZD1211StartRxThread(IN PZD1205_ADAPTER Adapter);

ULONG    
ZD1211SetQueryOIDThread(IN PZD1205_ADAPTER Adapter);

ULONG
ZD1211StartRxThread(IN PZD1205_ADAPTER Adapter);

ULONG
ZD1211InterruptThread(IN PZD1205_ADAPTER Adapter);

__inline
PrintCurrentTime()	
{							
#if 0						
	LARGE_INTEGER  	PerfFreq;	
							
	ZDDbgPrint((_T(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Time = %d\n"), KeQueryPerformanceCounter(&PerfFreq).LowPart ));		
	ZDDbgPrint((_T(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PerfFreq Low/High = %d\n"), PerfFreq.LowPart, PerfFreq.HighPart));	
#endif						
}                           

__inline PrintElapsedTime(PZD1205_ADAPTER Adapter)
{
LARGE_INTEGER   CurrTime;

    //KeQuerySystemTime(&CurrTime);
    NdisGetCurrentSystemTime(&CurrTime);
    CurrTime.QuadPart -= Adapter->StartTime.QuadPart;
    CurrTime.QuadPart /= 10000L;            // in ms
    ZDDbgPrint((_T(">>>>>>>>>>>> Time = %d ms\n"), CurrTime.LowPart));
}

__inline void ShowTimeStamp(PZD1205_ADAPTER Adapter, PUCHAR PromptStr)
{
ULONG   systemUpTime;
USHORT  timeHMS[3];
USHORT  timeMSec;
USHORT  ii;

    NdisGetSystemUpTime(&systemUpTime);
    //systemUpTime -= Adapter->timeDriverStart;
    JWeiDbgPrint5(("%s at %u ms", PromptStr, systemUpTime));

    timeMSec = (USHORT) (systemUpTime % 1000);
    systemUpTime /= 1000;
    for (ii = 0; ii < 3; ii ++)
    {
        timeHMS[ii] = (USHORT) (systemUpTime % 60);
        systemUpTime /= 60;
    }
    JWeiDbgPrint5((" (%u:%u,%u.%u).\n", timeHMS[2], timeHMS[1], timeHMS[0], timeMSec));
}							

#endif

//WPA support
void ReportAuthEvent(PZD1205_ADAPTER	Adapter,
					ULONG	Flags);

#endif  //_ZD1205PR_H

